{ Ide de Christian Aebi, de raliser le maximum, en combinant
  5 nombres (5 fractions) avec les 4 oprations +, -, *, /

  Calcule par la force brute, toutes les combinaisons
  possibles, pour trouver celle qui donne le plus grand
  rsultat.

  Dans Cette version de programme, on ne peut pas utiliser plusieurs
  fois le mme nombre!
----------------------------------------------------------------}

program tEx076;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses

  wApplication0
 ,wWindowText0 // To write text in an independent window
 ,wWindow0
 ,wDialog0
 ,wGlobals2
 ,wVariableNumLink2
 ,wDialogCreatorLOW2
 ,wDialogCreator2
// ,wUtiles0
 ,wMessages2
 ,wDebug0
 ,Windows;

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  // Some parameters that can be changed in a dialog box.

  constructor Init(strWinTitlePrm:ShortString);
  destructor Done; virtual;

  procedure Test1;
  procedure Test2;
  procedure Test3;
  procedure Test4;

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

const
QUATRE   = 4;
NEUF     = 9;
CINQ     = NEUF - QUATRE;

var
  avNumber         : array[QUATRE+1..NEUF] of Float;
  { Se sont les 5 nombres  combiner }

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);

// This line is all what is needed to have a status line.
new(poStatusLine, Init(@Self));

// Default values
{ Donnes, nombres  combiner }
avNumber[QUATRE+1]:=3/5;
avNumber[QUATRE+2]:=7/6;
avNumber[QUATRE+3]:=7/3;
avNumber[QUATRE+4]:=9/4;
avNumber[QUATRE+5]:=3/8;

FloatField(101, avNumber[QUATRE+1]);
FloatField(102, avNumber[QUATRE+2]);
FloatField(103, avNumber[QUATRE+3]);
FloatField(104, avNumber[QUATRE+4]);
FloatField(105, avNumber[QUATRE+5]);
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//=========================
begin

inherited Done;
end;  // TMyWindow.Done

procedure TMyWindow.Test1;
//========================
// Le compte est max
label SKIPtoEND;

var
  afUsed           : array[QUATRE+1..NEUF+1] of boolean;
  { Indique si le nombre a dj t mis dans le stack }

  avStack          : array[0..CINQ] of Float;
  { Contiendra les rsultats des oprations, qui se font en notation
    polonaise inverse }

  ind              : array[0..NEUF] of integer;
  { contient les oprations et/ou nombres a mettre dans le stack,
    pour raliser toutes les combinaisons possibles }
  { ind[k] =
    1 => +
    2 => -
    3 => *
    4 => /
    5..9 => met un nombre sur le stack }

  kk
  { indice de ind, pour mettre les nombres et/ou oprations sur le stack }
                   : integer;
var
  wRep             : word32;
  nStack,          { nombre d'lment dans le stack }
  nNombre,         { nombre de nombre ayant t mis dans le stack }
                   { il doit rest <= CINQ }
  nn               : integer;
  vMax             : Float;
  strOut           : string;  // rsultat final, qui sera affich.

begin // Test1
// Entre des nombres  combiner
wRep:=DialogExecMSG(11199, @Self);

if (wRep <> IDOK) then exit; // CANCELED the operation

// Initialisation par scurit, inutile en principe
for kk:=1 to CINQ do avStack[kk]:=0;

// par dfaut, rien n'est affich.
strOut:='';

// ind[0] deviendra = 2 quand toutes les combinaisons aurons t testes
ind[0]:=1;

// Les deux premier lments du stack sont des nombres
ind[1]:=QUATRE+1;
ind[2]:=QUATRE+1;

// Les autres lments du stack peuvent tre des nombres ou oprations
for kk:=3 to NEUF do ind[kk]:=1;

// Sentinel, dans le cas ou on dpasse la limite du tableau
afUsed[NEUF+1]:=FALSE;

// combinaison max. trouve
vMax:=0;

WriteWin(1, '---------------------------------------------------------------');
WriteWin(1, 'nombre de dpart : ');
for kk:= 1 to CINQ do strOut:=strOut + FloatToStr(avNumber[QUATRE+kk],13,9) + '  ;';
WriteWin(1, strOut);  strOut:='';
WriteWin(1, '');

// ***** BOUCLE PRINCIPALE *****
// Toutes les combinaisons seront teste ici
repeat
   // Le stack est vide, et aucun nombre utilis
   nStack  :=0;
   nNombre :=0;

   for kk:=QUATRE+1 to NEUF do afUsed[kk]:=FALSE;

   // boucle pour une combinaison
   kk:=0;
   repeat
      inc(kk);

      // Si on ne peut pas mettre d'oprations sur le stack, saute
      // les oprations, pour y mettre un nombre
      if (nStack < 2) then while (ind[kk] <= QUATRE) do inc(ind[kk]);

      // si tous les nombre utilis, et plus que des nombres  mettre
      //  sur le stack, on saute une suite des combinaisons impossibles
      if (ind[kk] >= CINQ) then begin
         while afUsed[ind[kk]] do inc(ind[kk]); // saute les nombres dj utilis

         if (nNombre >= CINQ) or (ind[kk] > NEUF) then begin
            { saute des combinaisons }
            nn:=kk;
            repeat
               ind[nn]:=NEUF;
               inc(nn);
               until (nn > NEUF);

            goto SKIPtoEND;
            end; { if (nNombre >= CINQ) or (ind[kk] > NEUF) then begin }
         end; { if (ind[kk] >= CINQ) then begin }

      { Met l'opration ou le nombre sur le stack }
      if (ind[kk] <= QUATRE) then begin
         { ralise une opration, le niveau du stack diminu }
         dec(nStack);

         case ind[kk] of
           1 : avStack[nStack]:=avStack[nStack] + avStack[nStack+1];
           2 : avStack[nStack]:=avStack[nStack] - avStack[nStack+1];
           3 : avStack[nStack]:=avStack[nStack] * avStack[nStack+1];
           4 : begin
               if (abs(avStack[nStack+1]) < 1e-10) then begin
                  { On saute toutes les combinaisons avec division par 0 }
                  nn:=kk;

                  repeat
                     ind[nn]:=NEUF;
                     inc(nn);
                     until (nn > NEUF);

                  goto SKIPtoEND;
                  end;

               avStack[nStack]:=avStack[nStack] / avStack[nStack+1];
               end;
           end; { case }
         end
      else begin
         { met un nombre sur le stack }
         inc(nStack);
         inc(nNombre);
         avStack[nStack]:=avNumber[ind[kk]];
         afUsed[ind[kk]]:=TRUE;  { ce nombre a t utilis }
         end;

      until (kk >= NEUF);

   { Le rsultat d'une combinaison est sur le stack, test si il
     est plus grand que le plus grand rsultat dj obtenu }
   if (vMax < avStack[1]) then begin
      { Affiche les oprations  faire }
      for kk:=1 to NEUF do begin
         if (ind[kk] <= QUATRE) then begin
            case ind[kk] of
              1 : strOut:=strOut + ' + ';
              2 : strOut:=strOut + ' - ';
              3 : strOut:=strOut + ' * ';
              4 : strOut:=strOut + ' / ';
              end; { case }
            end
         else strOut:=strOut + FloatToStr(avNumber[ind[kk]],8,4);
         end; { for }

      strOut:=strOut + '=' + FloatToStr(avStack[1],8,4);
      
      // affiche le rsultat et rinitialise  "vide" la chaine de sortie.
      WriteWin(1, strOut);  strOut:='';

      vMax:=avStack[1];
      end;

   { label dans le cas ou des combinaisons sont sautes  }
   SKIPtoEND:;

   { passage  la combinaison suivante }
   kk:=NEUF+1;
   repeat
      dec(kk);
      inc(ind[kk]);
      if (ind[kk] > NEUF) then ind[kk]:=1;
      until (ind[kk] > 1);

   { Si ind[0] > 0, toutes les combinaisons ont t testes }
   until (ind[0] > 1);
end;  // TMyWindow.Test1

procedure TMyWindow.Test2;
//========================
begin
end;  // TMyWindow.Test2

procedure TMyWindow.Test3;
//========================
begin
end;  // TMyWindow.Test3

procedure TMyWindow.Test4;
//========================
begin
end;  // TMyWindow.Test4

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// Handles the menu messages
Var wNrMenu     : word;
begin
WMCommand := 0; // Default return value when processing a message

if (lPar <> 0) then begin
   // call the parent WMCommand method.
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;

// for the menus,  lPar = 0
//=========================
wNrMenu   := LoWord(wPar);
Case wNrMenu Of
   101 : Test1;
   102 : Test2;
   103 : Test3;
   104 : Test4;
   
   999 : PostMessage(hWin, WM_CLOSE, 0, 0);

   else WMCommand:=inherited WMCommand(wPar, lPar);
   end;  // Case NrMenu Of
end;  // TMyWindow.WMCommand

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//======================================================================================
begin
// Default treatment of a message. Does nearly nothing
WindowProc := inherited WindowProc(hWindow, wMsg, wPar, lPar);
end;  // TMyWindow.WindowProc

Begin // MAIN ******
// Name under which the main window is registered. Spaces are not allowed
oApp.Init('Example076');

// Creation of the main window
new(poMyMainWin, Init('tEx076_Compte_est_Max.pp'));

oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.

