{ Test some sound aquisition possibilities


  --------------------------------------------}
program tEx078_WaveInOpen;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses
  wApplication0
 ,wWindowText0
 ,wWindow0
 ,wDialog0
 ,wPopupWindow0
 ,wDialogCreatorLOW2
 ,wDialogCreator2
 ,wVariableNumLink2
 ,wWindowBase0
 ,wErrors0
 ,wGlobals2
 ,wDebug0
 ,mmsystem  // c.f. Sources01\packages\extra\winunits,  pour les procdure de gestion du son.
 ,Windows
 ;

(*
// cette partie est une rcupration des constantes de playsound,
// j'ai laiss les commentaires originaux qui peuvent etre utiles
const
SND_SYNC = $0000; // play synchronously (default)
SND_ASYNC = $0001; // play asynchronously
SND_NODEFAULT = $0002; // don't use default sound
SND_MEMORY = $0004; // lpszSoundName points to a memory file
SND_LOOP = $0008; // loop the sound until next sndPlaySound
SND_NOSTOP = $0010; // don't stop any currently playing sound
SND_NOWAIT = $00002000; // don't wait if the driver is busy
SND_ALIAS = $00010000; // name is a registry alias
SND_ALIAS_ID = $00110000; // alias is a predefined ID
SND_FILENAME = $00020000; // name is file name
SND_RESOURCE = $00040004; // name is resource name or atom
SND_PURGE = $0040; // purge non-static events for task
SND_APPLICATION = $0080; // look for application specific association

// declaration de la fonction playsound contenue dans la dll winmm.dll
function PlaySound(pszSound: PChar; hmod: HMODULE; fdwSound: DWORD): BOOL;
stdcall; external 'winmm.dll' name {$ifdef unicode}'PlaySoundW' {$else}
'PlaySoundA' {$endif};

// declaration de la fonction waveInGetNumDevs contenue dans la dll winmm.dll
function waveInGetNumDevs:word32;
stdcall; external 'winmm.dll' name {$ifdef unicode}'waveInGetNumDevsW' {$else}
'waveInGetNumDevs' {$endif};

// declaration de la fonction playsound contenue dans la dll winmm.dll
function waveInOpen(phwi:LPHWAVEIN; uDeviceID:DWORD; pwfx:PWaveFormatex; dwInstance:DWORD; fdwOpen:DWORD): MMRESULT;
stdcall; external 'winmm.dll' name {$ifdef unicode}'waveInOpen' {$else}
'waveInOpen' {$endif};
*)
type
  TWavSound = array[0..30000000] of byte;  // to store the sound
  PWavSound = ^TWavSound;
var
  paS     : PWavSound; // where the sound will be stored

type
  PMyDialog = ^TMyDialog;
  TMyDialog = object(TDialog)
  //"""""""""""""""""""""""""
  constructor Init(poParentW:PWindowBase);

  function WMCommand(wPar:WPARAM; lPar:LPARAM):BOOL; virtual;
  // Handles the menu messages

//  function DialogProc(hDialog:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
    // Not used
  // Handles the dialog messages. See comments in  wDialog0.pp
  end; // TMyDialog = object(TDialog)

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  constructor Init(strWinTitlePrm:ShortString);

  destructor Done; virtual;

  procedure WinCreate(strWinClass:ShortString); virtual;
  // When creating the window, we ask to show the dialog box, not the window

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

function myCreateDialogObj(poParent:Pointer):Pointer;
//===================================================
var poObj : PMyDialog;
begin
new(poObj, Init(poParent));
myCreateDialogObj:=poObj;
end;  // myCreateDialogObj

//******************************************************************
// TMyDialog = object(TDialog)
//******************************************************************

constructor TMyDialog.Init(poParentW:PWindowBase);
//================================================
begin
// must be done, even if it seems useless.
inherited Init(poParentW);
end;  // TMyDialog.Init

procedure Test1;
//==============
var
  wNbDev : word32;
  wRes   : MMRESULT;  // = DWORD    c.f.  mmsystem.pp
// MMSYSERR_NOERROR      Success
// MMSYSERR_ALLOCATED    Specified resource is already allocated.
// MMSYSERR_BADDEVICEID  Specified device identifier is out of range
// MMSYSERR_NODRIVER     No device driver is present
// MMSYSERR_NOMEM        Unable to allocate or lock memory.
// WAVERR_BADFORMAT      Attempted to open with an unsupported waveform-audio format
  hwi        : HWAVEIN;  // handle to the waveform-audio input device.
  uDeviceID  : UINT;
  pwfx       : LPCWAVEFORMATEX ;
(*
typedef struct {
  WORD wFormatTag;
  WORD nChannels;
  DWORD nSamplesPerSec;
  DWORD nAvgBytesPerSec;
  WORD nBlockAlign;
  WORD wBitsPerSample;
  WORD cbSize;}
WAVEFORMATEX;
*)
  dwCallback : DWORD;
  dwInstance : DWORD;
  fdwOpen    : DWORD;
  
// for waveInAddBuffer
//  hwi        : HWAVEIN;  // handle to the waveform-audio input device.
  pwh        : LPWAVEHDR; // Pointer to a WAVEHDR structure that identifies the buffer.
  cbwh       : UINT;  // Size, in bytes, of the WAVEHDR structure
  pData      : PWavSound;  // for the buffer

begin
// UINT waveInGetNumDevs(void);
wNbDev:=waveInGetNumDevs();
wNbDev:=wNbDev;
// DBW(1, WTS(wNbDev));

fdwOpen:= CALLBACK_WINDOW;
//uDeviceID:= 0;  // default first device.
uDeviceID:= WAVE_MAPPER;  // default device;
new(pwfx);
dwCallback:= poMyMainWin^.hWin; // handle of a window
dwInstance:= 0;  // not used with the window handle

// fills the  pwfx  structure
pwfx^.wFormatTag:=WAVE_FORMAT_PCM;
pwfx^.nChannels:=1;
pwfx^.nSamplesPerSec:=22050;
pwfx^.wBitsPerSample:=8;  // or :=16;
pwfx^.nBlockAlign:=pwfx^.nChannels * pwfx^.wBitsPerSample div 8;
pwfx^.nAvgBytesPerSec:=pwfx^.nSamplesPerSec * pwfx^.nBlockAlign;
pwfx^.cbSize:=0;  // :=0 for  WAVE_FORMAT_PCM

hwi:=0;
wRes:=waveInOpen(@hwi, uDeviceID, pwfx, dwCallback, dwInstance, fdwOpen);
DBW(1, WTS(wRes) + WTS(MMSYSERR_NOERROR) + WTS(MMSYSERR_ALLOCATED));
DBW(1, ITS(hwi));  // handle

// hwi:= received from the waveInOpen function
new(pwh);
GetMem(pData, pwfx^.nBlockAlign);  // Buffer  remplir par le systme.
pwh^.lpData:=PCHAR(pData);
pwh^.dwBufferLength:=SizeOf(pwh^.lpData^);
pwh^.dwBytesRecorded:=1;  // sera rempli par le systme
pwh^.dwUser:=0;  // User data
pwh^.dwFlags:=0;
pwh^.dwLoops:=0;  // used only for outputs
pwh^.lpNext:=nil;  // wavehdr_tag*  ???
pwh^.reserved:=0;
cbwh:=SizeOf(pwh^);

wRes:=waveInPrepareHeader(hwi, pwh, cbwh);
DBW(1, WTS(wRes) + WTS(MMSYSERR_NOERROR) + WTS(MMSYSERR_INVALHANDLE) + WTS(MMSYSERR_INVALPARAM) + WTS(MMSYSERR_NODRIVER) + WTS(MMSYSERR_NOMEM));

wRes:=waveInAddBuffer(hwi, pwh, cbwh);
DBW(1, WTS(wRes) + WTS(MMSYSERR_NOERROR) + WTS(WAVERR_UNPREPARED));

wRes:=waveInStart(hwi);
DBW(1, WTS(wRes) + WTS(MMSYSERR_NOERROR) + WTS(WAVERR_UNPREPARED));

dispose(pwfx);
end;  // Test1;

function TMyDialog.WMCommand(wPar:WPARAM; lPar:LPARAM):BOOL;
//==========================================================
// Handles the menu messages
var
  wCtrlID     : word32;

begin
if (HiWord(wPar) <> BN_CLICKED) then begin
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;
//DBW(1, 'WMCommand=' + DBNotifToStr(HiWord(wPar)) + ITS5(LoWord(wPar)));
wCtrlID:=LoWord(wPar);

//MessageBeep(0);

//DBW(1, 'Button clicked=' + ITS(poBtn^.wCtrlID));

// sets output D0 to 0 [V]
if (wCtrlID = 100) then begin
   Test1;
   end;

// sets output D0 to more than 2 [V]
if (wCtrlID = 101) then begin
   MessageBeep(MB_ICONASTERISK);
   end;

// sets output D1 to 0 [V]
if (wCtrlID = 110) then begin
   MessageBeep(MB_ICONEXCLAMATION);
   end;

// sets output D1 to more than 2 [V]
if (wCtrlID = 111) then begin
   MessageBeep(MB_ICONHAND);
   end;

// sets Led OFF on the PCS10
if (wCtrlID = 300) then begin
   MessageBeep(MB_ICONQUESTION);
end;

// sets Led ON on the PCS10
if (wCtrlID = 301) then begin
   MessageBeep(MB_OK);
   end;

// sets the gain to 1 on all channels on the PCS10
if (wCtrlID = 401) then begin
   MessageBeep(0);
   end;

// sets the gain to 2 on all channels on the PCS10
if (wCtrlID = 402) then begin
   MessageBeep(0);
   end;

// sets the gain to 5 on all channels on the PCS10
if (wCtrlID = 405) then begin
   PlaySound('Self_defined_sound_1.wav', 0, SND_ASYNC or SND_FILENAME);
   end;

// sets the gain to 10 on all channels on the PCS10
if (wCtrlID = 410) then begin
   PlaySound('Self_defined_sound_2.wav', 0, SND_ASYNC or SND_FILENAME);
   end;

// Stops the playing sound
if (wCtrlID = 700) then begin
   PlaySound(NIL, 0, SND_PURGE);
   end;

// Plays a sin sound
if (wCtrlID = 710) then begin
//   Test2;
   end;

// Plays a sin sound sampled at 100 kHz
if (wCtrlID = 801) then begin
//   Test100kHz;
   end;

// Plays a sin sound sampled at 200 kHz
if (wCtrlID = 802) then begin
//   Test200kHz;
   end;

// Plays a sin sound sampled at 200 kHz
if (wCtrlID = 803) then begin
//   Test48kHz;
   end;

// Did we click on the quit button ?
// Close the main window, thus quit the application.
if (wCtrlID = 999) then  PostMessage(poMyMainWin^.hWin, WM_CLOSE, 0, 0);

WMCommand:=inherited WMCommand(wPar, lPar);
end;  // TMyDialog.WMCommand

//******************************************************************
// TMyWindow = object(TWindow)
//******************************************************************

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
new(paS);  // To save the sound into memory.

inherited Init(strWinTitlePrm);
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//========================
begin
inherited Done;

dispose(paS); // free the memory from the data.
paS:=nil;

end;

procedure TMyWindow.WinCreate(strWinClass:ShortString);
//=====================================================
//var strName : string[50];
Begin
// We don't want to see the main window
//wSizeState := SIZE_MINIMIZED;

inherited WinCreate(strWinClass);

// Here calling :  DialogExecMSG(11199, @Self);  doesn't work,
// But posting a message to open the dialog box at startup is possible.
PostMessage(hWin, WM_COMMAND, 101, 0);

//strName:='zlportio' + char(0);
//DBW(0, 'result= ' + ITS(driverstart(@strName[1])));

end;  // TMyWindow.WinCreate

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// treats the menu commands
begin
// Execute the dialog box at starting
// And the help window
if (lPar = 0) and (wPar =101) then DialogCreateMSG(11199, @Self);
//if (lPar = 0) and (wPar =121) then DialogCreateMSG(21199, @Self);

// Accelerators act as button click.
// Send the command to the active dialog
case LoWord(wPar) of
  999 : if (gglpoActiveDialog <> NIL) then
               gglpoActiveDialog^.WMCommand(LoWord(wPar), 0);
  end; // case

WMCommand:=inherited WMCommand(wPar, lPar);
end;  // TMyWindow.WMCommand

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//=======================================================================================
// All window messages are send here.

Begin
WindowProc:=inherited WindowProc(hWindow, wMsg, wPar, lPar);

 if (wMsg <> WM_MouseMove)   and (wMsg <> WM_NCMouseMove) and
   (wMsg <> WM_MENUSELECT )   and (wMsg <> WM_ENTERIDLE ) and
   (wMsg <> WM_SetCursor)   and (wMsg <> WM_NCHittest) and
   (wMsg <> WM_SetFocus) and (wMsg <> WM_KillFocus) and
   (wMsg <> WM_KEYDOWN) and (wMsg <> WM_KEYUP) and
   (wMsg <> WM_Move)        and (wMsg <> WM_NCActivate) then
   DBW0(32, DBMsgToStr(wMsg) + ITS(wPar) + ITS(lPar));

//if (wMsg = WM_Destroy) then begin
//   end;

End;  // TMyWindow.WindowProc

//**********************************************************************
Begin // MAIN ******
// Assign the pointer on the function which will create the dialog.
// It is used by the library. So the library will construct
// a user defined object.
gglfnCreateDialogObj:=@myCreateDialogObj;

// Name under which the main window is registered. Spaces are not allowed
oApp.Init('Example078');

// Creation of the main window
new(poMyMainWin, Init('tEx078_WaveInOpen.pp'));

// The App.WindowClass can be modified here, if wanted. (Not usual)
oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.

