{ Divers tests.
1) Test concercernant les carrs magiques 4 x 4
  --------------------------------------------}
program tEx082_Tests_Divers;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses

  wApplication0
 ,wWindowText0 // To write text in an independent window
 ,wWindow0
 ,wDialog0
 ,wGlobals2
 ,wVariableNumLink2
 ,wDialogCreatorLOW2
 ,wDialogCreator2
// ,wUtiles0
 ,wMessages2
 ,wDebug0
 ,Windows
 ,commDlg;   { !!!  AJOUTER A LA VERSION 2.40 de Freeplascal, sinon problme !!! }

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  // To do simulations, some parameters that can be changed in a dialog box.
  nIter     : int32;  // number of iteration
  nNbFaces  : int32;  // number of faces, between 1 and 40
  nNbPieces : int32;  // number of pieces (number) taken during one experiment

  constructor Init(strWinTitlePrm:ShortString);
  destructor Done; virtual;

  procedure Test1;
  procedure Test2;
  procedure Test3;
  procedure Test4;
  procedure Test5;
  procedure Test6;
  procedure Test7;
  procedure Test8;
  procedure Test10;
  procedure Test11;
  procedure Test12;

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

type
  TArrayInt = array[0..1000] of int32;
  TArrayFlo = array[0..1000] of Float;

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;
  glfStop     : boolean;

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);

// This line is all what is needed to have a status line.
new(poStatusLine, Init(@Self));

// Default values
nIter:=100000;
nNbFaces:=6;
nNbPieces:=80;
glfStop:=false;
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//=========================
begin

inherited Done;
end;  // TMyWindow.Done

//####################################################################################

{$R-}  // Range check error off  if  $R-

procedure MySetWriteFont(nFont:integer);
//======================================
// dfini la police en courrier new
var
  strS        : string[80];
  astrFont    : array[1..4] of string[30];
  rLogFont    : TLogFont;
  pWinText    : PWindowText0;

begin
astrFont[1]:='Arial';
astrFont[2]:='Times New Roman';
astrFont[3]:='Courier New';
astrFont[4]:='Comic Sans MS';  // if you have it.

// define a new font.
strS:=astrFont[nFont]+#0;
with rLogFont do  begin
//   lfHeight         := 0;                // Default logical height of font
   lfWidth          := 0;                // Default logical average character width
   lfEscapement     := 0;                // angle of escapement
   lfOrientation    := 0;                // base-line orientation angle
   lfWeight         := FW_NORMAL;        // font weight = 400
   lfItalic         := 0;                // italic attribute flag
   lfUnderline      := 0;                // underline attribute flag
   lfStrikeOut      := 0;                // strikeout attribute flag
   lfCharSet        := DEFAULT_CHARSET;  // character set identifier
   lfOutPrecision   := OUT_DEFAULT_PRECIS;  // output precision
   lfClipPrecision  := CLIP_DEFAULT_PRECIS; // clipping precision
   lfQuality        := DEFAULT_QUALITY;     // output quality
   lfPitchAndFamily := DEFAULT_PITCH;    // pitch and family
   lfFaceName       :=PCHAR(@strS[1]);   // pointer to typeface name string
//   lfWeight:=400; // normal, could go up to 1000 for very bold
   lfHeight:=-12;
   end; // with

pWinText:=GetWriteWinNr(1);
if (pWinText <> NIL) then pWinText^.oRichEditFrame.SetActualFont(rLogFont);
//if (pWinText <> NIL) then pWinText^.oRichEditFrame.SetActualFont(pWinText^.oRichEditFrame.TheLogFont);
end; //  MySetWriteFont

//####################################################################################

procedure TMyWindow.Test1;
//========================
// Compte le nombre de choix de 4 nombres diffrents parmis ceux de 0  15
// tel que leur somme donne 30.
// Ceci correspondra au nombre de choix de 4 case d'un carr magique 4 x 4
// form des nombres de 0  15, tel que la somme donne 30
var
  nn,n2       : int32;
//  wRep     : word32; // answer of the dialog box
  nCpt,
  ii,
  jj,
  kk,
  ll       : integer; // indice du jour de lundi (=1)  dimanche (=7)

begin
// initialisation
nCpt:=100;  // nombre de choix donnant 30.
for ii:=0 to 12 do
 for jj:=ii+1 to 13 do
  for kk:=jj+1 to 14 do
   for ll:=kk+1 to 15 do
    if (ii + jj + kk + ll = 30) then inc(nCpt);

WriteWin(1, 'nombre de sommes donnant 30 = ' + IntToStr(nCpt,4));
//MySetWriteFont;  // pour dfinir le type de police de caractres.

for n2:=1 to 5000 do begin
  nn:=1000000;
  repeat
    dec(nn);
    until nn = 0;

  WriteWin(1, 'n2 = ' + IntToStr(n2,4) + 'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa');
  LetDisplayInfo;
  end;

end;  // TMyWindow.Test1

procedure TMyWindow.Test2;
//========================
// Compte le nombre de choix de 5 nombres diffrents parmis ceux de 0  24
// tel que leur somme donne 60.
// Ceci correspondra au nombre de choix de 5 case d'un carr magique 5 x 5
// form des nombres de 0  24, tel que la somme donne 60
var
//  nn       : int32;
//  wRep     : word32; // answer of the dialog box
  nCpt,
  ii,
  jj,
  kk,
  ll,
  mm       : integer; // indice du jour de lundi (=1)  dimanche (=7)

begin
// initialisation
nCpt:=0;  // nombre de choix donnant 30.
for ii:=   0 to 20 do
 for jj:=ii+1 to 21 do
  for kk:=jj+1 to 22 do
   for ll:=kk+1 to 23 do
    for mm:=ll+1 to 24 do
     if (ii + jj + kk + ll + mm = 60) then inc(nCpt);

WriteWin(1, 'nombre de sommes donnant 60 = ' + IntToStr(nCpt,5));
//MySetWriteFont;  // pour dfinir le type de police de caractres.

end;  // TMyWindow.Test2

procedure TMyWindow.Test3;
//========================
// Compte le nombre de choix de 3 nombres diffrents parmis ceux de 0  8
// tel que leur somme donne 12.
// Ceci correspondra au nombre de choix de 3 case d'un carr magique 3 x 3
// form des nombres de 0  8, tel que la somme donne 12
var
//  nn       : int32;
//  wRep     : word32; // answer of the dialog box
  nCpt,
  ii,
  jj,
  kk       : integer; // indice du jour de lundi (=1)  dimanche (=7)

begin
// initialisation
nCpt:=0;  // nombre de choix donnant 30.
for ii:=   0 to 6 do
 for jj:=ii+1 to 7 do
  for kk:=jj+1 to 8 do
   if (ii + jj + kk = 12) then inc(nCpt);

WriteWin(1, 'nombre de sommes donnant 12 = ' + IntToStr(nCpt,5));
//MySetWriteFont;  // pour dfinir le type de police de caractres.
end;  // TMyWindow.Test3

procedure TMyWindow.Test4;
//========================
// Cherche les nombres entre 1900 et 2100 qui s'crivent d'une manire suivante :
// 10 x 9 x 8 x 7 x 6 x 5 x 4 x 3 x 2 x 1  o
// x = une opration de base et aussi pouvant tre    7 x 6 = 76.
// Il peut y avoir 'overflow', mais sans consquences.
var
  ii,jj,kk,ll,mm,nn : integer;
  indStack  // indice de la pile des nombres
 ,nMax
           :integer;
  anStack    // liste des nombres de la pile
 ,anOpStack  // liste des oprations  faire sur les nombres de la pile
 ,anOper     // liste des oprations entre les nombres
           : array[0..11] of int32;
  fLoop    : boolean;  // Indique s'il faut continuer une boucle
  strS     : string;


begin
ii:=1; jj:=ii+1; kk:=jj+1; ll:=kk; mm:=ll; nn:=mm;  ii:=nn;  // pour viter des warning

// pour crire en courrier New
WriteWin(1, '');
MySetWriteFont(3); // Police = Courier New

// initialisation
for ii:=10 downto 1 do begin
  anOper[ii]:=1;
  end;

anOpStack[0]:=0;

// Grosse boucle de tous les tests
//################################
repeat
  indStack:=0;
  nMax:=10;
  anStack[1]:=nMax;  // premier nombre de la pile
  strS:=IntToStr(nMax,0);
  for jj:=nMax-1 downto 1 do begin
    while (anOpStack[indStack] >= anOper[jj]) do begin
      // on excute les oprations prcdentes si c'est possible
      if (anOpStack[indStack] = 1) then anStack[indStack]:=anStack[indStack] + anStack[indStack+1];
      if (anOpStack[indStack] = 2) then anStack[indStack]:=anStack[indStack] - anStack[indStack+1];
      if (anOpStack[indStack] = 3) then anStack[indStack]:=anStack[indStack] * anStack[indStack+1];
      if (anOpStack[indStack] = 4) then anStack[indStack]:=anStack[indStack]*10 + anStack[indStack+1];
      dec(indStack);
      end;

    inc(indStack);
    anOpStack[indStack]:=anOper[jj];
    anStack[indStack+1]:=jj;

    if (anOper[jj] = 1) then strS:=strS + ' + ';
    if (anOper[jj] = 2) then strS:=strS + ' - ';
    if (anOper[jj] = 3) then strS:=strS + ' * ';
    if (anOper[jj] = 4) then strS:=strS + '';
    strS:=strS + IntToStr(jj,0);
    end; // for

    // dernire opration
    while (indStack > 0) do begin
      if (anOpStack[indStack] = 1) then anStack[indStack]:=anStack[indStack] + anStack[indStack+1];
      if (anOpStack[indStack] = 2) then anStack[indStack]:=anStack[indStack] - anStack[indStack+1];
      if (anOpStack[indStack] = 3) then anStack[indStack]:=anStack[indStack] * anStack[indStack+1];
      if (anOpStack[indStack] = 4) then anStack[indStack]:=anStack[indStack]*10 + anStack[indStack+1];
      dec(indStack);
      end;

  // criture d'une squence
  if (anStack[1] >= 1900) and (anStack[1] <= 2100) then
     WriteWin(1, IntToStr(anStack[1],7) + ' = ' + strS);

  // passage  la squence d'oprations suivante
  ii:=0;
  fLoop:=true;
  repeat
    inc(ii);
    inc(anOper[ii]);
    if (anOper[ii] > 4) then anOper[ii]:=1   // 4 = nombre d'oprations
    else                     fLoop:=false;
    until not fLoop;  // quiv.   until (anOpen[ii] > 1);

  until (anOper[nMax] > 1);

end;  // TMyWindow.Test4

procedure TMyWindow.Test5;
//========================
// Cherche les nombres entre 1900 et 2100 qui s'crivent d'une manire suivante :
// 10 x 9 x 8 x 7 x 6 x 5 x 4 x 3 x 2 x 1  o
// x = une opration de base et aussi pouvant tre    7 x 6 = 76.
// Il peut y avoir 'overflow', mais sans consquences.
label labelSKIP;  // exception, division par 0
var
  ii,jj,kk,ll,mm,nn : integer;
  indStack  // indice de la pile des nombres
 ,nMax
           :integer;
  anStack    // liste des nombres de la pile
           : array[0..11] of Float;
  anOpStack  // liste des oprations  faire sur les nombres de la pile
 ,anOper     // liste des oprations entre les nombres
           : array[0..11] of int32;
  fLoop    : boolean;  // Indique s'il faut continuer une boucle
  strS     : string;


begin
ii:=1; jj:=ii+1; kk:=jj+1; ll:=kk; mm:=ll; nn:=mm;  ii:=nn;  // pour viter des warning

// pour crire en courier New
WriteWin(1, '');
MySetWriteFont(3);

// initialisation
for ii:=10 downto 1 do begin
  anOper[ii]:=1;
  end;

anOpStack[0]:=0;

// Grosse boucle de tous les tests
//################################
repeat
  indStack:=0;
  nMax:=10;
  anStack[1]:=nMax;  // premier nombre de la pile
  strS:=IntToStr(nMax,0);
  for jj:=nMax-1 downto 1 do begin
    while (anOpStack[indStack] >= anOper[jj]) do begin
      // on excute les oprations prcdentes si c'est possible
      if (anOpStack[indStack] = 1) then anStack[indStack]:=anStack[indStack] + anStack[indStack+1];
      if (anOpStack[indStack] = 2) then anStack[indStack]:=anStack[indStack] - anStack[indStack+1];
      if (anOpStack[indStack] = 3) then anStack[indStack]:=anStack[indStack] * anStack[indStack+1];
      if (anOpStack[indStack] = 4) then begin
        if (anStack[indStack+1] <> 0) then
          anStack[indStack]:=anStack[indStack] / anStack[indStack+1]
        else goto labelSKIP;
        end;
      if (anOpStack[indStack] = 5) then anStack[indStack]:=anStack[indStack]*10 + anStack[indStack+1];
      dec(indStack);
      end;

    inc(indStack);
    anOpStack[indStack]:=anOper[jj];
    anStack[indStack+1]:=jj;

    if (anOper[jj] = 1) then strS:=strS + ' + ';
    if (anOper[jj] = 2) then strS:=strS + ' - ';
    if (anOper[jj] = 3) then strS:=strS + ' * ';
    if (anOper[jj] = 4) then strS:=strS + ' / ';
    if (anOper[jj] = 5) then strS:=strS + '';
    strS:=strS + IntToStr(jj,0);
    end; // for jj

  // la dernire opration se fait avec 1.  Elimine les division par 1, car
  // cela revient au mme que de multiplier par 1.
  if (anOpStack[indStack] = 4) then goto labelSKIP;

  // dernires oprations
  while (indStack > 0) do begin
    if (anOpStack[indStack] = 1) then anStack[indStack]:=anStack[indStack] + anStack[indStack+1];
    if (anOpStack[indStack] = 2) then anStack[indStack]:=anStack[indStack] - anStack[indStack+1];
    if (anOpStack[indStack] = 3) then anStack[indStack]:=anStack[indStack] * anStack[indStack+1];
    if (anOpStack[indStack] = 4) then begin
      if (anStack[indStack+1] <> 0) then
        anStack[indStack]:=anStack[indStack] / anStack[indStack+1]
      else goto labelSKIP;
      end;
    if (anOpStack[indStack] = 5) then anStack[indStack]:=anStack[indStack]*10 + anStack[indStack+1];
    dec(indStack);
    end;

  // criture d'une squence
  if (anStack[1] >= 1900) and (anStack[1] <= 2100) and
     (Frac(anStack[1]) > -0.0000001) and (Frac(anStack[1]) < 0.0000001) then
    WriteWin(1, FloatToStr(anStack[1],7,0) + ' = ' + strS);

labelSKIP: // saut ici, en cas de division par 0

  // passage  la squence d'oprations suivante
  ii:=0;
  fLoop:=true;
  repeat
    inc(ii);
    inc(anOper[ii]);
    if (anOper[ii] > 5) then anOper[ii]:=1   // 4 = nombre d'oprations
    else                     fLoop:=false;
    until not fLoop;  // quiv.   until (anOpen[ii] > 1);

  until (anOper[nMax] > 1);

end;  // TMyWindow.Test5

procedure TMyWindow.Test6;
//========================
// Calcul numrique de l'intgrale double utile pour le d  5 faces.
var
  ii,jj,nN,nM : int32;
  vA
 ,vB
 ,vFacA // facteur constant
 ,vFacB // facteur constant
 ,vT   // temporaire
 ,vS
// ,vR
              : Float;
  rMessage    : Msg;

begin
glfStop:=false;

// pour crire en courier New
WriteWin(1, '');
MySetWriteFont(3); // Police = Courier New

vA:=0.1;
vB:=sqrt(3);
nM:=10000;
vFacB:=vB / nM;
repeat
  nN:=20000;
    vS:=0;
    vFacA:=vA / nN;

    for ii:=0 to nN-1 do for jj:=0 to nM-1 do begin
      vT:=1 + sqr(vFacA*(0.5 + ii)) + sqr(vFacB*(0.5 + jj));
      vS:=vS + 1 / (vT * sqrt(vT));
      end;

    vS:=4*vFacA*vFacB*vS;
//    vR:=sqrt(sqr(2*pi/(2*pi - vS)) - 1) / vA;

    WriteWin(1, 'a = ' + FloatToStr(vA,7,2)
           + '   N = ' + IntToStr(nN,7)
           + '   S(a) = ' + FloatToStr(vS,15,10)
//           + '   r(a)/a = ' + FloatToStr(vR,15,10)
           );

  if (vA < 4.95) then vA:=vA+0.1
  else if (vA < 9.95) then vA:=vA+0.2
  else if (vA < 99.95) then vA:=vA+0.5
  else if (vA < 39.95) then vA:=vA+10
  else vA:=vA+50;

  // Let the dialog box being redrawn
  while (PeekMessage(@rMessage, 0, // any messages for this application
                      0, 0,         // Let the dialog box being updated
                      PM_REMOVE))   // remove the message from the queue
                      do begin
  TranslateAccelerator( gglpoMainWindow^.hWin,
                         gglpoApplication^.hAccelTable, rMessage);  // pour traiter des acclrateurs
  TranslateMessage(rMessage);
//        DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
    DispatchMessage(rMessage);
    end;

  until (vA > 400) or (glfStop);

WriteWin(1, 'Termine');
end;  // TMyWindow.Test6

procedure TMyWindow.Test7;
//========================
// Calcul numrique de l'intgrale double utile pour le d  5 faces.
var
  ii,jj,nM : int32;
  vA
 ,vB
 ,vDX
 ,vDY
 ,vT   // temporaire
 ,vS
// ,vR
              : Float;
  rMessage    : Msg;

begin
glfStop:=false;

// pour crire en courier New
WriteWin(1, '');
MySetWriteFont(3); // Police = Courier New

//vA:=0.1;
vB:=sqrt(3);  // est fixe
nM:=17320;
vDY:=vB / nM;  // ~= 0.0001
vDX:=0.0001;
vS:=0;

for ii:=0 to 1000 do begin
  for jj:=0 to nM-1 do begin
    vT:=1 + sqr(vDX*(0.5 + ii)) + sqr(vDY*(0.5 + jj));
    vS:=vS + 1 / (vT * sqrt(vT));
    end; // for jj

//  if (((ii + 1) mod 100) = 0) then begin
  if (ii >= 0*8999) then begin
    vA:=(ii + 1) * vDX;

    WriteWin(1, 'a = ' + FloatToStr(vA,9,5)
           + '   S(a) = ' + FloatToStr(4*vDX*vDY*vS,15,10)
           );

    // Let the dialog box being redrawn
    while (PeekMessage(@rMessage, 0, // any messages for this application
                        0, 0,         // Let the dialog box being updated
                        PM_REMOVE))   // remove the message from the queue
                        do begin
      TranslateAccelerator( gglpoMainWindow^.hWin,
                             gglpoApplication^.hAccelTable, rMessage);  // pour traiter des acclrateurs
      TranslateMessage(rMessage);
      //        DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
      DispatchMessage(rMessage);
      end; // while
    end; // if

  end; // for ii

WriteWin(1, 'Termine');
end;  // TMyWindow.Test7


procedure TMyWindow.Test8;
//========================
// Calcul numrique de l'intgrale double utile pour 
// dterminer des angles solides sous lesquels des polygnes sont vu.
// les polygnes   C  faces sont dcomposs en  C  triangles.
// Dans le cadre du calcul du d  5 faces.
var
  nC  // nombre de ct du polygne,  3 pour un d  5 faces, 5 pour un d  7 faces.
 ,nN,ii,jj : int32;
  vA
 ,vH
 ,vDX
 ,vDY
 ,vX2p1
 ,vT   // temporaire
 ,vRapLast
 ,vRap // but trouver vA et VH pour que vRap = 1
 ,vS
 ,vR
              : Float;
  rMessage    : Msg;

begin
glfStop:=false;
vRap:=0;

// pour crire en courier New
WriteWin(1, '');
MySetWriteFont(3); // Police = Courier New

WriteWin(1,
       'nbFaces         a        2a         h         r   Aire rect   Aire poly   Rap Aires' );

nC :=3; // nombre de cts du polygne
for nC:=3 to 5 do begin
vDX:=0.0001;
vDY:=vDX * sin(pi/nC) / cos(pi/nC);

vS:=0;
nN:=1;
repeat
  ii:=nN-1;
  vX2p1:=1 + sqr(vDX*(0.5 + ii));
  for jj:=-ii to ii do begin
    vT:=vX2p1 + sqr(vDY*jj);
    vS:=vS + 1 / (vT * sqrt(vT));
    end; // for jj

  vRapLast:=vRap;
  vRap:=(nC+2)*nC*vDX*vDY*vS / (4*pi);

//  if ((nN mod 1000) = 0) then begin
  if (
       (vRap >= 1) and (vRapLast <= 1)
//      (nN >= 2000)
//    and ((nN mod 1) = 0)
                           ) then begin
(*
    vA:=(nN-1) * vDY;
    vH:=(nN-1) * vDX;
    vR:=sqrt(sqr(vA) + sqr(vH));
    WriteWin(1,
           'nbFaces =' + IntToStr(nC+2,3)
           + '   a =' + FloatToStr(vA,8,5)
           + '   2a= ' + FloatToStr(2*vA,8,5)
           + '   h =' + FloatToStr(vH,8,5)
           + '   r =' + FloatToStr(vR,8,5)
           + '   Aire rect =' + FloatToStr(4*vA,8,5)
           + '   Aire poly =' + FloatToStr(nC*vA*vH,8,5)
           + '   Rap Aires =' + FloatToStr(nC*vH/4,8,5)
           + '   (C+2)*C* S(a) /(4*pi) =' + FloatToStr( vRapLast,9,6)
           );

    vA:=nN * vDY;
    vH:=nN * vDX;
    vR:=sqrt(sqr(vA) + sqr(vH));
    WriteWin(1,
           'nbFaces =' + IntToStr(nC+2,3)
           + '   a =' + FloatToStr(vA,8,5)
           + '   2a= ' + FloatToStr(2*vA,8,5)
           + '   h =' + FloatToStr(vH,8,5)
           + '   r =' + FloatToStr(vR,8,5)
           + '   Aire rect =' + FloatToStr(4*vA,8,5)
           + '   Aire poly =' + FloatToStr(nC*vA*vH,8,5)
           + '   Rap Aires =' + FloatToStr(nC*vH/4,8,5)
           + '   (C+2)*C* S(a) /(4*pi) =' + FloatToStr( vRap,9,6)
           );
*)
    // Extrapolation
    vA:=nN * vDY + vDY * (vRap-1) / (vRapLast - vRap);
    vH:=nN * vDX + vDX * (vRap-1) / (vRapLast - vRap);
    vR:=sqrt(sqr(vA) + sqr(vH));
    WriteWin(1,
             IntToStr(nC+2,7)
           + FloatToStr(vA,10,5)
           + FloatToStr(2*vA,10,5)
           + FloatToStr(vH,10,5)
           + FloatToStr(vR,10,5)
           + FloatToStr(4*vA,12,5)
           + FloatToStr(nC*vA*vH,12,5)
           + FloatToStr(nC*vH/4,12,5)
           );
  // On s'intresse  la valeur de  vA, lorsque  (C+2)*C* S(a) /(4*pi)  gale  1

    // Let the dialog box being redrawn
    while (PeekMessage(@rMessage, 0, // any messages for this application
                        0, 0,         // Let the dialog box being updated
                        PM_REMOVE))   // remove the message from the queue
                        do begin
      TranslateAccelerator( gglpoMainWindow^.hWin,
                             gglpoApplication^.hAccelTable, rMessage);  // pour traiter des acclrateurs
      TranslateMessage(rMessage);
      //        DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
      DispatchMessage(rMessage);
      end; // while
    end; // if

  inc(nN);
  until (vRap > 1.001);

end; // for nC:=3...

WriteWin(1, 'Termine');
end;  // TMyWindow.Test8

procedure TMyWindow.Test10;
//========================
// Tests statistiques sur des lancers de ds  6 faces, pour tester l'indpendance
var
  n2
 ,nCount     : int32;
  fIn        : text;

procedure ReadIt(strFile:string);
//===============================
begin
assign(fIn, strFile);
reset(fIn);

nCount:=0;

// Lecture des donnes et calculs des frquences de paires d'occurences.
while (not eof(fIn)) do begin
  // Lecture des donnes et frquences des paires
  inc(nCount);
  readln(fIn, n2);
  WriteWin(1, 'n = ' + ITS(nCount) + ITS(n2));
  end;

close(fIn);
end;

begin // TMyWindow.Test11;
ReadIt('h:\Bg\Docs\De_5_Faces\F6_47_4103.txt');
//ReadIt('h:\Bg\Docs\De_5_Faces\');

end;  // TMyWindow.Test10

procedure TMyWindow.Test11;
//========================
// Tests statistiques sur des lancers de ds  6 faces, pour tester l'indpendance
var
  n0, n2
 ,nCount     : int32;
  ii         : integer;
  fIn        : text;
  anFrequ    : array[0..6] of int32;
  vProb
 ,vSigma     : Float;

procedure ReadIt(strFile:string);
//===============================
begin
assign(fIn, strFile);
reset(fIn);

// Lecture des donnes et calculs des frquences de paires d'occurences.
while (not eof(fIn)) do begin
  // Lecture des donnes et frquences des paires
  readln(fIn, n0, n2);
  if (n2 > 0) then begin
    inc(anFrequ[n2-1]);
    inc(nCount);
    end;

  end;

close(fIn);
end;

begin // TMyWindow.Test11;
// Initialisation
nCount:=0;
for ii:=0 to 6 do anFrequ[ii]:=0;

ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_47_4100.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_46_9979.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_45_9320.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_44_1200.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_43_1200.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_42_4200.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_41_0800.txt');

ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_016_6110_Sans_erreurs.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_015_5428_Sans_erreurs.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_014_1501_Sans_erreurs.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_013_0240_Sans_erreurs.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_012_0701_Sans_erreurs.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_011_0801_Sans_erreurs.txt');
//ReadIt('h:\Bg\Docs\De_5_Faces\');

WriteWin(1, 'nCount = ' + ITS(nCount));

for ii:=0 to 5 do begin
  vProb:=anFrequ[ii] / nCount;
  vSigma:=sqrt(vProb * (1-vProb) / nCount);

  WriteWin(1, 'Frequ de ' + ITS4(1 + ii)
            + FTS((vProb - 1/6) / vSigma) + ' ;'
            + FTS(6*vProb)
            + FTS(6*(vSigma))
            );
  end;

end;  // TMyWindow.Test11

procedure TMyWindow.Test12;
//========================
// Tests statistiques sur des lancers de ds  6 faces, pour tester l'indpendance
var
  n0, n1, n2
 ,nCount     : int32;
  ii         : integer;
  fIn        : text;
  anFrequ    : array[0..36] of int32;
  vProb
 ,vSigma     : Float;

procedure ReadIt(strFile:string);
//===============================
begin
assign(fIn, strFile);
reset(fIn);

// Lecture des donnes et calculs des frquences de paires d'occurences.
n1:=0;
while (not eof(fIn)) do begin
  // Lecture des donnes et frquences des paires
  readln(fIn, n0, n2);
  if (n1 > 0) and (n2 > 0) then begin
    inc(anFrequ[n1-1 + 6*(n2-1)]);
    inc(nCount);
    end;

  n1:=n2;
  end;

close(fIn);
end;

begin // TMyWindow.Test12;
// Initialisation
nCount:=0;
for ii:=0 to 36 do anFrequ[ii]:=0;

ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_47_4100.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_46_9979.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_45_9320.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_44_1200.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_43_1200.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_42_4200.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie001_6f_41_0800.txt');

ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_016_6110_Sans_erreurs.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_015_5428_Sans_erreurs.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_014_1501_Sans_erreurs.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_013_0240_Sans_erreurs.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_012_0701_Sans_erreurs.txt');
ReadIt('h:\Bg\Docs\De_5_Faces\Serie_6f_011_0801_Sans_erreurs.txt');
//ReadIt('h:\Bg\Docs\De_5_Faces\');

WriteWin(1, 'nCount = ' + ITS(nCount));

for ii:=0 to 35 do begin
  vProb:=anFrequ[ii] / nCount;
  vSigma:=sqrt(vProb * (1-vProb) / nCount);

  WriteWin(1, 'Frequ de ' + ITS4(1 + (ii mod 6)) + ITS4(1 + (ii div 6))
            + FTS((vProb - 1/36) / vSigma) + ' ;'
            + FTS(36*vProb)
            + FTS(36*(vSigma))
            );
(*
  WriteWin(1, 'Frequ de ' + ITS4(1 + (ii mod 6)) + ITS4(1 + (ii div 6))
            + FTS(36*vProb)
            + FTS(36*(vProb - 2*vSigma))
            + FTS(36*(vProb + 2*vSigma)) + ' ;'
            + FTS(36*(vProb - 3*vSigma))
            + FTS(36*(vProb + 3*vSigma)) + ' ;'
            + FTS(36*(vSigma))
            );
*)
  end;

end;  // TMyWindow.Test12

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// Handles the menu messages
Var wNrMenu     : word;
    wCtrlID     : word32;
begin
WMCommand := 0; // Default return value when processing a message

wCtrlID:=LoWord(wPar);
// Stop generating pulses
if (wCtrlID = 999) then begin
  glfStop:=true;
//  DBW(0, 'STOPPING');
  end;

if (lPar <> 0) then begin
   // call the parent WMCommand method.
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;

// for the menus,  lPar = 0
//=========================
wNrMenu   := LoWord(wPar);
Case wNrMenu Of
   101 : Test1;
   102 : Test2;
   103 : Test3;
   104 : Test4;
   105 : Test5;
   106 : Test6;
   107 : Test7;
   108 : Test8;

   110 : Test10;
   111 : Test11;
   112 : Test12;

   else WMCommand:=inherited WMCommand(wPar, lPar);
   end;  // Case NrMenu Of
end;  // TMyWindow.WMCommand

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//======================================================================================
begin
// Default treatment of a message. Does nearly nothing
WindowProc := inherited WindowProc(hWindow, wMsg, wPar, lPar);
end;  // TMyWindow.WindowProc

Begin // MAIN ******
// Name under which the main window is registered. Spaces are not allowed
oApp.Init('tEx082_Tests_Divers');

// Creation of the main window
new(poMyMainWin, Init('tEx082_Tests_Divers'));

oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.

