{ Test de lecture de l'cran et d'criture sur l'cran
  Lecture de l'tat d'un d
  --------------------------------------------}
program tEx083_Lecture_Ecriture_Ecran;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses

  wApplication0
 ,wWindow0
 ,wDialog0
 ,wWindowBase0
 ,wDialogCreatorLow2
 ,wDialogCreator2
 ,wVariableNumLink2
// ,wUtiles0 // for the AccelTableMSGCreate function
 ,wGlobals2
 ,wParamApplic2
 ,wDebug0
 ,Windows;

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  pDialogActivate : PDialog;

  colGray : TypeColor;
  // Gray color of the cels.

  xScrMin     // rgion de l'cran vu
 ,xScrMax
 ,yScrMin
 ,yScrMax
 ,nLimWhite   // Limite de dtection du blanc
              : integer;

  nXDelta, nYDelta : integer;
  // number of pixels between two mine squares.

  fInfo            // indique s'il faut afficher des infos de dtection d'image
 ,fDraw : boolean; // indique s'il faut dessiner l'image

  wNb_msStart : word32;
  // to set the starting time

  wTimer1ID : word32;
  // ID of the first timer
  // = 0 when stopped

  nbNTrouve    // pour regrouper le nombre de fois que l'on trouv
 ,nTrouveLast  // le mme nombre de points.
               : integer;

  constructor Init(strWinTitlePrm:ShortString);
  destructor Done; virtual;

  procedure TestPoint( hDCScreen:HDC; nX0, nY0:integer;
                       var nX_left,nX_right,nY_top,nY_bot:integer);
  // Si une croix de longueur 35 x 35 peut tre place dans le d,
  // indique le carr contenant cette croix dans nX_left,..,nY_bot.
  // sinon,  nX_left = nX_right = nX0

  procedure GetScreenImage;
  // Lecture de l'image  l'cran

  procedure CopyScreenImage;
  // Copie d'une portion de l'image de l'cran

  procedure DetectNumber;
  // Dtection du nombre sur le d

  procedure WMTimer(wTimerID:WParam);
  // To handle the timer messages.

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

  PMyParamApplic = ^TMyParamApplic;
  TMyParamApplic = object(TParamApplic)
  //"""""""""""""""""""""""""""""""""""
  constructor Init;
//  destructor  Done; virtual;  use default

  // To save some parameters informations in the text file fOut
  // This is often overriden
  procedure SavePrmWrite(var fOut:text); virtual;

  // To load some parameters informations from the text file fIn
  // This is often overriden
  procedure LoadPrmRead(var fIn:text);  virtual;
  end; // TMyParamApplic = object(TParamApplic2)

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;
  poMyAppPrm  : PMyParamApplic;

// var nNotUsed : integer; // only to avoid an error message while compliling in DevPascal 1.9

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);

xScrMin:=3;
xScrMax:=200;
yScrMin:=50;
yScrMax:=200;
nLimWhite:=600;   // Limite de dtection du blanc

nXDelta:=35;
nYDelta:=37;

fDraw:=true;
fInfo:=true;
wTimer1ID:=0;

// time when timer started to count
wNb_msStart:=GetTickCount;

//Int32Field(  1001, ptTopLeft.x);
//Int32Field(  1002, ptTopLeft.y);
IntegerField(1001, nXDelta);
IntegerField(1002, nYDelta);
IntegerField(1003, xScrMin);
IntegerField(1004, xScrMax);
IntegerField(1005, yScrMin);
IntegerField(1006, yScrMax);
IntegerField(1007, nLimWhite);

ByteField(1009, byte(fDraw));
ByteField(1010, byte(fInfo));

// This line is all what is needed to have a status line.
new(poStatusLine, Init(@Self));
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//=========================
begin
inherited Done;
end;  // TMyWindow.Done

procedure TMyWindow.GetScreenImage;
//=================================
// Lecture de l'image  l'cran
var
  ptL         : TPoint;
  hDCScreen   : HDC;
  colPixel    : TypeColor;
begin
//DialogExecMSG(20399, @Self);

// Get Mouse position
GetCursorPos(@ptL);

// Get a device context of the screen
hDCScreen:=GetDC(0);

colPixel:= GetPixel(hDCScreen, ptL.x, ptL.y);

ReleaseDC(0, hDCScreen);

DBW(1, 'color=' + ITS5(colPixel.bRed) + ITS5(colPixel.bGreen) + ITS5(colPixel.bBlue));
end;  // TMyWindow.GetScreenImage

procedure TMyWindow.CopyScreenImage;
//==================================
// Copie d'une portion de l'image de l'cran
var
  ii,jj : integer;
  ptL         : TPoint;
  hDCScreen   : HDC;
  colPixel    : TypeColor;
  yMid        
 ,yR2         : integer;

begin
// Get a device context of the screen
hDCScreen:=GetDC(0);

for ii:=xScrMin to xScrMax do begin
  ptL.x:=ii;
  for jj:=yScrMin to yScrMax do begin
    ptL.y:=jj;
    colPixel:= GetPixel(hDCScreen, ptL.x, ptL.y);
    SetPixel(hDCScreen, ptL.x + 310, ptL.y, colPixel);
    end;
  end;

yMid:=    (yScrMax + yScrMin) div 2;
yR2 :=sqr(1+(yScrMax - yScrMin) div 2);
for jj:=yScrMin to yScrMax do begin
 for ii:=xScrMin + yMid-yScrMin - round(sqrt(yR2 - sqr(jj-yMid))) to
         xScrMin + yMid-yScrMin + round(sqrt(yR2 - sqr(jj-yMid))) do begin
  ptL.x:=ii;
    ptL.y:=jj;
    colPixel:= GetPixel(hDCScreen, ptL.x, ptL.y);
    colPixel.bRed  :=32*((colPixel.bRed + colPixel.bGreen + colPixel.bBlue) div (3*32));
    colPixel.bGreen:=colPixel.bRed;
    colPixel.bBlue :=colPixel.bRed;
    SetPixel(hDCScreen, ptL.x + 320+xScrMax, ptL.y, colPixel);
    end;
  end;

ReleaseDC(0, hDCScreen);
end;  // TMyWindow.CopyScreenImage

procedure TMyWindow.TestPoint( hDCScreen:HDC; nX0, nY0:integer;
                               var nX_left,nX_right,nY_top,nY_bot:integer);
//=========================================================================
// Si une croix de longueur nXDelta x nYDelta peut tre place dans le d,
// indique le carr contenant cette croix dans nX_left,..,nY_bot.
// sinon,  nX_left = nX_right = nX0
var
  jTop
 ,jBot
 ,iLeft
 ,iRight
        : integer;
  colPixel    : TypeColor;

begin // TestPoint
jTop:=nY0;
repeat
  dec(jTop);
  if fDraw then begin
    colPixel.bRed  :=  0;
    colPixel.bGreen:=255;
    colPixel.bBlue :=  0;
    colPixel.bReserved:=0;
    SetPixel(hDCScreen, nX0 + 310, jTop+1, colPixel);
    end;

  colPixel:= GetPixel(hDCScreen, nX0, jTop);
  until ((colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite) or (jTop <= yScrMin));

jBot:=nY0;
repeat
  inc(jBot);
  if fDraw then begin
    colPixel.bRed  :=255;
    colPixel.bGreen:=  0;
    colPixel.bBlue :=  0;
    colPixel.bBlue :=  0;
    colPixel.bReserved:=0;
    SetPixel(hDCScreen, nX0 + 310, jBot-1, colPixel);
    end;

  colPixel:= GetPixel(hDCScreen, nX0, jBot);
  until ((colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite) or (jBot >= yScrMax));

if ((jBot - jTop) >= nYDelta) and ((jBot - jTop) < 40) then begin
  // probablement un point du d, test encore verticalement.
//   DBW(1, 'X0, Y0, Ytop, Ybot =' + ITS5(nX0)  + ITS5(nY0) + ITS5(jTop) + ITS5(jBot));
  nY0:=(jTop + jBot) div 2;  // milieu
  iLeft:=nX0;
  repeat
    dec(iLeft);
    if fDraw then begin
      colPixel.bRed  :=255;
      colPixel.bGreen:=  0;
      colPixel.bBlue :=  0;
      colPixel.bReserved:=0;
      SetPixel(hDCScreen, iLeft + 311, nY0, colPixel);
      end;

    colPixel:= GetPixel(hDCScreen, iLeft, nY0);
    until ((colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite) or (iLeft <= xScrMin));

  iRight:=nX0;
  repeat
    inc(iRight);
    if fDraw then begin
      colPixel.bRed  :=  0;
      colPixel.bGreen:=255;
      colPixel.bBlue :=  0;
      colPixel.bReserved:=0;
      SetPixel(hDCScreen, iRight + 309, nY0, colPixel);
      end;

    colPixel:= GetPixel(hDCScreen, iRight, nY0);
    until ((colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite) or (iRight >= xScrMax));

  if ((iRight - iLeft) >= nXDelta) and ((iRight - iLeft) < 40) then begin
     // point blanc du d trouv
     nX_left :=iLeft;
     nX_right:=iRight;
     nY_top  :=jTop;
     nY_bot  :=jBot;
    end
  else begin
     // Point pas trouv, fausse alerte.
     nX_left :=nX0;
     nX_right:=nX0;
     nY_top  :=nY0;
     nY_bot  :=nY0;
     end;
  end
else begin
   // Point pas trouv, fausse alerte.
   nX_left :=nX0;
   nX_right:=nX0;
   nY_top  :=nY0;
   nY_bot  :=nY0;
   end;

end; // TMyWindow.TestPoint

procedure TMyWindow.DetectNumber;
//===============================
// Dtection du nombre sur le d
var
  ii,jj,nn : integer;
  ptL         : TPoint;
  hDCScreen   : HDC;
  colPixel    : TypeColor;
  nSuivit     // nombre de pixels blancs qui se suivent
 ,nX_left     // position du point trouv
 ,nX_right
 ,nY_top
 ,nY_bot
 ,nTrouve     // Nombre de points trouvs
               : integer;
  anXMin      // position d'un point trouv
 ,anXMax
 ,anYMin
 ,anYMax
              : array[0..10] of integer;

begin // TMyWindow.DetectNumber
// Get a device context of the screen
hDCScreen:=GetDC(0);

// Copie de l'image, pour voir
if fDraw then for jj:=yScrMin to yScrMax do begin
  ptL.y:=jj;
  for ii:=xScrMin to xScrMax do begin
    ptL.x:=ii;
    colPixel:= GetPixel(hDCScreen, ptL.x, ptL.y);

    if (colPixel.bRed + colPixel.bGreen + colPixel.bBlue > nLimWhite) then begin
      colPixel.bRed  :=0;
      colPixel.bGreen:=0;
      colPixel.bBlue :=0;
      SetPixel(hDCScreen, ptL.x + 310, ptL.y, colPixel);
      end
    else begin
      colPixel.bRed  :=255;
      colPixel.bGreen:=255;
      colPixel.bBlue :=255;
      SetPixel(hDCScreen, ptL.x + 310, ptL.y, colPixel);
      end;
    end; // for ii
  end; // for jj

// zones ou des points ont t trouvs
nTrouve:=0;  // nombre de points trouvs
anXMin[0]:=0;
anXMax[0]:=0;
anYMin[0]:=0;
anYMax[0]:=0;

// Cherche des points blancs
for jj:=yScrMin to yScrMax do begin
  ptL.y:=jj;
  nSuivit:=0;
  ii:=xScrMin;
  repeat
    inc(ii);
    // est-on dans une zone o un point a dj t trouv ?
    for nn:=1 to nTrouve do begin
      if ( (jj >= anYMin[nn]) and (jj <= anYMax[nn]) and
           (ii >= anXMin[nn]) and (ii <= anXMax[nn]) ) then ii:=anXMax[nn];
      end;

    ptL.x:=ii;
    colPixel:= GetPixel(hDCScreen, ptL.x, ptL.y);

    if (colPixel.bRed + colPixel.bGreen + colPixel.bBlue > nLimWhite) then begin
      inc(nSuivit); // un pixel blanc trouv, on le nombre que se suivent
      end
    else begin
      // plus de pixel blanc trouv, s'il y en a assez, on test si c'est un point
      // du d.
      if (nSuivit >= nXDelta) and (nSuivit < 40) then begin
        TestPoint( hDCScreen, ii - nSuivit div 2, jj,
                   nX_left, nX_right, nY_top, nY_bot);

        if (nX_right > nX_left) then begin
          // point trouv, il faut liminer cette rgion de recherche
          if fInfo then DBW(1, 'Trouv en :' + ITS5(nX_left) + ITS5(nX_right)
                                             + ITS5(nY_top)  + ITS5(nY_bot)
                                             + ITS5(nX_right - nX_left)
                                             + ITS5(nY_bot   - nY_top) );
          if (nTrouve < 10) then inc(nTrouve);
          anXMin[nTrouve]:=nX_left;
          anXMax[nTrouve]:=nX_right;
          anYMin[nTrouve]:=nY_top;
          anYMax[nTrouve]:=nY_bot;
          end;
        end;

      nSuivit:=0; // pour chercher un autre point blanc
      end;
    until (ii >= xScrMax);
  end; // for jj

ReleaseDC(0, hDCScreen);

if (wTimer1ID = 13) then begin
  // Ne fait rien, affichage dans le timer
//  DBW(1, '   Nombre trouve =' + ITS5(nTrouve));
  nTrouveLast:=nTrouve;
  end
else if (wTimer1ID <> 11) then begin
  // affichage diffrent, si le timer fonctionne ou non
  DBW(1, '   Nombre trouve =' + ITS5(nTrouve));
  end
else if (nTrouve <> nTrouveLast) then begin
  DBW(1, '   Nombre trouve =' + ITS5(nTrouveLast) + ' x ' + ITS5(nbNTrouve));
  nbNTrouve:=0;
  nTrouveLast:=nTrouve;
  end;
inc(nbNTrouve);
end;  // TMyWindow.DetectNumber

procedure TMyWindow.WMTimer(wTimerID:WParam);
//===========================================
// To handle the timer messages.
var
  wNb_ms      : word32;
//  rSysTime    : SYSTEMTIME;
  strS        : string;
  nTrouvePrec  // nTrouve prcdent
 ,nTrouvePrec2
 ,nn          : integer;

begin
if (wTimerID = 12) then begin
   // time in mili-seconds since Windows started minus the time when
   // the start button has been pressed.
   wNb_ms:=GetTickCount - wNb_msStart;

   strS:='Time = ' + IntToStr(wNb_ms div 1000, 4) + '.'
                           + IntToStr((wNb_ms mod 1000) div 100, 1) + ' sec';
   DBW(1, strS);
   end;

if (wTimerID = 11) then begin
  DetectNumber;
(*
   // time of the computer.
   GetSystemTime(@rSysTime);

   with rSysTime do begin
      strS:='Time = ' +
            IntToStr(wHour, 2) + ' ' +
            IntToStr(wMinute, 2) + ''' ' +
            IntToStr(wSecond, 2) + '.' +
            IntToStr(wMilliseconds div 100, 1) +
            ',   Year = ' + IntToStr(wYear, 4) +
            ',  Month = ' + IntToStr(wMonth, 2) +
            ',  Day = ' + IntToStr(wDay, 2) +
            ',  Day of week = ' + IntToStr(wDayOfWeek, 2);
      DBW(1, strS);
      end;
*)

   end;

if (wTimerID = 13) then begin
   KillTimer(hWin, wTimer1ID);

   nTrouveLast:=-1;
   nTrouvePrec:=-2;
   nbNTrouve:=0;
   nn:=0;
   repeat
     inc(nn);
     nTrouvePrec2:=nTrouvePrec;
     nTrouvePrec:=nTrouveLast;
     DetectNumber;

     // on s'arrte si 3 fois le mme nombre de suite.
     until (nn > 15) or
           ((nTrouvePrec = nTrouveLast) and (nTrouvePrec2 = nTrouvePrec) and
            (nTrouveLast > 0));

   DBW(1, '   Nombre trouve =' + ITS5(nTrouveLast) + ' x ' + ITS5(nn));

   // prochaine mesure dans 3 secondes);
   wTimer1ID:=SetTimer( hWin, 13, // 13 = a unique timer ID
                        3000,  // timeout in mili-seconds
                        NIL);
   end;

end;  // TMyWindow.WMTimer

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// Handles the menu messages
Var wNrMenu     : word;
begin
WMCommand := 0; // Default return value when processing a message

if (lPar <> 0) then begin
   // call the parent WMCommand method.
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;

// for the menus,  lPar = 0
//=========================
wNrMenu   := LoWord(wPar);
Case wNrMenu Of

   101 :   if (wTimer1ID = 0) then begin
              nTrouveLast:=-1;
              nbNTrouve:=0;
              wTimer1ID:=SetTimer( hWin, 11, // 11 = a unique timer ID
                                   150,  // timeout in mili-seconds
                                   NIL);
              end;

   102 :   if (wTimer1ID = 0) then
              wTimer1ID:=SetTimer( hWin, 12, // 12 = a unique timer ID
                                   1100,  // timeout in mili-seconds
                                   NIL);

   103 :   if (wTimer1ID = 0) then begin
              nTrouveLast:=-1;
              nbNTrouve:=0;
              wTimer1ID:=SetTimer( hWin, 13, // 13 = a unique timer ID
                                   150,  // timeout in mili-seconds
                                   NIL);
              end;
   104 : begin
         // Stops the timer
         if (wTimer1ID > 0) then KillTimer(hWin, wTimer1ID);
         wTimer1ID:=0;
         end;

   106 : GetScreenImage;
   107 : CopyScreenImage;
   108 : begin
           nTrouveLast:=-1;
           nbNTrouve:=0;
           DetectNumber;
           end;

   // Parameters
   301 : DialogExecMSG(30199, @Self);

   // A help information
   901 : DialogExecMSG(90199, @Self);

   else WMCommand:=inherited WMCommand(wPar, lPar);
   end;  // Case NrMenu Of
end;  // TMyWindow.WMCommand

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//=======================================================================================
// All window messages are send here.
Begin
if (wMsg = WM_Timer) then WMTimer(wPar);

// Default processing of the messages.
WindowProc:=inherited WindowProc(hWindow, wMsg, wPar, lPar);
End;  // TMyWindow.WindowProc

//*****************************************************************
// TMyParamApplic = object(TParamApplic2)
//*****************************************************************

constructor TMyParamApplic.Init;
//==============================
begin
inherited Init;
end;  // TMyParamApplic.Init

procedure TMyParamApplic.SavePrmWrite(var fOut:text);
//===================================================
begin
// First let the parent write its parameters, then its your turn.
inherited SavePrmWrite(fOut);

{$i-}
writeln(fOut, '...Signature : Param of Main Application');
writeln(fOut, 102, '   = Version');

// Saves some parameters
writeln(fOut, poMyMainWin^.nXDelta:6,  ' ', poMyMainWin^.nYDelta:6, ' ',
              byte(poMyMainWin^.fDraw):3);
writeln(fOut, poMyMainWin^.xScrMin:6,  ' ', poMyMainWin^.xScrMax:6, ' ',
              poMyMainWin^.yScrMin:6,  ' ', poMyMainWin^.yScrMax:6);
writeln(fOut, poMyMainWin^.nLimWhite:6, ' ',
              byte(poMyMainWin^.fInfo):3);

end;  // TMyParamApplic.SavePrmWrite

procedure TMyParamApplic.LoadPrmRead(var fIn:text);
//=================================================
var
  strS        : ShortString;
  nErr,
  nVersion
              : integer;

begin
// First let the parent read its parameters, then its your turn.
inherited LoadPrmRead(fIn);

{$i-}
readln(fIn, strS);
// strS should equal '...Signature : Param of Main Application'

readln(fIn, nVersion);  nVersion:=nVersion;
readln(fIn, poMyMainWin^.nXDelta, poMyMainWin^.nYDelta,
            byte(poMyMainWin^.fDraw));

if (nVersion >= 101) then begin
  readln(fIn, poMyMainWin^.xScrMin, poMyMainWin^.xScrMax,
              poMyMainWin^.yScrMin, poMyMainWin^.yScrMax);
  end;

if (nVersion >= 102) then begin
  readln(fIn, poMyMainWin^.nLimWhite, byte(poMyMainWin^.fInfo));
  end;

nErr:=IOResult;
if (nErr <> 0) then begin
  DBW(1, 'Erreur de lecture des paramtres');
  exit; // error, not normal !?!
  end;
end;  // TMyParamApplic.LoadPrmRead

Begin // MAIN ******
// to use the application parameters defined here.
new(poMyAppPrm, Init);
gglpoPrm:=poMyAppPrm; // it will be destroyed in the TApplication automatically

// Name under which the main window is registered. Spaces are not allowed
oApp.Init('tEx083_Lecture_Ecriture_Ecran');

// Creation of the main window
new(poMyMainWin, Init('tEx083_Lecture_Ecriture_Ecran'));

// The App.WindowClass can be modified here, if wanted. (Not usual)
oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.
