{ Test de lecture de l'cran et d'criture sur l'cran
  Lecture de l'tat d'un d
  --------------------------------------------}
program tEx084_testeur_de_des;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses

  wApplication0
 ,wWindowText0 // To write text in an independent window
 ,wWindow0
 ,wDialog0
 ,wWindowBase0
 ,wDialogCreatorLow2
 ,wDialogCreator2
 ,wVariableNumLink2
// ,wUtiles0 // for the AccelTableMSGCreate function
 ,wGlobals2
 ,wParamApplic2
 ,wDebug0
 ,Windows
 ,commDlg;   { !!!  AJOUTER A LA VERSION 2.40 de Freeplascal, sinon problme !!! }

const
  MAX_IMAGE  = 2000;
  MAX_MESURE = 15000;

type
  PArrayImage = ^TArrayImage;
  TArrayImage = array[0..234,0..234] of TypeColor;

  PArrayMesure = ^TArrayMesure;
  TArrayMesure = array[0..MAX_MESURE] of byte;

  PArrayInt16 = ^TArrayInt16;
  TArrayInt16 = array[0..MAX_MESURE] of int16;

  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  pDialogActivate : PDialog;

  colGray : TypeColor;
  // Gray color of the cels.

  xScrMin     // rgion de l'cran vu
 ,xScrMax
 ,xScrDelta
 ,yScrMin
 ,yScrMax
 ,yScrDelta
 ,nLimWhite   // Limite de dtection du blanc
 ,yDetectMin  // pour la dtection du rectangle blanc de la bouteille
               : integer;

  nXDelta, nYDelta : integer;
  // number of pixels between two mine squares.

  nX_deltaMin  // Minimum des largeurs de points blancs trouvs, lors d'un jet
 ,nY_deltaMin  // Minimum des hauteur de points blancs trouvs
               : integer;

  fInfo       // indique s'il faut afficher des infos de dtection d'image
 ,fDraw       // indique s'il faut dessiner l'image
 ,fDrawBouteille // indique s'il faut dessiner le rectangle de recherche de bouteille
              : boolean;

  wNb_msStart : word32;
  // to set the starting time

  wTimer1ID : word32;
  // ID of the first timer
  // = 0 when stopped

  wTime_0     // temps en ms du dbut de la mise en mouvement de la bouteille
              : word32;

  // Pour mmoriser les images analyses.
  apaImage : array[0..MAX_IMAGE] of PArrayImage;
  nIndImage : integer; // nombre d'images mmorises,
                       // indique toujours le premier indice libre,
                       // le prcdent tant utilis.
  nIndImageLast : integer; // valeur avant la mesure en cours.

  // Pointeurs temporaires pour traiter les images
  paImgTmp1
             : PArrayImage;

  // pour mmoriser les rsultats des faces des ds
  pabDeVal  : PArrayMesure;
  pabDeVal2 : PArrayMesure; // valeur avec tolrance plus large de dtection des points
  panDeCptLance : PArrayInt16; // compteur de lancers

  nScrollPos : integer; // position du scroll vertical

  // somme des occurences des points des ds
  anSumX : array[0..6] of integer;
  nSumTot : integer;  // somme totale des mesures valides

  constructor Init(strWinTitlePrm:ShortString);
  destructor Done; virtual;

  procedure GetScreenImage;
  // Lecture de l'image  l'cran

  procedure CopyScreenImage;
  // Copie d'une portion de l'image de l'cran

  procedure CopyDePicture;
  // Copie l'image du d dans : apaImage[nIndImage mod MAX_IMAGE]^


  procedure TestPoint( nXLeft, nXRight, nY0, nDeltaMax:integer;
                       var nX_left, nX_delta, nY_left,
                           nY_top,  nY_delta, nX_top:integer);
  // Retourne dans nX_delta, nY_delta la taille maximale de la croix pouvant
  // tre place dans le point du d, dont nX0, nY0 fait partie.
  // Les pixels de (nXLeft,nY0)  (nXRight, nY0)  sont blancs

  procedure DetectNumber(var nTrouve,nTrouveLarge:integer);
  // Dtection du nombre sur le d
  // nTrouve = Nombre de points trouvs
  // nTrouveLarge = Nombre de zone blanche trouves, >= nTrouve.
  // Il devrait tre gale  nTrouve, sinon, il y a doute.
  // Si nTrouveLarge <> nTrouve, il y a doute sur la dtection des points.

  function DetectPositionOneTry:integer;
  // Dtection de la position de la bouteille
  // une seule fois
  // Retourne 0 si le point de dtection trouv.

  function DetectPosition(wTimeOut:word32):integer;
  // Dtection de la position de la bouteille
  // plusieurs fois
  // Retourne 0 si pas de problmes.

  procedure DoMeasurements;
  // Effectue des mesures, en dtectant la position de la bouteille
  // et en stockant les mesures dans un fichier.

  procedure WMTimer(wTimerID:WParam);
  // To handle the timer messages.

  procedure SaveFile;

  procedure OpenFile;

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  procedure WMPaint;
  // the system want the program to repaint the client area.

  procedure WMVScoll(wPar:WPARAM);
  // Handle the scoll bar messages

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

  PMyParamApplic = ^TMyParamApplic;
  TMyParamApplic = object(TParamApplic)
  //"""""""""""""""""""""""""""""""""""
  constructor Init;
//  destructor  Done; virtual;  use default

  // To save some parameters informations in the text file fOut
  // This is often overriden
  procedure SavePrmWrite(var fOut:text); virtual;

  // To load some parameters informations from the text file fIn
  // This is often overriden
  procedure LoadPrmRead(var fIn:text);  virtual;
  end; // TMyParamApplic = object(TParamApplic2)

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;
  poMyAppPrm  : PMyParamApplic;

// var nNotUsed : integer; // only to avoid an error message while compliling in DevPascal 1.9

procedure MySetWriteFont(nFont:integer);
//======================================
// dfini la police en courrier new
var
  strS        : string[80];
  astrFont    : array[1..4] of string[30];
  rLogFont    : TLogFont;
  pWinText    : PWindowText0;

begin
astrFont[1]:='Arial';
astrFont[2]:='Times New Roman';
astrFont[3]:='Courier New';
astrFont[4]:='Comic Sans MS';  // if you have it.

// define a new font.
strS:=astrFont[nFont]+#0;
with rLogFont do  begin
//   lfHeight         := 0;                // Default logical height of font
   lfWidth          := 0;                // Default logical average character width
   lfEscapement     := 0;                // angle of escapement
   lfOrientation    := 0;                // base-line orientation angle
   lfWeight         := FW_NORMAL;        // font weight = 400
   lfItalic         := 0;                // italic attribute flag
   lfUnderline      := 0;                // underline attribute flag
   lfStrikeOut      := 0;                // strikeout attribute flag
   lfCharSet        := DEFAULT_CHARSET;  // character set identifier
   lfOutPrecision   := OUT_DEFAULT_PRECIS;  // output precision
   lfClipPrecision  := CLIP_DEFAULT_PRECIS; // clipping precision
   lfQuality        := DEFAULT_QUALITY;     // output quality
   lfPitchAndFamily := DEFAULT_PITCH;    // pitch and family
   lfFaceName       :=PCHAR(@strS[1]);   // pointer to typeface name string
//   lfWeight:=400; // normal, could go up to 1000 for very bold
   lfHeight:=-12;
   end; // with

pWinText:=GetWriteWinNr(1);
if (pWinText <> NIL) then pWinText^.oRichEditFrame.SetActualFont(rLogFont);
//if (pWinText <> NIL) then pWinText^.oRichEditFrame.SetActualFont(pWinText^.oRichEditFrame.TheLogFont);
end; //  MySetWriteFont

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
var
  nn       : integer;

begin
inherited Init(strWinTitlePrm);
dwStyle := dwStyle or WS_VScroll; // to have a vertical scroll bar
nScrollPos:=0;

xScrMin:=30;
xScrDelta:=160;
xScrMax:=xScrMin+xScrDelta;
yScrMin:=50;
yScrDelta:=160;
yScrMax:=yScrMin+yScrDelta;
nLimWhite:=600;   // Limite de dtection du blanc
yDetectMin:=50;

nXDelta:=35;
nYDelta:=37;

fDraw:=true;
fDrawBouteille:=false;
fInfo:=true;
wTimer1ID :=0;
wTime_0   :=GetTickCount;

// Time in milliseconds since the computer started
wNb_msStart:=GetTickCount;

//Int32Field(  1001, ptTopLeft.x);
//Int32Field(  1002, ptTopLeft.y);
IntegerField(1001, nXDelta);
IntegerField(1002, nYDelta);
IntegerField(1003, xScrMin);
IntegerField(1004, xScrDelta);
IntegerField(1005, yScrMin);
IntegerField(1006, yScrDelta);
IntegerField(1007, nLimWhite);
IntegerField(1008, yDetectMin);

ByteField(1009, byte(fDraw));
ByteField(1010, byte(fInfo));

// Pour mmoriser les images analyses.
for nn:=0 to MAX_IMAGE do new(apaImage[nn]);
nIndImage :=0; // nombre d'images mmorises
nIndImageLast:=0;

new(pabDeVal);
new(pabDeVal2);
new(panDeCptLance);

// somme des occurences des points des ds
for nn:=0 to 6 do anSumX[nn]:=0;
nSumTot:=0;  // somme totale des mesures valides

// This line is all what is needed to have a status line.
new(poStatusLine, Init(@Self));
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//=========================
var nn : integer;
begin
dispose(panDeCptLance);
dispose(pabDeVal2);
dispose(pabDeVal);
for nn:=MAX_IMAGE downto 0 do dispose(apaImage[nn]);
inherited Done;
end;  // TMyWindow.Done

procedure TMyWindow.GetScreenImage;
//=================================
// Lecture de l'image  l'cran
var
  ptL         : TPoint;
  hDCScreen   : HDC;
  colPixel    : TypeColor;
begin
//DialogExecMSG(20399, @Self);

// Get Mouse position
GetCursorPos(@ptL);

// Get a device context of the screen
hDCScreen:=GetDC(0);

colPixel:= GetPixel(hDCScreen, ptL.x, ptL.y);

ReleaseDC(0, hDCScreen);

DBW(1, 'color=' + ITS5(colPixel.bRed) + ITS5(colPixel.bGreen) + ITS5(colPixel.bBlue));
end;  // TMyWindow.GetScreenImage

procedure TMyWindow.CopyScreenImage;
//==================================
// Copie d'une portion de l'image de l'cran
var
  ii,jj : integer;
  ptL         : TPoint;
  hDCScreen
 ,hDCWin      : HDC;
  colPixel    : TypeColor;
  nXMoy       // milieu de recherche en X
 ,nYMoy       // milieu de recherche en Y
 ,nXR         // moitier de xScrMax - xScrMin
 ,nYR         // moitier de yScrMax - yScrMin
 ,nYR2        // carr de nYR
 ,nXRadius
 ,nXSMin      // minimum de recherche selon X
 ,nXSMax      // maximum de recherche selon X
              : integer;

begin
// Get a device context of the screen
hDCScreen:=GetDC(0);
hDCWin   :=GetDC(hWin);

for ii:=xScrMin to xScrMax do begin
  ptL.x:=ii;
  for jj:=yScrMin to yScrMax do begin
    ptL.y:=jj;
    colPixel:= GetPixel(hDCScreen, ptL.x, ptL.y);
    SetPixel(hDCWin, ptL.x, ptL.y, colPixel);
    end;
  end;

nXMoy:= (xScrMax   + xScrMin) div 2;
nYMoy:= (yScrMax   + yScrMin) div 2;
nXR  := (xScrMax+1 - xScrMin) div 2;
nYR  := (yScrMax+1 - yScrMin) div 2;
nYR2 := sqr(nYR);
for jj:=yScrMin to yScrMax do begin
  ptL.y:=jj;

  // Copie une rgion elliptique
  nXRadius:=round(sqrt(nYR2 - sqr(jj-nYMoy)) * nXR / nYR);
  nXSMin:=nXMoy - nXRadius;
  nXSMax:=nXMoy + nXRadius;
  for ii:=nXSMin to nXSMax do begin
    ptL.x:=ii;
    colPixel:= GetPixel(hDCScreen, ptL.x, ptL.y);
    colPixel.bRed  :=32*((colPixel.bRed + colPixel.bGreen + colPixel.bBlue) div (3*32));
    colPixel.bGreen:=colPixel.bRed;
    colPixel.bBlue :=colPixel.bRed;
    SetPixel(hDCWin, ptL.x + xScrDelta, ptL.y, colPixel);
    end;
  end;

ReleaseDC(hWin, hDCWin);
ReleaseDC(0, hDCScreen);
end;  // TMyWindow.CopyScreenImage

procedure TMyWindow.CopyDePicture;
//================================
// Copie l'image du d dans : apaImage[nIndImageMod]^
var
  ii,jj,j0
 ,nIndImageMod
 ,nXMoy       // milieu de recherche en X
 ,nYMoy       // milieu de recherche en Y
 ,nXR         // moitier de xScrMax - xScrMin
 ,nYR         // moitier de yScrMax - yScrMin
 ,nYR2        // carr de nYR
 ,nXRadius
 ,nXSMin      // minimum de recherche selon X
 ,nXSMax      // maximum de recherche selon X
              : integer;
  colPixelDraw
              : TypeColor;
  hDCScreen
              : HDC;

begin // TMyWindow.CopyDePicture
// Get a device context of the screen
hDCScreen:=GetDC(0);

nIndImageMod:=nIndImage mod MAX_IMAGE;
paImgTmp1:=apaImage[nIndImageMod];

// Copie de l'image
for jj:=yScrMin to yScrMax do begin
  j0:=jj - yScrMin;
  for ii:=0 to xScrMax do begin
    paImgTmp1^[ii,j0]:= GetPixel(hDCScreen, ii, jj);
    end; // for ii
  end; // for jj

if fDraw then begin
  // dessine l'ellipse de recherche
  colPixelDraw.bReserved:=0;
  colPixelDraw.bRed  := 35;
  colPixelDraw.bGreen:=255;
  colPixelDraw.bBlue := 35;
  nXMoy:= (xScrMax   + xScrMin) div 2;
  nXR  := (xScrMax+1 - xScrMin) div 2;
  nYMoy:= (yScrMax+1 - yScrMin) div 2;
  nYR  := (yScrMax+1 - yScrMin) div 2;
  nYR2 := sqr(nYR);

  nIndImageMod:=nIndImage mod MAX_IMAGE;
  paImgTmp1:=apaImage[nIndImageMod];

  // Cherche des points blancs du D
  for jj:=2 to yScrDelta-2 do begin
    // recherche dans une rgion elliptique
    nXRadius:=round(sqrt(nYR2 - sqr(jj-nYMoy)) * nXR / nYR);
    nXSMin:=nXMoy - nXRadius;
    nXSMax:=nXMoy + nXRadius;
    paImgTmp1^[nXSMin,jj]:=colPixelDraw;
    paImgTmp1^[nXSMax,jj]:=colPixelDraw;
    end;
  end; // if fDraw then begin

ReleaseDC(0, hDCScreen);
end;  // TMyWindow.CopyDePicture

procedure TMyWindow.TestPoint( nXLeft, nXRight, nY0, nDeltaMax:integer;
                               var nX_left, nX_delta, nY_left,
                                   nY_top,  nY_delta, nX_top:integer);
//====================================================================
// Retourne dans nX_delta, nY_delta la taille maximale de la croix pouvant
// tre place dans le point du d, dont nX0, nY0 fait partie.
// Les pixels de (nXLeft,nY0)  (nXRight, nY0)  sont blancs
var
  ii,jj
 ,nCpt
 ,jTop
 ,jBot
 ,jMid
 ,jMidM1
 ,jMidP1
 ,iMid
 ,iMidM1
 ,iMidP1
 ,nIndImageMod
 ,nXDeltaM4   // = nXDelta - 4 ou -3
 ,nYDeltaM4   // = nYDelta - 4 ou -3
        : integer;
  colPixel
 ,colPixelDraw
              : TypeColor;
  fStop : boolean;

begin // TMyWindow.TestPoint
nIndImageMod:=nIndImage mod MAX_IMAGE;
paImgTmp1:=apaImage[nIndImageMod];

jMid  :=nY0;
nCpt:=0;

// Pour deux passages de recherches, si pas de bonne rgion trouve au premier passage
repeat
  inc(nCpt);
  nY0    :=jMid;

  iMid  :=(nXLeft + nXRight) div 2;
  iMidM1:=iMid-1;
  iMidP1:=iMid+1;

  jTop:=nY0;
  repeat
    // Dtection verticale, vers le haut, sur une largeur de 3 pixels
    dec(jTop);
    colPixel:= paImgTmp1^[iMid,jTop];
    fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
    if fStop then begin
      colPixel:= paImgTmp1^[iMidM1,jTop];
      fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
      if fStop then begin
        colPixel:= paImgTmp1^[iMidP1,jTop];
        fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
        end;
      end;
    until fStop or (jTop <= 0); // s'arrte car plus de pixels blancs dans la bande.
  inc(jTop);  // pixels blancs, jusqu'  jTop, vers le haut.

  jBot:=nY0;
  repeat
    // Dtection verticale, vers le bas, sur une largeur de 3 pixels
    inc(jBot);
    colPixel:= paImgTmp1^[iMid,jBot];
    fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
    if fStop then begin
      colPixel:= paImgTmp1^[iMidM1,jBot];
      fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
      if fStop then begin
        colPixel:= paImgTmp1^[iMidP1,jBot];
        fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
        end;
      end;
    until fStop or (jBot >= yScrMax - yScrMin);
  dec(jBot); // pixels blancs, de jTop  jBot.

  jMid  :=(jTop + jBot) div 2;  // milieu
  jMidM1:=jMid-1;
  jMidP1:=jMid+1;

  repeat
    // Dtection horizontale, vers la gauche, sur une largeur de 3 pixels
    dec(nXLeft);
    colPixel:= paImgTmp1^[nXLeft,jMid];
    fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
    if fStop then begin
      colPixel:= paImgTmp1^[nXLeft,jMidM1];
      fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
      if fStop then begin
        colPixel:= paImgTmp1^[nXLeft,jMidP1];
        fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
        end;
      end;
    until fStop or (nXLeft <= 1);
  inc(nXLeft);

  repeat
    // Dtection horizontale, vers la droite, sur une largeur de 3 pixels
    inc(nXRight);
    colPixel:= paImgTmp1^[nXRight,jMid];
    fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
    if fStop then begin
      colPixel:= paImgTmp1^[nXRight,jMidM1];
      fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
      if fStop then begin
        colPixel:= paImgTmp1^[nXRight,jMidP1];
        fStop   :=(colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite);
        end;
      end;
    until fStop or (nXRight >= xScrMax);
  dec(nXRight);  // pixels blancs, de nXLeft  nXRight.

  nY_delta:=jBot - jTop + 1; // Rgion horizontale dtecte
  nX_delta:=nXRight - nXLeft + 1;  // Rgion horizontale dtecte
  inc(nCpt);
  // Si la rgion est trop petite et qu'on a fait qu'un seul passage,
  // cherche encore une deuxime fois
  until ((nX_delta >= nXDelta) and (nY_delta >= nYDelta)) or (nCpt >= 2);

// Rgion verticale dtecte
nY_top  :=jTop;
nY_delta:=jBot - jTop + 1;
nX_top  :=iMid;

// Rgion horizontale dtecte
nX_left :=nXLeft;
nX_delta:=nXRight - nXLeft + 1;
nY_left :=jMid;

// dessine sur la partie d'image cherche
// Croix de dtection
nXDeltaM4:=nXDelta - 1 - (nXDelta div 4); // Pour tester les fausse dtection de points blancs
nYDeltaM4:=nYDelta - 1 - (nXDelta div 4);

colPixelDraw.bReserved:=0;
if (nX_delta >= nXDelta) and (nY_delta >= nYDelta) then begin
  colPixelDraw.bRed  :=35;
  colPixelDraw.bGreen:=35;
  colPixelDraw.bBlue :=35;
  end
else if (nX_delta >= nXDeltaM4) and (nY_delta >= nYDeltaM4) then begin
  colPixelDraw.bRed  :=253; // La couleur indique une rgion trop petite
  colPixelDraw.bGreen:=  0;
  colPixelDraw.bBlue :=  0;
  end
else begin
  colPixelDraw.bRed  :=  0; // La couleur indique une dtection avorte
  colPixelDraw.bGreen:=253;
  colPixelDraw.bBlue :=  0;
  end;

jj:=(jTop + jBot) div 2;
for ii:=nXLeft to nXRight do paImgTmp1^[ii,jj]:=colPixelDraw;
ii:=(nXLeft + nXRight) div 2;
for jj:=jTop to jBot do paImgTmp1^[ii,jj]:=colPixelDraw;

(*
// Pour indiquer le point de dpart
colPixelDraw.bRed  :=  0;
colPixelDraw.bGreen:=196;
colPixelDraw.bBlue :=  0;
paImgTmp1^[iMid,nY0]:=colPixelDraw;
*)
end; // TMyWindow.TestPoint

procedure TMyWindow.DetectNumber(var nTrouve,nTrouveLarge:integer);
//=================================================================
// Dtection du nombre sur le d
// nTrouve = Nombre de points trouvs
// nTrouveLarge = Nombre de zone blanche trouves, >= nTrouve.
// Il devrait tre gale  nTrouve, sinon, il y a doute.
// Si nTrouveLarge <> nTrouve, il y a doute sur la dtection des points.
var
  ii,jj,nn
 ,iiLeft
 ,iMid
              : integer;
  colPixel    : TypeColor;
  nSuivit     // nombre de pixels blancs qui se suivent
 ,nXDeltaM4   // = nXDelta - 4 ou -3
 ,nYDeltaM4   // = nYDelta - 4 ou -3
 ,nX_left     // Dbut de la ligne horizontale trouve
 ,nX_delta    // Largeur de la ligne horizontale trouve
 ,nY_left     // Position Y de la ligne horizontale trouve
 ,nY_top      // Dbut de la ligne verticale trouve
 ,nY_delta    // Largeur de la ligne verticale trouve
 ,nX_top      // Position X de la ligne verticale trouve
 ,nRegion     // Nombre de rgions ayant une zone blanche
 ,nXMoy       // milieu de recherche en X
 ,nYMoy       // milieu de recherche en Y
 ,nXR         // moitier de xScrMax - xScrMin
 ,nYR         // moitier de yScrMax - yScrMin
 ,nYR2        // carr de nYR
 ,nXRadius
 ,nXSMin      // minimum de recherche selon X
 ,nXSMax      // maximum de recherche selon X
 ,nIndImageMod
               : integer;
  anXMin      // zone de rgion ayant du "blanc" explore
 ,anXMax
 ,anYMin
 ,anYMax
              : array[0..031] of integer;

begin // TMyWindow.DetectNumber
CopyDePicture;

nX_deltaMin:=112;
nY_deltaMin:=112;
nXDeltaM4:=nXDelta - 1 - (nXDelta div 4); // Pour tester les fausse dtection de points blancs
nYDeltaM4:=nYDelta - 1 - (nXDelta div 4);

nXMoy:= (xScrMax   + xScrMin) div 2;
nXR  := (xScrMax+1 - xScrMin) div 2;
nYMoy:= (yScrMax+1 - yScrMin) div 2;
nYR  := (yScrMax+1 - yScrMin) div 2;
nYR2 := sqr(nYR);

// zones ou des points ont t trouvs
nRegion:=0;
nTrouve:=0;  // nombre de points trouvs
nTrouveLarge:=0;
anXMin[0]:=0;
anXMax[0]:=0;
anYMin[0]:=0;
anYMax[0]:=0;

nIndImageMod:=nIndImage mod MAX_IMAGE;
paImgTmp1:=apaImage[nIndImageMod];

// Cherche des points blancs du D
for jj:=2 to yScrMax-yScrMin-2 do begin
  // recherche dans une rgion elliptique
  nXRadius:=round(sqrt(nYR2 - sqr(jj-nYMoy)) * nXR / nYR);
  nXSMin:=nXMoy - nXRadius;
  nXSMax:=nXMoy + nXRadius;
  ii:=nXSMin;
  repeat
    // Saute les pixels non proche du blanc
    repeat
      inc(ii);
      colPixel:=paImgTmp1^[ii,jj];
      until (colPixel.bRed + colPixel.bGreen + colPixel.bBlue >= nLimWhite) or
            (ii >= nXSMax);

    // Si (ii, jj) est dans une zone blanche dj traite, alors on saute cette zone.
    for nn:=1 to nRegion do begin
      if ( (jj >= anYMin[nn]) and (jj <= anYMax[nn]) and
           (ii >= anXMin[nn]) and (ii <= anXMax[nn]) ) then begin
         ii:=anXMax[nn]+1;
         end;
      end; // for nn:=..

    // Compte le nombre de pixels proche du blanc qui se suivent
    iiLeft:=ii;
    nSuivit:=0;
    repeat
      inc(nSuivit);
      inc(ii);
      colPixel:=paImgTmp1^[ii,jj];
      until (colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite) or
            (ii >= nXSMax);
    // De iiLeft  ii-1 les points sont blancs.

    if (nSuivit >= nXDeltaM4) and (nSuivit <= 24) then begin
      // Une zone de pixels blancs dtecte, test si elle correspond  un point.

      // Test si on est dans une zone blanche dj traite, alors on saute cette zone.
      iMid:=(iiLeft + ii) div 2;
      for nn:=1 to nRegion do begin
        if ( (jj >= anYMin[nn]) and (jj <= anYMax[nn]) and
             (iMid >= anXMin[nn]) and (iMid <= anXMax[nn]) ) then begin
           ii:=anXMax[nn]+1;
           nSuivit:=0;  // annule la dtection de la zone
           end;
        end; // for nn:=..

      if (nSuivit >= nXDeltaM4) then begin

        TestPoint( iiLeft, ii-1, jj, 24,
                   nX_left, nX_delta, nY_left, nY_top, nY_delta, nX_top);

        // Mmorise la rgion teste
        if (nRegion < 031) then inc(nRegion);
        anXMin[nRegion]:=nX_left;
        anXMax[nRegion]:=nX_left + nX_delta;
        anYMin[nRegion]:=nY_top;
        anYMax[nRegion]:=nY_top + nY_delta;

        if fInfo and ((nX_delta < nXDelta) or (nY_delta < nYDelta)) then
           DBW(1, 'Petit en :' + ITS5(nX_left)  + ITS5(nY_top)
                               + ITS5(nX_delta) + ITS5(nY_delta)
                               );

        if (nX_delta >= nXDeltaM4) and (nY_delta >= nYDeltaM4) then begin
          // Zone trouve, test si c'est une zone douteuse, car petite, ou
          // si c'est une zone contenant un point blanc, assez surement.
          inc(nTrouveLarge);

          if (nX_delta >= nXDelta) and (nY_delta >= nYDelta) then begin
            // Ici, assez surement la zone contient un point blanc du d.
            inc(nTrouve);
            if fInfo then DBW(1, 'Trouv en :' + ITS5(nX_left)  + ITS5(nY_top)
                                               + ITS5(nX_delta) + ITS5(nY_delta)
                                               );

            // Mmorise la plus petite dimension des points trouvs
            if (nX_deltaMin > nX_delta) then nX_deltaMin:=nX_delta;
            if (nY_deltaMin > nY_delta) then nY_deltaMin:=nY_delta;
            end;
          end;
        end; // if (nSuivit >= nXDeltaM4)
      end; // if (nSuivit >= nXDeltaM4) and (nSuivit <= 24)
    until (ii >= nXSMax);
  end; // for jj
end;  // TMyWindow.DetectNumber

function TMyWindow.DetectPositionOneTry:integer;
//==============================================
// Dtection de la position de la bouteille
// Retourne 0 si le point de dtection trouv.
var
  colPixel    : TypeColor;
  ii,jj
 ,iiLeft
 ,nSuivit     // nombre de pixels blancs qui se suivent
 ,nX_left     // position du point trouv
 ,nX_delta
 ,nY_left
 ,nY_top
 ,nY_delta
 ,nX_top
 ,nXSL
 ,nXSR
 ,nYST
 ,nYSB
 ,nLimWhite0
 ,nIndImageMod
               : integer;
  hDCScreen
              : HDC;

begin // TMyWindow.DetectPositionOneTry
// Limites de recherches
nLimWhite0:=680;
nXSL:=1;
nXSR:=xScrMin-2;
nYST:=yDetectMin;
nYSB:=yDetectMin+50;

nIndImageMod:=nIndImage mod MAX_IMAGE;
paImgTmp1:=apaImage[nIndImageMod];

// Copie de l'image, pour voir
if fDrawBouteille then begin
  // Get a device context of the screen
  hDCScreen:=GetDC(0);

  for jj:=nYST to nYSB do begin
    for ii:=nXSL to nXSR do begin
    colPixel:=paImgTmp1^[ii,jj];

      if (colPixel.bRed + colPixel.bGreen + colPixel.bBlue > nLimWhite0) then begin
        colPixel.bRed  :=255;
        colPixel.bGreen:=255;
        colPixel.bBlue :=255;
        SetPixel(hDCScreen, ii+261, jj-yScrMin+211, colPixel);
        end
      else begin
        colPixel.bRed  :=0;
        colPixel.bGreen:=0;
        colPixel.bBlue :=0;
        SetPixel(hDCScreen, ii+261, jj-yScrMin+211, colPixel);
        end;
      end; // for ii
    end; // for jj

  ReleaseDC(0, hDCScreen);
  end; // if fDrawBouteille then ...

// Cherche un point blanc, signal de position de la bouteille
// bonne pour la lecture du d.
for jj:=nYST to nYSB do begin
  ii:=nXSL;

    // Saute les pixels non proche du blanc
    repeat
      inc(ii);
      colPixel:=paImgTmp1^[ii,jj];
      until (colPixel.bRed + colPixel.bGreen + colPixel.bBlue >= nLimWhite) or
            (ii >= nXSR);

    // Compte le nombre de pixels proche du blanc qui se suivent
    iiLeft:=ii;
    nSuivit:=0;
    repeat
      inc(nSuivit);
      inc(ii);
      colPixel:=paImgTmp1^[ii,jj];
      until (colPixel.bRed + colPixel.bGreen + colPixel.bBlue < nLimWhite) or
            (ii >= nXSR);
    // De iiLeft  ii-1 les points sont blancs.

    if (nSuivit >= 018) then begin
      // Une zone de pixels blancs dtecte, test si elle correspond  un point.
      TestPoint( iiLeft, ii-1, jj, 40,
                 nX_left, nX_delta, nY_left, nY_top, nY_delta, nX_top);

      if (nY_delta >=018) then begin
        // point trouv
        if fInfo then DBW(1, 'Dtect en :' + ITS5(nX_left) + ITS5(nY_top)
                                           + ITS5(nX_delta)  + ITS5(nY_delta)
                                           );
        DetectPositionOneTry:=0; // OK
        exit(0);
        end
      end; // if (nSuivit >= 018)
  end; // for jj

DetectPositionOneTry:=1; // Pas de dtection de point blanc
end;  // TMyWindow.DetectPositionOneTry

function TMyWindow.DetectPosition(wTimeOut:word32):integer;
//=========================================================
// Dtection de la position de la bouteille
// Retourne 0 si pas de problmes.
var
  nPos        // Indique si la bouteille a t dtecte dans la bonne
              // position pour effectuer une mesure.
 ,nn
              : integer;
  wTime_1     // temps  l'entre dans la procdure
 ,wTime_2     // temps dans la boucle de dterction de position de bouteille
              : word32;

begin // TMyWindow.DetectPosition
// Time in milliseconds since the computer started
wTime_1:=GetTickCount;

nn:=0;
// A tester durant wTimeOut [ms] si la position de la bouteille est OK
repeat
  inc(nn);
  CopyDePicture;
  nPos:=DetectPositionOneTry;
  wTime_2:=GetTickCount;
  until (nPos = 0) or (wTime_2 > wTime_1 + wTimeOut);

DetectPosition:=nPos; // nPos = 0 est le cas normal, sinon erreur de
                      // dtection de la position de la bouteille.
nn:=nn; // pour liminer des warnings
//DBW(1, 'DetectPos, nn=' + ITS5(nPos) + ITS5(nn) + ITS(wTime_2 - wTime_1));
end;  // TMyWindow.DetectPosition

procedure TMyWindow.DoMeasurements;
//=================================
// Effectue des mesures, en dtectant la position de la bouteille
// et en stockant les mesures dans un fichier.
// Cette procdure est appele par le timer, quelques diximes
// de secondes avant que la bouteille soit stable pour
// permettre une mesure de la valeur du d.
var
  wTime_1     // temps  l'entre dans la procdure
 ,wTime_2
 ,wTime_3
              : word32;
  nTrouve_1   // lecture de la valeur du d
 ,nTrouve_1_Large
 ,nTrouve_2   // valeur du d
 ,nTrouve     // valeur retenue du d
 ,nbImageDiff_1 // nombre de valeurs lue diffrentes, avant stabilisation
 ,nbImageDiff_2 // nombre de valeurs lue diffrentes, aprs stabilisation
 ,nbImageEgale  // nombre de valeurs lue identiques, celle qui sera retenue
 ,nOK
 ,nIndImageOK  // image garde pour montrer une qui donne le bon nombre de points
 ,nIndImageMod
 ,nIndImageOKMod
 ,nn
 ,nX_deltaMinMem
 ,nY_deltaMinMem
              : integer;
  rRec        : RECT;
  rMessage    : Msg;

begin // TMyWindow.DoMeasurements
wTime_1:=GetTickCount;  // heure d'arrive dans la procdure

if (nSumTot = 0) then  WriteWin(3, ''); // Pour ouvrir la fentre


nIndImageLast:=nIndImage;

// Attente que la bouteille hors de la vue de la camra
repeat
  // Permet de grer les messages
  PeekMessage( @rMessage, 0, // any messages for this application
               0, 0,         // Let the dialog box being updated
               PM_REMOVE);  // remove the message from the queue
  TranslateAccelerator( gglpoMainWindow^.hWin,
                         gglpoApplication^.hAccelTable, rMessage);  // pour traiter des acclrateurs
  TranslateMessage(rMessage);
//        DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
  if (rMessage.message = WM_CLOSE) then exit;
  DispatchMessage(rMessage);
  if (wTimer1ID <> 1111) then exit;

  CopyDePicture;
  nOK:=DetectPositionOneTry;
  until (nOK <> 0);

// Attente d'arrive de la bouteille en vue de la camra
repeat
  // Permet de grer les messages
  PeekMessage( @rMessage, 0, // any messages for this application
               0, 0,         // Let the dialog box being updated
               PM_REMOVE);  // remove the message from the queue
  TranslateAccelerator( gglpoMainWindow^.hWin,
                         gglpoApplication^.hAccelTable, rMessage);  // pour traiter des acclrateurs
  TranslateMessage(rMessage);
//        DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
  if (rMessage.message = WM_CLOSE) then exit;
  DispatchMessage(rMessage);
  if (wTimer1ID <> 1111) then exit;

  CopyDePicture;
  nOK:=DetectPositionOneTry;
  until (nOK = 0);

wTime_2:=GetTickCount;  // heure de dtection du point blanc de la bouteille

// Lecture du nombre sur le d
nn:=0;
nbImageEgale  :=1; // on compte le nombre de transistions entre images identiques
nbImageDiff_1 :=0; // nombre d'images diffrentes, avant stabilisation
nbImageDiff_2 :=0; // nombre d'images diffrentes, aprs stabilisation
nTrouve   :=0;
nIndImageOK:=0;
DetectNumber(nTrouve_1, nTrouve_1_Large);
pabDeVal^[nIndImage]:=nTrouve_1;
pabDeVal2^[nIndImage]:=nTrouve_1_Large;
panDeCptLance^[nIndImage]:=nSumTot+1;
repeat
  inc(nn);
  nTrouve_2 :=nTrouve_1;
  inc(nIndImage); // nombre de mesures mmorises.
  DetectNumber(nTrouve_1, nTrouve_1_Large);
  pabDeVal^[nIndImage]:=nTrouve_1;
  pabDeVal2^[nIndImage]:=nTrouve_1_Large;
  panDeCptLance^[nIndImage]:=nSumTot+1;

  // l'image du d est-elle stable pour dtecter le mme nombre ?
  if (nTrouve_1 <> nTrouve_2) or (nTrouve_1 <> nTrouve_1_Large) or
     (nbImageDiff_2 > 0) then begin
    // Non l'image n'est pas stable ou pas bien dfinie
    if (nbImageEgale < 004) then begin
      // Il n'y a pas encore eu stabilisation de la bouteille
      nbImageDiff_1:=nbImageDiff_1 + nbImageEgale; // nombre d'images diffrentes
      nbImageEgale:=1;
      nTrouve:=0; // pas de valeur de d retenue
      end
    else begin
      // Il y a dj eu stabilisation, se sont donc les images avant le
      // dpart iminant de la bouteille qui sont comptabilites.
      inc(nbImageDiff_2);
      end;
    end
  else begin // Ici nTrouve_1 = nTrouve_2  et  nTrouve_1 = nTrouve_1_Large
    // on compte le nombre d'images qui donnent le mme nombre de points
    inc(nbImageEgale);
    nTrouve:=nTrouve_1; // Mmorise la valeur trouve
    if (nbImageEgale = 004) then begin
      nIndImageOK:=nIndImage; // Mmorise une image de rfrence
      nX_deltaMinMem:=nX_deltaMin;
      nY_deltaMinMem:=nY_deltaMin;
      end;
    end;

  nOK:=DetectPositionOneTry;
  until ((nOK <> 0) and (nn >= 6)) or (nn >= 20);
  // Au moins 6 lectures d'images, au maximum 20 lectures d'images
  // Ici, la bouteille est reparti hors de la vue de la camra ou
  // il elle est reste trop longtemps

// Indique la premire zone libre pour stocker une image
inc(nIndImage);

// Mmorise le temps de dpart de la bouteille
wTime_3:=GetTickCount;

if (nbImageEgale >= 004) then begin
  // Nombre de points bien dtect
  panDeCptLance^[nIndImageLast]:=nSumTot+1;
  pabDeVal^[nIndImageLast]:=nTrouve;
  pabDeVal2^[nIndImageLast]:=nTrouve; // = nTrouve_Large  Ici

  // Echange de pointeurs pour mmoriser la bonne image
  nIndImageMod  :=nIndImageLast mod MAX_IMAGE;
  nIndImageOKMod:=nIndImageOK   mod MAX_IMAGE;
  paImgTmp1               :=apaImage[nIndImageMod];
  apaImage[nIndImageMod]  :=apaImage[nIndImageOKMod];
  apaImage[nIndImageOKMod]:=paImgTmp1;
  nIndImage:=nIndImageLast+1;

  // Une mesure valide
  inc(anSumX[nTrouve]);
  inc(nSumTot);  // somme totale des mesures valides

  if (nTrouve >= 1) and (nTrouve <= 6) then begin
    // Bonne dtection, que l'on mmorise
    if (nSumTot mod 100 = 0) then
      WriteWin(3, ITS5(nSumTot)
                + ITS5(anSumX[1])
                + ITS5(anSumX[2])
                + ITS5(anSumX[3])
                + ITS5(anSumX[4])
                + ITS5(anSumX[5])
                + ITS5(anSumX[6])
                + ITS5(anSumX[0])
                );

    WriteWin(2, ITS5(nSumTot)+ ITS5(nTrouve)
                + FloatToStr((6*anSumX[1] - nSumTot) / sqrt(5*nSumTot),10,4)
                + FloatToStr((6*anSumX[2] - nSumTot) / sqrt(5*nSumTot),10,4)
                + FloatToStr((6*anSumX[3] - nSumTot) / sqrt(5*nSumTot),10,4)
                + FloatToStr((6*anSumX[4] - nSumTot) / sqrt(5*nSumTot),10,4)
                + FloatToStr((6*anSumX[5] - nSumTot) / sqrt(5*nSumTot),10,4)
                + FloatToStr((6*anSumX[6] - nSumTot) / sqrt(5*nSumTot),10,4)
                );

  (*
    WriteWin(2, ITS5(nSumTot)+ ITS5(nTrouve)
                + FloatToStr((5*anSumX[1] - nSumTot) / sqrt(4*nSumTot),10,4)
                + FloatToStr((5*anSumX[2] - nSumTot) / sqrt(4*nSumTot),10,4)
                + FloatToStr((5*anSumX[3] - nSumTot) / sqrt(4*nSumTot),10,4)
                + FloatToStr((5*anSumX[4] - nSumTot) / sqrt(4*nSumTot),10,4)
                + FloatToStr((5*anSumX[5] - nSumTot) / sqrt(4*nSumTot),10,4)
                );
  *)
    // Information de dveloppements
    WriteWin(1, 'D=' + ITS5(nSumTot) + ITS3(nTrouve)
                + ITS4(nX_deltaMinMem) + ITS4(nY_deltaMinMem)
                + ITS3(nbImageDiff_1) + ITS3(nbImageEgale) + ITS3(nbImageDiff_2)
                + ITS(wTime_2 - wTime_1) // dure de bouteille hors camra
                + ITS(wTime_3 - wTime_2) // dure de bouteille devant camra
                + ITS(wTime_1 - wTime_0) // dure d'un cycle complet
                );
    end;
  end;

// Test s'il y a eu un problme de dtection
if (nTrouve <= 0) or (nTrouve >= 7) or (nbImageEgale < 004) then begin
  // il y a eu un problme, soit le d est mal plac, soit ?
  inc(anSumX[0]);
  DBW(1, 'Probl=' + ITS5(nSumTot+1) + ITS3(nTrouve)
         + ITS3(nbImageDiff_1) + ITS3(nbImageEgale) + ITS3(nbImageDiff_2)
         );

// Pour le dveloppement
(*
  WriteWin(1, 'D =' + ITS5(nIndImage) + ITS5(nTrouve)
              + ITS5(nbImageDiff_1) + ITS(nbImageEgale) + ITS5(nbImageDiff_2)
              + ITS(wTime_2 - wTime_1) // dure de bouteille hors camra
              + ITS(wTime_3 - wTime_2) // dure de bouteille devant camra
              + ITS(wTime_1 - wTime_0) // dure d'un cycle complet
              );
*)
  end;

SetScrollRange(
    hWin,	// handle of window with scroll bar
    SB_VERT, // scroll bar flag
    0, // minimum scrolling position
    nIndImage, // maximum scrolling position
    true 	// redraw flag
    );

if (nScrollPos >= nIndImageLast) then begin
  nScrollPos:=nIndImage;
  SetScrollPos(
      hWin,	// handle of window with scroll bar
      SB_VERT,	// scroll bar flag
      nIndImage,	// new position of scroll box
      true 	// redraw flag
      );
  // ask to redraw the complete window
  GetClientRect(hWin, rRec); // get the size of the client area, to redraw it
  invalidateRect(hWin, rRec, TRUE); // TRUE => redraw the backgroud (white) also
  PostMessage(hWin, WM_PAINT, 0, 0);
  end;

// Mmorise l'heure du dernier dpart de la bouteille.
wTime_0:=wTime_1;

// demande de revenir dans la procedure de mesure.
if (wTimer1ID = 1111) then PostMessage(hWin, WM_COMMAND, 101, 0);
end;  // TMyWindow.DoMeasurements

procedure TMyWindow.WMTimer(wTimerID:WParam);
//===========================================
// To handle the timer messages.
var
  wNb_ms      : word32;
//  rSysTime    : SYSTEMTIME;
  strS        : string;
  nTrouve
 ,nTrouveLarge
              : integer;

begin
if (wTimerID = 19) then begin
   // time in mili-seconds since Windows started minus the time when
   // the start button has been pressed.
   wNb_ms:=GetTickCount - wNb_msStart;

   strS:='Time = ' + IntToStr(wNb_ms div 1000, 4) + '.'
                           + IntToStr((wNb_ms mod 1000) div 100, 1) + ' sec';
   DBW(1, strS);
   end;

if (wTimerID = 12) then begin
  DetectNumber(nTrouve, nTrouveLarge);
  DBW(1, 'Nombre trouve =' + ITS5(nTrouve) + ITS5(nTrouveLarge));
  end;

// if (wTimerID = 11) then DoMeasurements;  // PLUS UTILISE

end;  // TMyWindow.WMTimer

{$i tEx084_testeur_save_load_INC.pp}

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// Handles the menu messages
Var
  wNrMenu     : word;
  nOK
 ,nTrouve
 ,nTrouveLarge
              : integer;
  rRec        : RECT;

begin
WMCommand := 0; // Default return value when processing a message

if (lPar <> 0) then begin
   // call the parent WMCommand method.
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;

// for the menus,  lPar = 0
//=========================
wNrMenu   := LoWord(wPar);
Case wNrMenu Of

   101 : begin
         wTimer1ID:=1111;  // pour indiquer que des mesures sont en cours
         DoMeasurements;
         end;

   102 :   if (wTimer1ID = 0) then begin
              // mesures en continue, pour des tests.
              wTimer1ID:=SetTimer( hWin, 12, // = a unique timer ID
                                   150,  // timeout in mili-seconds
                                   NIL);
              end;

   119 :   if (wTimer1ID = 0) then
               wTimer1ID:=SetTimer( hWin, 19, // = a unique timer ID
                                    1110,  // timeout in mili-seconds
                                    NIL);
   104 : begin
         // Stops the timer
         if (wTimer1ID > 0) and (wTimer1ID < 1111) then KillTimer(hWin, wTimer1ID);
         wTimer1ID:=0;
         DBW(1, 'STOP TIMER');
         end;
   105 : begin
         fDrawBouteille:=true;
         DBW(1, 'DetectPosition=' + ITS5(DetectPosition(500)));
         fDrawBouteille:=false;
         end;
   106 : GetScreenImage;
   107 : CopyScreenImage;
   108 : begin
         // une mesure
         DetectNumber(nTrouve, nTrouveLarge);
         nOK:=DetectPositionOneTry;
         pabDeVal^[nIndImage]:=nTrouve;
         pabDeVal2^[nIndImage]:=nTrouveLarge;
         panDeCptLance^[nIndImage]:=nSumTot;

         if (nTrouve >= 1) and (nTrouve <= 6) then begin
           inc(anSumX[nTrouve]);
           inc(nSumTot);  // somme totale des mesures valides
           end;

         inc(nIndImage);
         WriteWin(1, 'OK=' + ITS3(nOK) + ITS5(nIndImage)
                           + ITS3(nTrouve) + ITS3(nTrouveLarge)
                           + ITS4(nX_deltaMin) + ITS4(nY_deltaMin)
                           );
         SetFocus(hWin);

nScrollPos:=nIndImage;
SetScrollRange(
    hWin,	// handle of window with scroll bar
    SB_VERT, // scroll bar flag
    0, // minimum scrolling position
    nIndImage, // maximum scrolling position
    true 	// redraw flag
    );
SetScrollPos(
    hWin,	// handle of window with scroll bar
    SB_VERT,	// scroll bar flag
    nIndImage,	// new position of scroll box
    true 	// redraw flag
    );

         // ask to redraw the complete window
         GetClientRect(hWin, rRec); // get the size of the client area, to redraw it
         invalidateRect(hWin, rRec, TRUE); // TRUE => redraw the backgroud (white) also
         end;

    121 : SaveFile;
    122 : OpenFile;

   // Parameters
   301 : begin
         DialogExecMSG(30199, @Self);
         xScrMax:=xScrMin+xScrDelta;
         yScrMax:=yScrMin+yScrDelta;

         if (xScrMax >= 234) then begin
           xScrMax:=234-1;
           xScrDelta:=xScrMax - xScrMin;
           end;
         if (yScrDelta >= 234) then begin
           yScrDelta:=234-1;
           yScrMax:=yScrMin+yScrDelta;
           end;
         end;

   302 : fDraw:=not fDraw;


   // A help information
   901 : DialogExecMSG(90199, @Self);

   else WMCommand:=inherited WMCommand(wPar, lPar);
   end;  // Case NrMenu Of
end;  // TMyWindow.WMCommand

procedure TMyWindow.WMPaint;
//==========================
Var
  hDcPaint    : hdc;
  rPS         : paintstruct;
  strS        : String;
  nn,i0,j0
 ,nScrLeft
 ,nScrTop
 ,nIndImageMod
 ,nNbImageHoriz
 ,nNbImageVert
              : integer;
  rRec        : RECT;
              // rRec.Right  = largeur de la fentre client
              // rRec.Bottom = hauteur de la fentre client

begin // TMyWindow.WMPaint
// Get a device context.
// Here we have a facility, during the WMPaint, we must always
// begin with  "BeginPaint", which gives a Device Context to paint, and
// end with "EndPaint", to tell that the painting is done.
if (nIndImage < 1) then exit;

GetClientRect(hWin, @rRec);
nClientWidth  :=rRec.Right;
nClientHeight :=rRec.Bottom;

nNbImageHoriz:=(rRec.Right  -  2) div (xScrMax+40);
nNbImageVert :=(rRec.Bottom - 22) div (yScrDelta+4);

hDcPaint:=BeginPaint(hWin, @rPS);

nn:=nScrollPos - nNbImageHoriz * nNbImageVert;
if (nn < 0) then nn:=0;

nScrTop := 0;
nScrLeft:= 0;
repeat
  strS:=IntToStr(panDeCptLance^[nn],5);
  TextOut(hDcPaint, 1+nScrLeft, 20+nScrTop, @strS[1], length(strS));
  strS:=IntToStr(pabDeVal^[nn],5);
  TextOut(hDcPaint, 1+nScrLeft, 40+nScrTop, @strS[1], length(strS));
  strS:=IntToStr(pabDeVal2^[nn],5);
  TextOut(hDcPaint, 1+nScrLeft, 60+nScrTop, @strS[1], length(strS));

  nIndImageMod:=nn mod MAX_IMAGE;
  paImgTmp1:=apaImage[nIndImageMod];
    for j0:=0 to yScrDelta do
      for i0:=0 to xScrMax do begin
        SetPixel(hDcPaint, i0+38+nScrLeft, j0+nScrTop, paImgTmp1^[i0,j0]);
        end;

  nScrLeft:=nScrLeft+xScrMax+40;
  if (nScrLeft + xScrMax + 42 > rRec.Right) then begin
    // passage  la ligne suivante
    nScrLeft:=0;
    nScrTop:=nScrTop + yScrDelta+4;
    end;

  inc(nn);
  until (nn >= nIndImage) or (nScrTop+yScrDelta+26 >= rRec.Bottom);

EndPaint(hWin, rPS);
end;  // TMyWindow.WMPaint

procedure TMyWindow.WMVScoll(wPar:WPARAM);
//========================================
// Handle the scoll bar messages
var
  nScrollCode
 ,nPos
 ,nNbImageHoriz
 ,nNbImageVert
             : integer;
  rRec        : RECT;

begin
nScrollCode:= LoWord(wPar);
nPos:= HiWord(wPar);

GetClientRect(hWin, @rRec);
nClientWidth  :=rRec.Right;
nClientHeight :=rRec.Bottom;

nNbImageHoriz:=(rRec.Right  -  2) div (xScrMax+40);
nNbImageVert :=(rRec.Bottom - 22) div (yScrDelta+4);

if (nScrollCode <> SB_THUMBPOSITION) and
   (nScrollCode <> SB_THUMBTRACK) then
   nPos:=GetScrollPos(
          hWin, // handle of window with scroll bar
          SB_VERT // scroll bar flags
          );

case nScrollCode of
  SB_TOP      : nPos:=0; // Scrolls to the upper left.
  SB_BOTTOM   : nPos:=nIndImage; // Scrolls to the lower right.
  SB_LINEDOWN : begin // Scrolls one line down.
                nPos:=nPos + nNbImageHoriz;

                end;
  SB_LINEUP : begin // Scrolls one line up.
                nPos:=nPos - nNbImageHoriz;
                end;
  SB_PAGEDOWN : begin // Scrolls one page down.
                nPos:=nPos + nNbImageHoriz * nNbImageVert;
                end;
  SB_PAGEUP : begin // Scrolls one page up.
                nPos:=nPos - nNbImageHoriz * nNbImageVert;
                end;

//  SB_THUMBPOSITION Scrolls to the absolute position. The current
//  position is specified by the nPos parameter.
//  SB_THUMBTRACK Drags scroll box to the specified position. The
//                current position is specified by the nPos parameter.
  SB_ENDSCROLL : begin // Ends scroll, on a terminer le scroll
     // ask to redraw the complete window
     GetClientRect(hWin, rRec); // get the size of the client area, to redraw it
     invalidateRect(hWin, rRec, TRUE); // TRUE => redraw the backgroud (white) also
     end;

  end; // case

if (nPos < 0       ) then nPos:=0;
if (nPos > nIndImage) then nPos:=nIndImage;

nScrollPos:=nPos;  // Mmorisation de la position du scroll vertical

SetScrollPos(
    hWin,	// handle of window with scroll bar
    SB_VERT,	// scroll bar flag
    nPos,	// new position of scroll box
    true 	// redraw flag
    );
end; // TMyWindow.WMVScoll

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//=======================================================================================
// All window messages are send here.
Begin
if (wMsg = WM_Timer) then WMTimer(wPar);
Case wMsg Of
   WM_Paint   : WMPaint; // must redraw the client area part.
   WM_Timer   : WMTimer(wPar);
   WM_VSCROLL : WMVScoll(wPar);
   End; // Case wMsg Of

// Default processing of the messages.
WindowProc:=inherited WindowProc(hWindow, wMsg, wPar, lPar);
End;  // TMyWindow.WindowProc

//*****************************************************************
// TMyParamApplic = object(TParamApplic2)
//*****************************************************************

constructor TMyParamApplic.Init;
//==============================
begin
inherited Init;
end;  // TMyParamApplic.Init

procedure TMyParamApplic.SavePrmWrite(var fOut:text);
//===================================================
begin
// First let the parent write its parameters, then its your turn.
inherited SavePrmWrite(fOut);

{$i-}
writeln(fOut, '...Signature : Param of Main Application');
writeln(fOut, 103, '   = Version');

// Saves some parameters
writeln(fOut, poMyMainWin^.nXDelta:6,  ' ', poMyMainWin^.nYDelta:6, ' ',
              byte(poMyMainWin^.fDraw):3);
writeln(fOut, poMyMainWin^.xScrMin:6,  ' ', poMyMainWin^.xScrDelta:6, ' ',
              poMyMainWin^.yScrMin:6,  ' ', poMyMainWin^.yScrDelta:6);
writeln(fOut, poMyMainWin^.nLimWhite:6, ' ',
              byte(poMyMainWin^.fInfo):3);
writeln(fOut, poMyMainWin^.yDetectMin:6);

end;  // TMyParamApplic.SavePrmWrite

procedure TMyParamApplic.LoadPrmRead(var fIn:text);
//=================================================
var
  strS        : ShortString;
  nErr,
  nVersion
              : integer;

begin
// First let the parent read its parameters, then its your turn.
inherited LoadPrmRead(fIn);

{$i-}
readln(fIn, strS);
// strS should equal '...Signature : Param of Main Application'

readln(fIn, nVersion);  nVersion:=nVersion;
readln(fIn, poMyMainWin^.nXDelta, poMyMainWin^.nYDelta,
            byte(poMyMainWin^.fDraw));

readln(fIn, poMyMainWin^.xScrMin, poMyMainWin^.xScrDelta,
            poMyMainWin^.yScrMin, poMyMainWin^.yScrDelta);

readln(fIn, poMyMainWin^.nLimWhite, byte(poMyMainWin^.fInfo));

if (nVersion >= 103) then begin
  readln(fIn, poMyMainWin^.yDetectMin);
  end;

poMyMainWin^.xScrMax:=poMyMainWin^.xScrMin+poMyMainWin^.xScrDelta;
poMyMainWin^.yScrMax:=poMyMainWin^.yScrMin+poMyMainWin^.yScrDelta;

nErr:=IOResult;
if (nErr <> 0) then begin
  DBW(1, 'Erreur de lecture des paramtres');
  exit; // error, not normal !?!
  end;
end;  // TMyParamApplic.LoadPrmRead

Begin // MAIN ******
// to use the application parameters defined here.
new(poMyAppPrm, Init);
gglpoPrm:=poMyAppPrm; // it will be destroyed in the TApplication automatically

// Name under which the main window is registered. Spaces are not allowed
oApp.Init('tEx084_testeur_de_des');

// Creation of the main window
new(poMyMainWin, Init('tEx084_testeur_de_des'));

// The App.WindowClass can be modified here, if wanted. (Not usual)
oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.
