Unit wPrinter0;
// EVERYTHING HAS TO BE DONE !!!
// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

interface
{"""""""}

Uses
  wWindow0
 ,wWindowBase0
 ,wGlobals2
 ,wDebug0
 ,Windows;

Type

 {*******************************************************************}
PPrnInstructionNode = ^TPrnInstructionNode;
TPrnInstructionNode = Object
{============================================}
  SelfColor         : TColorRef;
  { Couleur du texte de l'instruction }

  strVarValue     : String;
  { Valeur contenue dans la variable }

  wFormat,
  { Format du texte, justification, Ctrl-F1 :[ DrawText ] }

  wStyle,
  { Style du texte, dfini si l'instruction est encadr ,
    encadr avec fond rempli, soulign, en gras, en italique, ...etc
    cf. const st_XXX ( wConst.tpw ) }

  wStylePrm         : Word;
  { paramtres supplmentaires pouvant avoir une valeur pour un style donn (selon wStyle) }

  Constructor Init;
  { Initialisation de certains paramtres }

  Destructor Done; Virtual;
  { Destructions de certains paramtres, et de l'instance }

  End; { TPrnInstructionNode = Object(TInstructionNode) }

 {*******************************************************************}
PPrinter0 = ^TPrinter0;
TPrinter0 = Object
{=========================}
   nInitXPos,
   nInitYPos          : Integer;
   { position initiale lors de l'impression }

   wPrintType         : Word;
   { Indique si on imprime sur cran ou sur imprimante, donc si on calcule les
     dimensions avec un device d'imprimante ou d'cran. }

   nTextPointS,
   nTextPointVS       : Integer;
   { taille en point des fontes S (String) et VS(VarString) }

   Constructor Init(wMsg:Word32);
   { Initialisation de l'instance, des proprits }

   Destructor Done; Virtual;
   { dstruction de l'instance, des listes...}

   Procedure OpenMainDc; Virtual;
   { on ouvre un Device context selon wPrintType ( d'imprimante ou d'cran )
     et on l'assigne  dcMain}

   Procedure CloseMainDc; Virtual;
   { On ferme le Device context assign  dcMain }

   Procedure SetDcSource(wType : Word; hDcUse : hDc); Virtual;
   { Permet de changer le Device utilis pour calculer les tailles
     des instructions dans .DoInterpretation.
     wType peut tre une des constantes pt_XXX (wConst.tpw), soit:
     pt_Screen (par dfaut, HdcUse:=0), pt_Printer (HdcUse:=0), pt_Dc (qui permet
     de passer par le paramtre hDcUse un Device context  utiliser) }

   Procedure Print(aDC : HDC; Var mmXPos, mmYPos : Float); Virtual;
   { Imprime physiquement la fiche dans le device context pass par prm,
     en commenant  la position mmXPos, mmYPos, ces deux variables sont mises  jour
     pour indiquer quelle est la position  la fin de l'impression. ( en mm. )
     Parcours la liste des instructions et pour chaque noeud appelle Exec_Instruction }

   Procedure TranslateValue(Var pPos : PPrnInstructionNode); Virtual;
   { Pour un noeud de type it_varString, lit la variable associ et construit le champ
     pstrVarValue }

   Procedure UpDateAllVar; Virtual;
   { Lit la fiche et remet  jour les variables par rapport  la fiche }


   {------------- Protected -----------------------------------------------------}

   Procedure CreateInstrAndApplyDef; Virtual;
  { Parcours la liste des instructions, et pour chaque noeud appelle ( dans l'ordre ) :
     - Exec_Definition }

   Procedure DefineFont; Virtual;
   { Initialise les fontes hFnt_VarString et hFnt_String }

   Function NewInstruction : PPrnInstructionNode; Virtual;
   { Initialise une nouvelle instance de TInstructionNode, et la renvoit comme rsultat.
     Ici on cre une instance de TPrnInstructionNode }

   Procedure AssignString(pANode : PPrnInstructionNode;Var strAnInstr: String); Virtual;
   { Assigne les valeurs au noeud pANode, de type String. }
   { Les champs suivants sont dja assigns : fNewLine, et nLine }

   Procedure AssignVarString(pANode : PPrnInstructionNode;Var strAnInstr: String); Virtual;
   { Assigne les valeurs au noeud pANode, de type VarString. }
   { Les champs suivants sont dja assigns : fNewLine, et nLine }

   Function GetDirectiveType(Var strADir : String): Word; Virtual;
   {!  ne pas appeller !}
   { renvoit pour une directive uniquement (sans prm) donne, le type de cette directive,
     On compare donc ici le string recu aux directives existantes, et on en renvoit le type.

     Si la directive n'est pas connu, on renvoit dir_None. (cf. dir_XXX dans wConst.tpw)
     Ceci pour pouvoir surcharger facilement ainsi :

       TPrinter02.GetDirectiveType(Var strADir : String);  = un descendant.
       Begin
         If Inherited GetDirectiveType(strADir)=dir_None Then
         Begin
           If strADir='MYNEWDIRECTIVE' Then GetDirectiveType:=dir_MyNewDirective
           Else GetDirectiveType:=dir_None;
         End
       End; }

   Function GetSpecificationType(Var strDef : String): Word; Virtual;
   { renvoit pour une dfinition-spcification, son type. Pour comprendre l'ide,
     voir plus haut la mthode GetDirectiveType }

   Function GetSpecialisationType(Var strDef : String): Word; Virtual;
   { renvoit pour une dfinition-spcialisation, son type. Pour comprendre l'ide,
     voir plus haut la mthode GetDirectiveType }

   Function Exec_Directive(wADir: Word; strPrm : String): Boolean; Virtual;
   {!  ne pas appeller !}
   { Execute la directive strADir avec les paramtres strPrm }

   Function Exec_Specialisation(wADef: Word; Var strPrm : String;
                                pANode : PPrnInstructionNode): Boolean; Virtual;
   {!  ne pas appeller !}
   { Execute la dfinition strADef avec les paramtres strPrm sur l'instruction contenue dans
     le noeud pANode }

   Function Exec_Instruction(pANode : PPrnInstructionNode): Boolean; Virtual;
   {!  ne pas appeller !}
   { Execute l'instruction contenue dans le noeud pANode }

 End;

 {*******************************************************************}
PMsgPrintOut = ^TMsgPrintOut;
TMsgPrintOut = Object
{===============================}
   { Read-Write }
   mmFicheInitX,
   mmFicheInitY,
   { Read-Only }
   mmFicheFinalX,
   mmFicheFinalY    :Float;
   { les deux premires servent  indiquer  quelle position, l'on veut
     imprimer la fiche, les deux dernieres servent  connnatre le point
     bas-droite de la fiche aprs impression ( en mm.) }

   pMainPrn      : PPrinter0;

   Constructor Init(ATitle : PChar; APrn : PPrinter0);

   Procedure PrintPage(Page : Word; Var Rect : TRect; flags : Word); Virtual;

 End; { TMsgPrintOut = Object (TPrintOut) }

(*
PGAPPrintDialog = ^TGAPPrintDialog;
TGAPPrintDialog = object(TPrintDialog)
{====================================}
  { Pour corriger une erreur de Borland Pascal }
  procedure IDSetup(var Msg:TMessage); virtual id_First + id_Setup;
  end; { - TGAPPrintDialog = object(TPrintDialog) - }
*)

PGAPPrinterAbortDlg = ^TGAPPrinterAbortDlg;
TGAPPrinterAbortDlg = object
{============================================}
  { pour corriger l'abscence de traitement de CANCEL durant une
    impression qui dur longtemps }
  fAborted         : boolean;
  { =FALSE par dfaut, mais est mis  TRUE si on a appuy sur CANCEL }

  constructor Init(AParent:PWindow0; Template, Title, Device, Port: PChar);
  procedure WMCommand(var Msg:TMessage); virtual;
  end; { - TGAPPrinterAbortDlg = object(TPrinterAbortDlg) - }

PGAPPrinter = ^TGAPPrinter;
TGAPPrinter = object
{============================}
  { pour corriger l'abscence de traitement de CANCEL durant une
    impression qui dur longtemps }
  pAbortDlg        : PGAPPrinterAbortDlg;
  { Pointeur sur le dialogue Abort  (CANCEL) }

  constructor Init;
  function InitAbortDialog( Parent: PWindow0;
                            Title: PChar): Pointer; virtual;
  end; { - TGAPPrinter = object(TPrinter) - }

const
  glpPrinter       : PGAPPrinter = NIL;

const
  glvScaleDPIPrn   : Float = 1;
  { Permet de dimimuer la rsolution de l'image alloue en mmoire pour
    l'imprimante.  = 1 normalement }

Implementation
{""""""""""""}

{**********************************************************}
{** TPrnInstructionNode }
{**********************************************************}

Constructor TPrnInstructionNode.Init;
{===================================}
Begin { TPrnInstructionNode.Init }
//  Inherited Init;
  SelfColor:=RGB(0,0,0);
  wFormat:=dt_Left or dt_NoClip or dt_NoPrefix;
  wStyle:=0;
  wStylePrm:=0;
  strVarValue:=''
End;  { TPrnInstructionNode.Init }

Destructor TPrnInstructionNode.Done;
{==================================}
Begin { TPrnInstructionNode.Done }
//  Inherited Done;
End;  { TPrnInstructionNode.Done }

{**********************************************************}
{** TPrinter0 }
{**********************************************************}

Constructor TPrinter0.Init(wMsg:Word32);
{========================================================}
Begin { TPrnInte.Init }
End;  { TPrinter0.Init }

Destructor TPrinter0.Done;
{========================}
Begin { TPrinter0.Done }
End;  { TPrinter0.Done }

Procedure TPrinter0.OpenMainDc;
{=============================}
Begin { TPrinter0.OpenMainDc }
End;  { TPrinter0.OpenMainDc }

Procedure TPrinter0.CloseMainDc;
{=============================}
Begin { TPrinter0.CloseMainDc }
End;  { TPrinter0.CloseMainDc }

Procedure TPrinter0.SetDcSource(wType : Word; hDcUse : hDc);
{==========================================================}
Begin { TPrinter0.SetDcSource }
End;  { TPrinter0.SetDcSource }

Procedure TPrinter0.Print(aDC : HDC; Var mmXPos, mmYPos : Float);
{=============================================================}
Begin { TPrinter0.Print }
End;  { TPrinter0.Print }

Procedure TPrinter0.TranslateValue(Var pPos : PPrnInstructionNode);
{=================================================================}
Begin { TPrinter0.TranslateValue }
End;  { TPrinter0.TranslateValue }

Procedure TPrinter0.UpDateAllVar;
{===============================}
Begin { TPrinter0.UpDateAllVar }
End; { TPrinter0.UpDateAllVar }

Procedure TPrinter0.CreateInstrAndApplyDef;
{=========================================}
Begin { TPrinter0.CreateInstrAndApplyDef }
End; { TPrinter0.CreateInstrAndApplyDef }

Procedure TPrinter0.DefineFont;
{=============================}
Begin { TPrinter0.DefineFont }
End;  { TPrinter0.DefineFont }

Function TPrinter0.NewInstruction : PPrnInstructionNode;
{===================================================}
Begin { TPrinter0.NewInstruction }
  NewInstruction:=New(pPrnInstructionNode, Init)
End;  { TPrinter0.NewInstruction }

Procedure TPrinter0.AssignString(pANode : PPrnInstructionNode;Var strAnInstr: String);
{=================================================================================}
Begin { TPrinter0.AssignString }
End;  { TPrinter0.AssignString }

Procedure TPrinter0.AssignVarString(pANode : PPrnInstructionNode;Var strAnInstr: String);
{====================================================================================}
Begin { TDlgInter.AssignVarString }
End;  { TDlgInter.AssignVarString }

Function TPrinter0.GetDirectiveType(Var strADir:String):Word;
{==============================================================}
Begin { TPrinter0.GetDirectiveType }
GetDirectiveType:=0;
End;  { TPrinter0.GetDirectiveType }

Function TPrinter0.GetSpecificationType(Var strDef : String): Word;
{=================================================================}
Begin { TPrinter0.GetSpecificationType }
GetSpecificationType:=0;
End;  { TPrinter0.GetSpecificationType }

Function TPrinter0.GetSpecialisationType(Var strDef : String): Word;
{==================================================================}
Begin { TPrinter0.GetSpecialisationType }
GetSpecialisationType:=0;
End;  { TPrinter0.GetSpecialisationType }

Function TPrinter0.Exec_Directive(wADir: Word; strPrm : String): Boolean;
{=======================================================================}
Begin { TPrinter0.Exec_Directive }
Exec_Directive:=false;
End;  { TPrinter0.Exec_Directive }

Function TPrinter0.Exec_Specialisation(wADef: Word; Var strPrm : String;
                             pANode : PPrnInstructionNode): Boolean;
{======================================================================}
Begin { TPrinter0.Exec_Specialisation }
Exec_Specialisation:=false;
End;  { TPrinter0.Exec_Specialisation }

Function TPrinter0.Exec_Instruction(pANode : PPrnInstructionNode): Boolean;
{======================================================================}
Begin { TPrinter0.Exec_Instruction }
Exec_Instruction:=false;
End;  { TPrinter0.Exec_Instruction }

{**********************************************************}
{** TMsgPrintOut }
{**********************************************************}

Constructor TMsgPrintOut.Init(ATitle : PChar; APrn : PPrinter0);
{============================================================}
Begin { TMsgPrintOut.Init }
End;  { TMsgPrintOut.Init }

Procedure TMsgPrintOut.PrintPage(Page : Word; Var Rect : TRect; flags : Word);
{================================================================================}
Begin { TMsgPrintOut.PrintPage }
End;  { TMsgPrintOut.PrintPage }

{**********************************************************}
{****** TGAPPrinterAbortDlg = object(TPrinterAbortDlg) }
{**********************************************************}

constructor TGAPPrinterAbortDlg.Init( AParent:PWindow0; Template, Title,
{===================================} Device, Port: PChar);
begin
end; {-  TGAPPrinterAbortDlg.Init - }

procedure TGAPPrinterAbortDlg.WMCommand(var Msg:TMessage);
{========================================================}
begin
end; { - TGAPPrinterAbortDlg.WMCommand - }

{**********************************************************}
{****** TGAPPrinter = object(TPrinter) }
{**********************************************************}

constructor TGAPPrinter.Init;
{===========================}
begin
end;  { - TGAPPrinter.Init - }

function TGAPPrinter.InitAbortDialog( Parent: PWindow0;
{===================================} Title: PChar): Pointer;
begin { -  TGAPPrinter.InitAbortDialog - }
InitAbortDialog:=nil;
end;  { -  TGAPPrinter.InitAbortDialog - }


End. { *** Unit wPrinter0.pas *** }