// Program which treats the output of the freepascal compile, for Crimson Editor

program Analyse;
//==============

var
  fIn         : text; // file 'h:\Temp\results.txt, created during the compilation of a program
  strS        : String[200]; // on line of the file
  strFileName : String[200]; // the name of the file being compiled
  nLine       : integer;  // count the line number
  nErr        : integer;  // Error in the IOResult, if any
  fLinking    : boolean; //indicates if the linking began

begin (* Main *)
assign(fIn, '\Temp\Results.txt');
reset(fIn);

fLinking:=false;
nLine:=0;

{$i-}
while not eof(fIn) do begin
   nLine:=nLine + 1;
   readln(fIn, strS);

   if (nLine = 4) then strFileName:=Copy(strS,11,60); // not used know

   // the first lines are skipped, then the others are sended to the normal output
   if (nLine >= 5) then begin
      if (nLine = 5) and (Copy(strS,1,7) = 'Linking') then fLinking:=true;
      if (nLine = 5) and (not fLinking) then writeln(strS);
      if (nLine = 6) and (not fLinking)  then writeln(strS);
      if (nLine >= 7) then writeln(strS);
      end;
   end; // while

nErr:=IOResult; // just to clear the IOResult.

if (nErr <> 0) then writeln('Error in the ''Analyse'' file, nErr=', nErr);

if (nLine < 7) then begin
  writeln('No errors');
  halt(0);  // indique qu'il n'y a pas eu d'erreurs
  end
else halt(1); // pour indiquer au fichier batch qu'il y a eu une erreur.

// writeln('fileName="', strFileName, '"');
// writeln('last line="', strS, '"');
end. (* Main *)
