{ Pour rsoudre le problme du Compte est bon.
  Compte le nombre d'expressions diffrentes
  Gnre une liste de toutes les expressions diffrentes.
  --------------------------------------------}
program tEx080_Compte_Bon;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses
  wApplication0
 ,wWindowText0 // To write text in an independent window
 ,wToolBar0
// ,wMenus0
// ,wWindowBase0
 ,wVariableNumLink2
 ,wDialogCreatorLOW2
 ,wDialogCreator2
 ,wErrors0
 ,wGlobals2
 ,wUtiles2  // for the quicksort algorithme
 ,wDebug0
 ,Windows;

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindowText)
  //"""""""""""""""""""""""""""""
  poToolBar : PToolBar;
  // Remember the toolbar, to destroy it when a new one is wanted.

  constructor Init(strWinTitlePrm:ShortString);
  destructor Done; virtual;

  procedure Test1;
  procedure Test2;
  procedure Test3;
  procedure Test4;
  procedure Test8;
  procedure Test9;

  procedure MenuCreate; virtual;
  // Creates the menu

  procedure WinCreate(strWinClass:ShortString); virtual;
  // When creating the window, we ask to show the dialog box, not the window

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

//  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

const
MAXOPER   = 5;  // nombre max. d'operation  +  -  *  /  \
MAXNUMBER = 8;  // nombre max. de nombres  combiner

var
  avNumber         : array[1..MAXNUMBER] of Float;
  { Se sont les nombres  combiner }
  nOp     : integer;  // nombre d'oprateurs possible, gnralement 4 ou 5.
  nNb     : integer;  // nombre de nombres  combiner,  de 2  7
  nNbOp   : integer;  // = nOp + nNb = nombre d'oprateurs possible + nombre de nombres.
  nNb2m1  : integer;  // nombre de nombres + nombre d'oprateurs entre deux nombres

// var glnNotUsed : integer; // To avoid an error in the DevPascal 1.9 environment
var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

//******************************************************************
// TMyWindow = object(TWindow)
//******************************************************************

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
var  nn : integer;
begin
inherited Init(strWinTitlePrm);

poToolBar:=NIL;

// This line is all what is needed to have a status line.
new(poStatusLine, Init(@Self));

// Scurit
for nn:=1 to MAXNUMBER do avNumber[nn]:=2 + nn*nn;
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//========================
begin
// if (poToolBar <> NIL) then dispose(poToolBar, Done); done by the parent
inherited Done;
end;  // TMyWindow.Done

procedure TMyWindow.Test1;
//========================
// Le compte est max
label SKIPtoEND;
var
  wRep     : word32; // answer of the dialog box

  afUsed           : array[1..MAXNUMBER*2] of boolean;
  { Indique si le nombre a dj t mis dans le stack }

  avStack          : array[0..MAXNUMBER] of Float;
  { Contiendra les rsultats des oprations, qui se font en notation
    polonaise inverse }

  anInd            : array[0..MAXNUMBER*2] of integer;
  { contient les oprations et/ou nombres a mettre dans le stack,
    pour raliser toutes les combinaisons possibles }
  { ind[k] =
    1 => +
    2 => -
    3 => *
    4 => /
    5..9 => met un nombre sur le stack }

  pavComb  : PTypeArrayFloat; // liste de toutes les combinaisons.
  nNbComb  : int32;  // nombre de combinaisons stockes

  kk,         { indice de ind, pour mettre les nombres et/ou oprations sur le stack }
  nStack,     { nombre d'lment dans le stack }
  nCount,     // combre le nombre d'expressions testes.
  nn          : int32;
  vMax        : Float;
  strOut      : string;  // rsultat final, qui sera affich.

begin // Test1
// initialisation
nOp:=4; // nombre d'oprateurs possible, gnralement 4 dans Test1.
nNb:=5; // nombre de nombres  combiner,  de 2  7
nNbOp:=nNb+nOp;
nNb2m1:=2*nNb-1;

nNbComb:=0; // nombre de combinaisons stockes
GetMem(pavComb, 1000000*SizeOf(Float));

// Default values, nombres  combiner.
avNumber[1]:=2;
avNumber[2]:=5;
avNumber[3]:=117;
avNumber[4]:=4307;
avNumber[5]:=14307;

avNumber[1]:=sqrt(21);
avNumber[2]:=exp(ln(53)/5);
avNumber[3]:=exp(ln(71)/7);
avNumber[4]:=exp(ln(1113)/13);

Randomize;
avNumber[1]:=random;
avNumber[2]:=random;
avNumber[3]:=random;
avNumber[4]:=random;
avNumber[5]:=random;

FloatField(101, avNumber[1]);
FloatField(102, avNumber[2]);
FloatField(103, avNumber[3]);
FloatField(104, avNumber[4]);
FloatField(105, avNumber[5]);

//Int32Field(101, nn);
wRep:=IDOK;
//wRep:=DialogExecMSG(12199, @Self);

if (wRep <> IDOK) then exit; // CANCELED the operation

// Initialisation par scurit, inutile en principe
for kk:=1 to nNb do avStack[kk]:=0;

// par dfaut, rien n'est affich.
strOut:='';

// anInd[0] deviendra = 2 quand toutes les combinaisons aurons t testes
anInd[0]:=1;

// Au dpart :
// Les deux premier lments du stack sont des nombres
// Ensuite alterne entre nombre et oprateur (+)
anInd[1]:=nOp+1;
anInd[2]:=nOp+2;
anInd[3]:=1;
anInd[4]:=nOp+3;
anInd[5]:=1;
anInd[6]:=nOp+4;
anInd[7]:=1;
anInd[8]:=nOp+5;
anInd[9]:=1;
anInd[10]:=nOp+6;
anInd[11]:=1;
anInd[12]:=nOp+7;
anInd[13]:=1;

// Sentinel, dans le cas ou on dpasse la limite du tableau
afUsed[nNbOp+1]:=FALSE;

// combinaison max. trouve
vMax:=0;

WriteWin(1, '---------------------------------------------------------------');
WriteWin(1, '1) Nombres de dpart : ');
for kk:= 1 to nNb do strOut:=strOut + FloatToStr(avNumber[kk],13,9) + '  ;';
WriteWin(1, strOut);  strOut:='';
WriteWin(1, '');

nCount:=0;

// ***** BOUCLE PRINCIPALE *****
// Toutes les combinaisons seront teste ici
repeat
   // Le stack est vide, et aucun nombre utilis
   nStack  :=0;
   inc(nCount);

   for kk:=nOp+1 to nNbOp do afUsed[kk]:=FALSE;

   // boucle pour une combinaison
   kk:=0;
   repeat
      inc(kk);

      // Si on ne peut pas mettre d'oprations sur le stack, saute
      // les oprations, pour y mettre un nombre
      if (nStack < 2) then while (anInd[kk] <= nOp) do inc(anInd[kk]);

      if (anInd[kk] > nOp) then begin // un nombre a mettre sur le stack.
         while afUsed[anInd[kk]] do inc(anInd[kk]); // saute les nombres dj utiliss

         // si tous les nombre utilis, et plus que des nombres  mettre
         //  sur le stack, on saute une suite des combinaisons impossibles
         if (anInd[kk] > nNbOp) then begin
            // plus de nombre  mettre sur le stack, car tous utiliss.
            { saute des combinaisons }
            for nn:=kk to nNb2m1 do anInd[nn]:=nNbOp;

            goto SKIPtoEND;
            end; { if (ind[kk] > nNbOp) then begin }
         end; { if (ind[kk] >= nOp) then begin }

      { Met l'opration ou le nombre sur le stack }
      if (anInd[kk] <= nOp) then begin
         { ralise une opration, le niveau du stack diminu }
         dec(nStack);

         case anInd[kk] of
           1 : avStack[nStack]:=avStack[nStack] + avStack[nStack+1];
           2 : avStack[nStack]:=avStack[nStack] - avStack[nStack+1];
           3 : avStack[nStack]:=avStack[nStack] * avStack[nStack+1];
           4 : begin
               if (abs(avStack[nStack+1]) < 1e-10) then begin
                  { On saute toutes les combinaisons avec division par 0 }
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;
oRichEditFrame.AppendText('Saute petit nombre :' + FloatToStr(avStack[nStack+1],23,15));
                  goto SKIPtoEND;
                  end;

               avStack[nStack]:=avStack[nStack] / avStack[nStack+1];
               end;
           5 : begin
               if (abs(avStack[nStack]) < 1e-10) then begin
                  { On saute toutes les combinaisons avec division par 0 }
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end;

               avStack[nStack]:=avStack[nStack+1] / avStack[nStack];
               end;
           end; { case }
         end
      else begin
         { met un nombre sur le stack }
         inc(nStack);
         avStack[nStack]:=avNumber[anInd[kk] - nOp];
         afUsed[anInd[kk]]:=TRUE;  { ce nombre a t utilis }
         end;

      until (kk >= nNb2m1);

   { Le rsultat d'une combinaison est sur le stack, test si il
     est plus grand que le plus grand rsultat dj obtenu }
//   if (vMax < avStack[1]) then begin
   if ((nCount < 0) and (vMax < avStack[1])) then begin
      { Affiche les oprations  faire }
      for kk:=1 to nNb2m1 do begin
         if (anInd[kk] <= nOp) then begin
            case anInd[kk] of
              1 : strOut:=strOut + ' + ';
              2 : strOut:=strOut + ' - ';
              3 : strOut:=strOut + ' * ';
              4 : strOut:=strOut + ' / ';
              5 : strOut:=strOut + ' \ ';
              end; { case }
            end
         else strOut:=strOut + FloatToStr(avNumber[anInd[kk] - nOp],8,4);
         end; { for }

      strOut:=strOut + '=' + FloatToStr(avStack[1],8,4);

      // affiche le rsultat et rinitialise  "vide" la chaine de sortie.
      WriteWin(1, strOut);  strOut:='';

      vMax:=avStack[1];
      end;

   // Une combinaison de plus.
//   if (avStack[1] > 0) then
      begin  // ne garde que certains nombres.
      inc(nNbComb);
      pavComb^[nNbComb]:=avStack[1];
      end;

   { label dans le cas ou des combinaisons sont sautes  }
   SKIPtoEND:;

   { passage  la combinaison suivante }
   kk:=nNb2m1+1;
   repeat
      dec(kk);
      inc(anInd[kk]);
      if (anInd[kk] > nNbOp) then anInd[kk]:=1;
      until (anInd[kk] > 1);

   { Si anInd[0] = 2, toutes les combinaisons ont t testes }
   until (anInd[0] = 2);

WriteWin(1, 'nCount =' + ITS(nCount));

// trie toutes les solutions.
QSort(1, nNbComb, pavComb^);

// Compte le nombre de solutions diffrentes.
nCount:=1;
vMax:=pavComb^[1] + abs(pavComb^[nn])*1e-10;
for nn:=2 to nNbComb do begin
  if (vMax < pavComb^[nn]) then begin
     inc(nCount);
     vMax:=pavComb^[nn] + abs(pavComb^[nn])*1e-10;
     end;
  end;

WriteWin(1, 'nb. sol. diffrentes avec signe =' + ITS(nCount));
WriteWin(1, 'premier =' + FloatToStr(pavComb^[1],23,19));

// ne garde pas les signes ngatifs
for nn:=1 to nNbComb do pavComb^[nn]:=abs(pavComb^[nn]);

// trie toutes les solutions.
QSort(1, nNbComb, pavComb^);

// Compte le nombre de solutions diffrentes.
nCount:=1;
vMax:=pavComb^[1] + 1e-10;
for nn:=2 to nNbComb do begin
  if (vMax < pavComb^[nn]) then begin
     inc(nCount);
     vMax:=pavComb^[nn]*(1 + 1e-10);
     end;
  end;

WriteWin(1, 'nb. sol. diffrentes sans signe =' + ITS(nCount));
WriteWin(1, 'premier =' + FloatToStr(pavComb^[1],23,19));
WriteWin(1, 'dernier =' + FloatToStr(pavComb^[nNbComb],23,19));
{
// Recherche de la plus petite diffrence
nCount:=1;
vMax:=1000;
for nn:=2 to nNbComb do begin
  if ((pavComb^[nn] > pavComb^[nn-1] + 1e-10) and
      (vMax > pavComb^[nn] - pavComb^[nn-1])) then begin
     inc(nCount);
     vMax:=pavComb^[nn] - pavComb^[nn-1];
     end;
  end;

WriteWin(1, 'plus petite diff. =' + FloatToStr(vMax*1e12,23,15));
}
//oRichEditFrame.AppendText('Number of throws =' + FloatToStr(vMax,9,5));
FreeMem(pavComb, 1000000*SizeOf(Float));
end;  // TMyWindow.Test1

procedure TMyWindow.Test2;
//========================
// Le compte est max
label SKIPtoEND;
var
  wRep     : word32; // answer of the dialog box

  afUsed           : array[1..MAXNUMBER*2] of boolean;
  { Indique si le nombre a dj t mis dans le stack }

  avStack          : array[0..MAXNUMBER] of Float;
  { Contiendra les rsultats des oprations, qui se font en notation
    polonaise inverse }

  anInd            : array[0..MAXNUMBER*2] of integer;
  { contient les oprations et/ou nombres a mettre dans le stack,
    pour raliser toutes les combinaisons possibles }
  { ind[k] =
    1 => +
    2 => -
    3 => *
    4 => /
    5..9 => met un nombre sur le stack }

  anStackOrder : array[0..MAXNUMBER*2] of integer;
  // ordre d'importance, pour liminer des cas redondants

  anStackOrderL,
  anStackOrderR,
  anStackOrderO  : array[0..MAXNUMBER*2] of integer;
  // Pour mmoriser le stackOrder des deux oprandes avant une multiplication ou une division
  // anStackOrderO  mmorise l'opration faite sur l'oprande de gauche

  pavComb  : PTypeArrayFloat; // liste de toutes les combinaisons.
  nNbComb  : int32;  // nombre de combinaisons stockes

  kk,         { indice de ind, pour mettre les nombres et/ou oprations sur le stack }
  nStack,     { nombre d'lment dans le stack }
  nCount,     // combre le nombre d'expressions testes.
  nn          : int32;
  vMax        : Float;
  strOut      : string;  // rsultat final, qui sera affich.

begin // Test2
// initialisation
nOp:=4; // nombre d'oprateurs possible, gnralement 4 dans Test2.
nNb:=5; // nombre de nombres  combiner,  de 2  7
nNbOp:=nNb+nOp;
nNb2m1:=2*nNb-1;

nNbComb:=0; // nombre de combinaisons stockes
GetMem(pavComb, 1000001*SizeOf(Float));

// Default values, nombres  combiner.
avNumber[1]:=5;
avNumber[2]:=19;
avNumber[3]:=67;
avNumber[4]:=301;
avNumber[5]:=1403;

Randomize;
avNumber[1]:=random;
avNumber[2]:=random;
avNumber[3]:=random;
avNumber[4]:=random;
avNumber[5]:=random;
avNumber[6]:=random;
avNumber[7]:=random;

FloatField(101, avNumber[1]);
FloatField(102, avNumber[2]);
FloatField(103, avNumber[3]);
FloatField(104, avNumber[4]);
FloatField(105, avNumber[5]);

//Int32Field(101, nn);
wRep:=IDOK;
//wRep:=DialogExecMSG(12199, @Self);

if (wRep <> IDOK) then exit; // CANCELED the operation

// Initialisation par scurit, inutile en principe
for kk:=1 to nNb do avStack[kk]:=0;

anStackOrder[0]:=0;  // pour viter un warning
anStackOrderL[0]:=0;
anStackOrderR[0]:=0;
anStackOrderO[0]:=0;

// par dfaut, rien n'est affich.
strOut:='';

// anInd[0] deviendra = 2 quand toutes les combinaisons aurons t testes
anInd[0]:=1;

// Au dpart :
// Les deux premier lments du stack sont des nombres
// Ensuite alterne entre nombre et oprateur (+)
anInd[1]:=nOp+1;
anInd[2]:=nOp+2;
anInd[3]:=1;
anInd[4]:=nOp+3;
anInd[5]:=1;
anInd[6]:=nOp+4;
anInd[7]:=1;
anInd[8]:=nOp+5;
anInd[9]:=1;
anInd[10]:=nOp+6;
anInd[11]:=1;
anInd[12]:=nOp+7;
anInd[13]:=1;

// Sentinel, dans le cas ou on dpasse la limite du tableau
afUsed[nNbOp+1]:=FALSE;

// combinaison max. trouve
vMax:=0;

WriteWin(1, '---------------------------------------------------------------');
WriteWin(1, '2) Nombres de dpart : ');
for kk:= 1 to nNb do strOut:=strOut + FloatToStr(avNumber[kk],13,9) + '  ;';
WriteWin(1, strOut);  strOut:='';
WriteWin(1, '');

nCount:=0;

// ***** BOUCLE PRINCIPALE *****
// Toutes les combinaisons seront teste ici
repeat
   // Le stack est vide, et aucun nombre utilis
   nStack  :=0;

   for kk:=nOp+1 to nNbOp do afUsed[kk]:=FALSE;

   // boucle pour une combinaison
   kk:=0;
   repeat
      inc(kk);

      // Si on ne peut pas mettre d'oprations sur le stack, saute
      // les oprations, pour y mettre un nombre
      if (nStack < 2) then while (anInd[kk] <= nOp) do inc(anInd[kk]);

      if (anInd[kk] > nOp) then begin // un nombre a mettre sur le stack.
         while afUsed[anInd[kk]] do inc(anInd[kk]); // saute les nombres dj utiliss

         // si tous les nombre utilis, et plus que des nombres  mettre
         //  sur le stack, on saute une suite des combinaisons impossibles
         if (anInd[kk] > nNbOp) then begin
            // plus de nombre  mettre sur le stack, car tous utiliss.
            // saute des combinaisons
            for nn:=kk to nNb2m1 do anInd[nn]:=nNbOp;

            goto SKIPtoEND;
            end; { if (ind[kk] > nNbOp) then begin }
         end; { if (ind[kk] > nOp) then begin }

      { Met l'opration ou le nombre sur le stack }
      if (anInd[kk] <= nOp) then begin
         { ralise une opration, le niveau du stack diminu }
         dec(nStack);

         case anInd[kk] of
           1 : begin
               // Puisque l'addition est commutative : a b + = b a +
               // donc un des deux cas peut tre limin
               // Puisque l'addition est associative, on a : a b + c + = a b c + +
               // donc le deuxime cas peut tre limin
               if ((anStackOrder[nStack] > anStackOrder[nStack+1]) or
                   (anInd[kk-1] <= 2)) then begin
                   // On saute des expressions redondandes
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end
               else avStack[nStack]:=avStack[nStack] + avStack[nStack+1];
               end;
           2 : begin
               // Puisque la soustraction est commutative au signe prs : |a b -| = |b a -|
               // donc un des deux cas peut tre limin
               // Puisque : |a |b c -| -| = |a b -| c +  ou   = |a c -| b +  ou   = ||b c -| a -|
               // donc le premier cas peut tre limin
               // Puisque : a b - c - = a b c + -
               // donc le deuxime cas peut tre limin
               if ((anStackOrder[nStack] > anStackOrder[nStack+1]) or
                   (anInd[kk-1] <= 2)) then begin
                   // On saute des expressions redondandes
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end
               else avStack[nStack]:=abs(avStack[nStack] - avStack[nStack+1]);
               end;
           3 : begin
               // Puisque la multiplication est commutative : a b *  ==  b a *
               // donc un des deux cas peut tre limin
               // Puisque la multiplication est associative, on a : a b * c *  ==  a b c * *
               // donc le deuxime cas peut tre limin
               // Puisque : a b * c /  ==  a b c / *
               // donc le deuxime cas peut tre limin
               if ((anStackOrder[nStack] > anStackOrder[nStack+1]) or
                   ((anInd[kk-1] >= 3) and (anInd[kk-1] <= nOp))) then begin
                   // On saute des expressions redondandes
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end
               else avStack[nStack]:=avStack[nStack] * avStack[nStack+1];
               end;
           4 : begin 
               // Puisque : a b / c /  ==  a c / b /     difficile  grer
               // un des deux cas peut tre limin

               // Puisque : a b / c *  ==  a b c / /
               // donc le deuxime cas peut tre limin
               // Puisque : a b / c /  ==  a b c * /
               // donc le deuxime cas peut tre limin
               if ((anInd[kk-1] >= 3) and (anInd[kk-1] <= nOp)) then begin
                   // On saute des expressions redondandes
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end;

               if ((anStackOrderO[nStack] = 4) and
                   (anStackOrderR[nStack] > anStackOrder[nStack+1])) then begin
                   // l'opration qui a gnr l'oprande de gauche (x y /)  tait une division.
                   // et  Ordre(y) > Ordre(z)
                   // On saute l'expression redondande :  x y / z /  avec O(y) > O(z)
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end;

               if ((anStackOrderO[nStack] = 3) and
                   (anStackOrderR[nStack] > anStackOrder[nStack+1]) and
                   (anStackOrderR[nStack] > anStackOrderL[nStack])) then begin
                   // l'opration qui a gnr l'oprande de gauche (x y *)  tait une multiplication.
                   // et  Ordre(y) > Ordre(z)  et  Ordre(y) > Ordre(x)
                   // On saute l'expression redondande :  x y * z /  avec O(y) > O(z) et  O(y) > O(x)
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end;

               if (abs(avStack[nStack+1]) < 1e-10) then begin
                  { On saute toutes les combinaisons avec division par 0 }
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;
oRichEditFrame.AppendText('Saute petit nombre :' + FloatToStr(avStack[nStack+1],23,15));
                  goto SKIPtoEND;
                  end;

               avStack[nStack]:=avStack[nStack] / avStack[nStack+1];
               end;
           5 : begin
               if (abs(avStack[nStack]) < 1e-10) then begin
                  { On saute toutes les combinaisons avec division par 0 }
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end;

               avStack[nStack]:=avStack[nStack+1] / avStack[nStack];
               end;
           end; { case }

           // mmorise l'ordre des oprande et l'oprateur
           anStackOrderL[nStack]:=anStackOrder[nStack];
           anStackOrderR[nStack]:=anStackOrder[nStack+1];
           anStackOrderO[nStack]:=anInd[kk];

           // mmorise toujours l'ordre le plus grand
           if (anStackOrder[nStack] <  anStackOrder[nStack+1]) then
               anStackOrder[nStack] := anStackOrder[nStack+1];

         end
      else begin
         { met un nombre sur le stack }
         inc(nStack);
         avStack[nStack]:=avNumber[anInd[kk] - nOp];
         anStackOrder[nStack]:=anInd[kk]; // ordre pour liminer les cas redondants
         anStackOrderO[nStack]:=0;  // pas une opration
         afUsed[anInd[kk]]:=TRUE;  { ce nombre a t utilis }
         end;

      until (kk >= nNb2m1);

   { Le rsultat d'une combinaison est sur le stack, test si il
     est plus grand que le plus grand rsultat dj obtenu }
//   if (vMax < avStack[1]) then begin
   if (nCount < 0) then begin
      { Affiche les oprations  faire }
      for kk:=1 to nNb2m1 do begin
         if (anInd[kk] <= nOp) then begin
            case anInd[kk] of
              1 : strOut:=strOut + ' + ';
              2 : strOut:=strOut + ' - ';
              3 : strOut:=strOut + ' * ';
              4 : strOut:=strOut + ' / ';
              5 : strOut:=strOut + ' \ ';
              end; { case }
            end
         else strOut:=strOut + FloatToStr(avNumber[anInd[kk] - nOp],12,4);
         end; { for }

      strOut:=FloatToStr(avStack[1],8,4) + ' = ' + strOut;

      // affiche le rsultat et rinitialise  "vide" la chaine de sortie.
      WriteWin(1, strOut);  strOut:='';

      vMax:=avStack[1];
      end;

   // Une combinaison de plus.
   if (nCount < 1000000) then
      begin  // ne garde que certains nombres.
      inc(nNbComb);
      pavComb^[nNbComb]:=avStack[1];
      end;

   inc(nCount);

   { label dans le cas ou des combinaisons sont sautes  }
   SKIPtoEND:;

   { passage  la combinaison suivante }
   kk:=nNb2m1+1;
   repeat
      dec(kk);
      inc(anInd[kk]);
      if (anInd[kk] > nNbOp) then anInd[kk]:=1;
      until (anInd[kk] > 1);

   { Si anInd[0] = 2, toutes les combinaisons ont t testes }
   until (anInd[0] = 2);

WriteWin(1, 'nCount =' + ITS(nCount));

// ne garde pas les signes ngatifs
for nn:=1 to nNbComb do pavComb^[nn]:=abs(pavComb^[nn]);

// trie toutes les solutions.
QSort(1, nNbComb, pavComb^);

// Compte le nombre de solutions diffrentes.
nCount:=1;
vMax:=pavComb^[1] + 1e-10;
for nn:=2 to nNbComb do begin
  if (vMax < pavComb^[nn]) then begin
     inc(nCount);
     vMax:=pavComb^[nn]*(1 + 1e-10);
     end;
  end;

WriteWin(1, 'nb. sol. diffrentes sans signe =' + ITS(nCount));
WriteWin(1, 'premier =' + FloatToStr(pavComb^[1],23,19));
WriteWin(1, 'dernier =' + FloatToStr(pavComb^[nNbComb],23,19));
{
// Recherche de la plus petite diffrence
nCount:=1;
vMax:=1000;
for nn:=2 to nNbComb do begin
  if ((pavComb^[nn] > pavComb^[nn-1] + 1e-10) and
      (vMax > pavComb^[nn] - pavComb^[nn-1])) then begin
     inc(nCount);
     vMax:=pavComb^[nn] - pavComb^[nn-1];
     end;
  end;

WriteWin(1, 'plus petite diff. =' + FloatToStr(vMax*1e12,23,15));
}
//oRichEditFrame.AppendText('Number of throws =' + FloatToStr(vMax,9,5));
FreeMem(pavComb, 1000001*SizeOf(Float));
end;  // TMyWindow.Test2

procedure TMyWindow.Test3;
//========================
// Le compte est max
label SKIPtoEND;
var
  wRep     : word32; // answer of the dialog box

  afUsed           : array[1..MAXNUMBER*2] of boolean;
  { Indique si le nombre a dj t mis dans le stack }

  avStack          : array[0..MAXNUMBER] of Float;
  { Contiendra les rsultats des oprations, qui se font en notation
    polonaise inverse }

  anInd            : array[0..MAXNUMBER*2] of integer;
  { contient les oprations et/ou nombres a mettre dans le stack,
    pour raliser toutes les combinaisons possibles }
  { ind[k] =
    1 => +
    2 => -
    3 => *
    4 => /
    5..9 => met un nombre sur le stack }

  anStackOrder : array[0..MAXNUMBER*2] of integer;
  // ordre d'importance, pour liminer des cas redondants

  pavComb  : PTypeArrayFloat; // liste de toutes les combinaisons.
  nNbComb  : int32;  // nombre de combinaisons stockes

  kk,         { indice de ind, pour mettre les nombres et/ou oprations sur le stack }
  nStack,     { nombre d'lment dans le stack }
  nCount,     // combre le nombre d'expressions testes.
  nTests,     // nombres de tests effectus, y compris ceux limins.
  nn          : int32;
  vMax        : Float;
  strOut      : string;  // rsultat final, qui sera affich.

  nStackSizeDiv,
  nStackSizeDiv2,
  nStackSizeDiv3 : integer;  // taille du stack au moment de la dernire division  /  ou  \.
  // un  /  ou un  \  sans tre combin  un + ou un - suivit d'un  \  est limin.

//  nStackSizeDiv4  serait utile pour combiner 9 nombres ou plus.

  fPrintExecption : boolean;  // Pour le dveloppement

begin // Test3
// initialisation
nOp:=5; // nombre d'oprateurs possible, gnralement 4 ou 5.
nNb:=4; // nombre de nombres  combiner,  de 2  7
nNbOp:=nNb+nOp;
nNb2m1:=2*nNb-1;

nNbComb:=0; // nombre de combinaisons stockes
GetMem(pavComb, 500001*SizeOf(Float));   pavComb^[0]:=500000;

// Default values, nombres  combiner.
avNumber[1]:=3;
avNumber[2]:=11;
avNumber[3]:=67;
avNumber[4]:=307;
avNumber[5]:=1403;
avNumber[6]:=9401;
{
avNumber[1]:=sqrt(21);
avNumber[2]:=exp(ln(53)/5);
avNumber[3]:=exp(ln(71)/7);
avNumber[4]:=exp(ln(1113)/13);
}
Randomize;
avNumber[1]:=random;
avNumber[2]:=random;
avNumber[3]:=random;
avNumber[4]:=random;
avNumber[5]:=random;
avNumber[6]:=random;
avNumber[7]:=random;
avNumber[8]:=random;

FloatField(101, avNumber[1]);
FloatField(102, avNumber[2]);
FloatField(103, avNumber[3]);
FloatField(104, avNumber[4]);
FloatField(105, avNumber[5]);
FloatField(106, avNumber[6]);
FloatField(107, avNumber[7]);

//Int32Field(101, nn);
wRep:=IDOK;
//wRep:=DialogExecMSG(12199, @Self);

if (wRep <> IDOK) then exit; // CANCELED the operation

// Initialisation par scurit, inutile en principe
for kk:=1 to nNb do avStack[kk]:=0;

anStackOrder[0]:=0;  // pour viter un warning

// par dfaut, rien n'est affich.
strOut:='';

// anInd[0] deviendra = 2 quand toutes les combinaisons aurons t testes
anInd[0]:=1;

// Au dpart :
// Les deux premier lments du stack sont des nombres
// Ensuite alterne entre nombre et oprateur (+)
anInd[1]:=nOp+1;
anInd[2]:=nOp+2;
anInd[3]:=1;
anInd[4]:=nOp+3;
anInd[5]:=1;
anInd[6]:=nOp+4;
anInd[7]:=1;
anInd[8]:=nOp+5;
anInd[9]:=1;
anInd[10]:=nOp+6;
anInd[11]:=1;
anInd[12]:=nOp+7;
anInd[13]:=1;
anInd[14]:=nOp+8;
anInd[15]:=1;

// Sentinel, dans le cas ou on dpasse la limite du tableau
afUsed[nNbOp+1]:=FALSE;

// combinaison max. trouve
vMax:=0;

WriteWin(1, '---------------------------------------------------------------');
WriteWin(1, '3) Nombres de dpart : ');
for kk:= 1 to nNb do strOut:=strOut + FloatToStr(avNumber[kk],13,9) + '  ;';
WriteWin(1, strOut);  strOut:='';
WriteWin(1, '');

nCount:=0;
nTests:=0;

// ***** BOUCLE PRINCIPALE *****
// Toutes les combinaisons seront teste ici
repeat
   // Le stack est vide, et aucun nombre utilis
   nStack  :=0;
   nStackSizeDiv:=0;
   nStackSizeDiv2:=0;
   nStackSizeDiv3:=0;
fPrintExecption:=false;

   for kk:=nOp+1 to nNbOp do afUsed[kk]:=FALSE;

   // boucle pour une combinaison
   kk:=0;
   repeat
      inc(kk);

      // Si on ne peut pas mettre d'oprations sur le stack, saute
      // les oprations, pour y mettre un nombre
      if (nStack < 2) then while (anInd[kk] <= nOp) do inc(anInd[kk]);

      if (anInd[kk] > nOp) then begin // un nombre a mettre sur le stack.
         while afUsed[anInd[kk]] do inc(anInd[kk]); // saute les nombres dj utiliss

         // si tous les nombre utilis, et plus que des nombres  mettre
         //  sur le stack, on saute une suite des combinaisons impossibles
         if (anInd[kk] > nNbOp) then begin
            // plus de nombre  mettre sur le stack, car tous utiliss.
            { saute des combinaisons }
            for nn:=kk to nNb2m1 do anInd[nn]:=nNbOp;

            goto SKIPtoEND;
            end; { if (ind[kk] > nNbOp) then begin }
         end; { if (ind[kk] >= nOp) then begin }

      { Met l'opration ou le nombre sur le stack }
      if (anInd[kk] <= nOp) then begin
         { ralise une opration, le niveau du stack diminu }
         dec(nStack);

         // Ayant ajout un deuxime oprateur de division,
         // Toutes les oprations peuvent tre considres comme commutatives
         // donc on oblige de respecter un ordre   a b opr.  limine  b a opr.
         if (anStackOrder[nStack] > anStackOrder[nStack+1]) then begin
            // On saute des expressions redondandes
            for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

            goto SKIPtoEND;
            end;

         case anInd[kk] of
           1 : begin
               // Puisque l'addition est associative, on a : a b + c + = a b c + +
               // donc le deuxime cas peut tre limin
               if (anInd[kk-1] <= 2) then begin
                   // On saute des expressions redondandes
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end
               else begin
                  avStack[nStack]:=abs(avStack[nStack] + avStack[nStack+1]);
                  if (nStackSizeDiv  >= nStack) then nStackSizeDiv:=0;
                  if (nStackSizeDiv2 >= nStack) then nStackSizeDiv2:=0;
                  if (nStackSizeDiv3 >= nStack) then nStackSizeDiv3:=0;
                  end;
               end;
           2 : begin
               // Puisque : |a |b c -| -| = |a b -| c +  ou   = |a c -| b +  ou   = ||b c -| a -|
               // donc le premier cas peut tre limin
               // Puisque : a b - c - = a b c + -
               // donc le deuxime cas peut tre limin
               if (anInd[kk-1] <= 2) then begin
                   // On saute des expressions redondandes
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end
               else begin
//for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;
//goto SKIPtoEND;
                  avStack[nStack]:=abs(avStack[nStack] - avStack[nStack+1]);
                  if (nStackSizeDiv  >= nStack) then nStackSizeDiv:=0;
                  if (nStackSizeDiv2 >= nStack) then nStackSizeDiv2:=0;
                  if (nStackSizeDiv3 >= nStack) then nStackSizeDiv3:=0;
                  end;
               end;
           3 : begin
               // Puisque la multiplication est associative, on a : a b * c *  ==  a b c * *
               // donc le deuxime cas peut tre limin
               // Puisque : a b * c /  ==  a b c / *
               // donc le deuxime cas peut tre limin
               if ((anInd[kk-1] >= 3) and (anInd[kk-1] <= nOp)) then begin
                   // On saute des expressions redondandes
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end
               else begin
                  avStack[nStack]:=avStack[nStack] * avStack[nStack+1];
                  end;
               end;
           4 : begin
               // Puisque : a b / c /  ==  a c / b /
               // un des deux cas peut tre limin
               // Puisque : a b / c *  ==  a b c / /
               // donc le deuxime cas peut tre limin
               // Puisque : a b / c /  ==  a b c * /
               // donc le deuxime cas peut tre limin
               if ((anInd[kk-1] >= 3) and (anInd[kk-1] <= nOp)) then begin
                   // On saute des expressions redondandes
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end;

               if (abs(avStack[nStack+1]) < 1e-10) then begin
                  { On saute toutes les combinaisons avec division par 0 }
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;
oRichEditFrame.AppendText('Saute petit nombre :' + FloatToStr(avStack[nStack+1],23,15));
                  goto SKIPtoEND;
                  end;

               avStack[nStack]:=avStack[nStack] / avStack[nStack+1];

               // mmorise la taille du stack lors des dernires divisions
               if (nStackSizeDiv = 0) then nStackSizeDiv:=nStack
               else if (nStackSizeDiv2 = 0) then nStackSizeDiv2:=nStack
               else nStackSizeDiv3:=nStack
               end;
           5 : begin
 //if (nStackSizeDiv >= nStack) then fPrintExecption:=true;  // Pour TESTS
               if (((anInd[kk-1] >= 3) and (anInd[kk-1] <= nOp)) or
                   (nStackSizeDiv  >= nStack*9) or
                   (nStackSizeDiv2 >= nStack*9) or
                   (nStackSizeDiv3 >= nStack*9)) then begin
                   // On saute des expressions redondandes
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end;

               if (abs(avStack[nStack]) < 1e-10) then begin
                  { On saute toutes les combinaisons avec division par 0 }
                  for nn:=kk+1 to nNb2m1 do anInd[nn]:=nNbOp;

                  goto SKIPtoEND;
                  end;

               avStack[nStack]:=avStack[nStack+1] / avStack[nStack];

               // mmorise la taille du stack lors des dernires divisions
               if (nStackSizeDiv = 0) then nStackSizeDiv:=nStack
               else if (nStackSizeDiv2 = 0) then nStackSizeDiv2:=nStack
               else nStackSizeDiv3:=nStack
               end;
           end; { case }

           // mmorise toujours l'ordre le plus grand
           if (anStackOrder[nStack] <  anStackOrder[nStack+1]) then
               anStackOrder[nStack] := anStackOrder[nStack+1];

         end // if (anInd[kk] <= nOp) then begin
      else begin
         { met un nombre sur le stack }
         inc(nStack);
         avStack[nStack]:=avNumber[anInd[kk] - nOp];
         anStackOrder[nStack]:=anInd[kk]; // ordre pour liminer les cas redondants
         afUsed[anInd[kk]]:=TRUE;  { ce nombre a t utilis }
         end;

      until (kk >= nNb2m1);

   { Le rsultat d'une combinaison est sur le stack, test si il
     est plus grand que le plus grand rsultat dj obtenu }
//   if (vMax < avStack[1]) then begin
   if (fPrintExecption or (nCount < 0)) then begin
      { Affiche les oprations  faire }
nn:=0;
      for kk:=1 to nNb2m1 do begin
         if (anInd[kk] <= nOp) then begin
            case anInd[kk] of
              1 : strOut:=strOut + ' + ';
              2 : strOut:=strOut + ' - ';
              3 : strOut:=strOut + ' * ';
              4 : strOut:=strOut + ' / ';
              5 : strOut:=strOut + ' \ ';
              end; { case }
 case anInd[kk] of
   5 : inc(nn);
   end; { case }
            end
         else strOut:=strOut + FloatToStr(avNumber[anInd[kk] - nOp],12,4);
         end; { for }

      strOut:=FloatToStr(avStack[1],17,9) + ' = ' + strOut;

      // affiche le rsultat et rinitialise  "vide" la chaine de sortie.
if (nn > 0) then      WriteWin(1, strOut);  strOut:='';

      vMax:=avStack[1];
      end;

   // Une combinaison de plus.
  if (nNbComb < pavComb^[0]) then
      begin  // ne garde que certains nombres.
      inc(nNbComb);
      pavComb^[nNbComb]:=avStack[1];
      end;

   // Une expression de plus compte.
   inc(nCount);

   if (nCount mod 500000 = 0) then begin
     WriteWin(1, 'nCount =' + ITS(nCount));
     LetDisplayInfo;  // let the text beeing displayed.
     end;

   { label dans le cas ou des combinaisons sont sautes  }
   SKIPtoEND:;

   // Un test de plus, y compris ceux d'expressions redondandes
   inc(nTests);

   { passage  la combinaison suivante }
   kk:=nNb2m1+1;
   repeat
      dec(kk);
      inc(anInd[kk]);
      if (anInd[kk] > nNbOp) then anInd[kk]:=1;
      until (anInd[kk] > 1);

   { Si anInd[0] = 2, toutes les combinaisons ont t testes }
   until (anInd[0] = 2);

WriteWin(1, 'nCount =' + ITS(nCount) + '   nTests =' + ITS(nTests));

// trie toutes les solutions.
QSort(1, nNbComb, pavComb^);

// Compte le nombre de solutions diffrentes.
nCount:=1;
vMax:=pavComb^[1] + 1e-10;
for nn:=2 to nNbComb do begin
  if (vMax < pavComb^[nn]) then begin
     inc(nCount);
     vMax:=pavComb^[nn]*(1 + 1e-10);
     end;
  end;

WriteWin(1, 'nb. sol. diffrentes sans signe =' + ITS(nCount));
WriteWin(1, 'premier =' + FloatToStr(pavComb^[1],23,19));
WriteWin(1, 'dernier =' + FloatToStr(pavComb^[nNbComb],23,19));

{
// Recherche de la plus petite diffrence
nCount:=1;
vMax:=1000;
for nn:=2 to nNbComb do begin
  if ((pavComb^[nn] > pavComb^[nn-1] + 1e-10) and
      (vMax > pavComb^[nn] - pavComb^[nn-1])) then begin
     inc(nCount);
     vMax:=pavComb^[nn] - pavComb^[nn-1];
     end;
  end;

WriteWin(1, 'plus petite diff. =' + FloatToStr(vMax*1e12,23,15));
}
//oRichEditFrame.AppendText('Number of throws =' + FloatToStr(vMax,9,5));
//oRichEditFrame.AppendText('Size = ' + FTS(SizeOf(pavComb^)));
FreeMem(pavComb, round(1+pavComb^[0])*sizeOf(Float));
end;  // TMyWindow.Test3

procedure TMyWindow.Test4;
//========================
// Toutes les expressions, en utilisant les 5 oprateurs  + - * / \
// et en permettant d'oprer sur des nombres plus profond dans la pile que l'avant dernier.
label Finished;
var
  anStackSize       : array[0..MAXNUMBER*2] of integer;
  // taille du stack aprs placement du nombre ou aprs l'opration

  anStackRef        : array[0..MAXNUMBER*2] of integer;
  // = 0 si code un oprateur
  // = le numro d'ordre de la liste des oprandes (=lettres = nombres).

  anStackOrder      : array[0..MAXNUMBER*2] of integer;
  // = l'ordre maximal des deux oprandes utilis par l'oprateur  ou
  // = le numro d'ordre de la liste des oprandes (=lettres = nombres).

  anStackOperAct    : array[0..MAXNUMBER*2] of integer;
  // Pour les oprateurs, l'oprateur anStackRef[nn]
  // agit sur les deux nombres :
  // anStackRef[nn-1] et sur anStackRef[anStackOperAct[nn]]
  // Pour une oprande, anStackOperAct[nn] = nn;

  afUsed           : array[0..MAXNUMBER] of boolean;
  // Indique si l'oprande a dj t mis dans le stack (= la pile)

  nOrderMax      : integer;
  // pour la recherche d'oprande  remplac par le suivant.

//  nStack,     { nombre d'lment dans le stack }
  nCount,     // combre le nombre d'expressions testes.
  nTests,     // nombres de tests effectus, y compris ceux limins.
  nMem,
  kk,
  nn          : int32;
  strS        : string;  // rsultat final, qui sera affich.

begin // test4
// dfinition d'une police plus agrable
SetWriteWinFont(1, 'Courier New', 12, '');

// Initialisation
// initialisation
nOp:=5; // nombre d'oprateurs possible, gnralement 4 ou 5.
nNb:=6; // nombre de nombres  combiner,  de 2  7
nNbOp:=nNb+nOp;
nNb2m1:=2*nNb-1;

// Etat de la stucture de donne au dpart.
anStackSize [0]:=0;
anStackSize [1]:=1;
anStackOrder[1]:=1;
anStackRef  [1]:=1;
anStackRef  [0]:=0;  // sentinelle
anStackOrder[0]:=0;  // sentinelle
afUsed[1]:=true;
anStackOperAct[1]:=1;

for nn:=1 to nNb-1 do begin
  anStackSize [2*nn  ]:=2;
  anStackOrder[2*nn  ]:=nn+1;
  anStackRef  [2*nn  ]:=nn+1;
  anStackOperAct[2*nn]:=2*nn;  // pour les oprandes
  anStackSize [2*nn+1]:=1;
  anStackOrder[2*nn+1]:=nn+1;
  anStackRef  [2*nn+1]:=0;
  anStackOperAct[2*nn+1]:=2*nn-1; // pointe sur l'oprateur prcdent
  afUsed[nn+1]:=true;
  end;

nOrderMax:=nNb-1;

nCount:=0;
  
//WriteWin(1, '      1     2     3     4     5     6     7    8    9   10   11');

// ***** BOUCLE PRINCIPALE *****
// Toutes les combinaisons seront teste ici
repeat
  // pour afficher la liste des oprations  faire
  inc(nCount);
  strS:=IntToStr(nCount,3) + ')  ';
  for nn:=1 to nNb2m1 do begin
    strS:=strS; //  + IntToStr(anStackSize[nn],1);
{
    if (anStackRef[nn] = 0) then strS:=strS + '+' + IntToStr(anStackOrder[nn],1) + IntToStr(anStackOperAct[nn],1) + '  '
    else begin
      strS:=strS + char(96 + anStackRef[nn]) + IntToStr(anStackOrder[nn],1) + '   ';
      end;
}
    if (anStackRef[nn] = 0) then strS:=strS + '+  '
    else begin
      strS:=strS + char(96 + anStackRef[nn]) + '  ';
      end;
    end;

  WriteWin(1, strS);



// A FAIRE LA BOUCLE DE CALCULS ICI !!!!,   c.f.  test3...  ou  test8...




  // ============ Codage suivant.
  if (nOrderMax = 1) then goto Finished;

  // recherche, de droite  gauche, la position du dernier oprande
  // le permier trouv est celui d'ordre le plus grand
  nn:=nNb2m1;
  repeat dec(nn) until (anStackRef[nn] > 0);

  nMem:=nn;
  // recherche de l'oprateur prcdent le dernier oprande
  repeat dec(nn); until (anStackRef[nn] = 0);

  if (nn > 0) then begin
    // oprateur trouv, on le remplace par le dernier oprande trouv lors de la recherche
    anStackOrder[nn]:=anStackRef[nn+1];
    anStackRef[nn]  :=anStackRef[nn+1];
    anStackSize[nn] :=anStackSize[nn-1]+1;
    for kk:=nn+1 to nMem do afUsed[anStackRef[kk]]:=false; // libre certaine oprandes
    end
  else begin
    // oprateur non trouv, tous les oprandes se trouvent  gauche
    // recherche de l'oprande d'ordre maximal autoris
    nn:=nNb;
    repeat
      dec(nn);
      afUsed[anStackRef[nn]]:=false;  // ces oprandes ne sont plus utiliss.
      until (anStackRef[nn] = nOrderMax);

    // remplace l'oprande de position prcdente par l'oprande d'ordre le plus bas et non utilis
    dec(nn);
    afUsed[anStackRef[nn]]:=false;
    repeat
      inc(anStackRef[nn]);
      inc(anStackOrder[nn]);
      until (not afUsed[anStackRef[nn]]);

    if (anStackRef[1] = nNb-1) then begin
      nOrderMax:=nNb-2;
      if (anStackRef[2] = nNb-2) then begin
        nOrderMax:=nNb-3;
        if (anStackRef[3] = nNb-3) then begin
          nOrderMax:=nNb-4;
          if (anStackRef[4] = nNb-4) then begin
            nOrderMax:=nNb-5;
            if (anStackRef[5] = nNb-5) then begin
              nOrderMax:=nNb-6;
              if (anStackRef[6] = nNb-6) then begin
                nOrderMax:=nNb-7;
                end;
              end;
            end;
          end;
        end;
      end;
    end; // if (nn > 0) then begin

  afUsed[anStackRef[nn]]:=true;
  anStackOperAct[nn]:=nn;  // oprande plac sur le stack

  // de gauche  droite, dfini le nouveau codage des oprations du stack
  //"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
  afUsed[nNb]:=false;
  repeat
    inc(nn);
    if (anStackSize[nn-1] = 1) then begin
      // Une oprande est place sur le stack
      kk:=0;
      repeat inc(kk); until (not afUsed[kk]);
      anStackRef[nn]  :=kk;
      anStackOrder[nn]:=kk;
      afUsed[kk]      :=true;
      anStackSize[nn] :=2;
      anStackOperAct[nn]:=nn;  // oprande plac sur le stack
      end
    else if (anStackOrder[nn-1] > anStackOrder[anStackOperAct[nn-1]-1]) then begin
      // Un oprateur est plac sur le stack
      anStackRef[nn]:=0;
      anStackOperAct[nn]:=anStackOperAct[anStackOperAct[nn-1]]-1;

      // mmorise l'ordre le plus grand des deux oprateurs
      anStackOrder[nn]:=anStackOrder[nn-1];
      if (anStackOrder[nn] < anStackOrder[anStackOperAct[nn]]) then
        anStackOrder[nn]:=anStackOrder[anStackOperAct[nn]];

      anStackSize[nn]:=anStackSize[nn-1]-1;
      end
    else begin
      // une nouvelle oprande doit tre plac sur le stack.
      kk:=0;
      repeat inc(kk); until (not afUsed[kk]);
      anStackRef[nn]:=kk;
      anStackOrder[nn]:=kk;
      anStackSize[nn]:=anStackSize[nn-1]+1;
      anStackOperAct[nn]:=nn;
      afUsed[kk]:=true;
      end;

    until (nn = nNb2m1);


nTests:=0;
inc(nTests);
//WriteWin(1, IntToStr(nCount,2) + ')  nTests = ' + ITS(nTests));

  until ((nOrderMax = 0) or (nCount >= 900));

Finished:
//WriteWin(1, 'nSum = ' + ITS(nSum));

end;  // TMyWindow.Test4

procedure TMyWindow.Test8;
//========================
// Toutes les expressions, en utilisant les 5 oprateurs  + - * / \
// et en permettant d'oprer sur des nombres plus profond dans la pile que l'avant dernier.
var
  anStackSize       : array[0..MAXNUMBER*2] of integer;
  // taille du stack aprs placement du nombre ou aprs l'opration

  anOrder          : array[0..MAXNUMBER*2] of integer;
  // = 0 si code un nombre (= une oprande)
  // = le numro d'ordre, de gauche  droite, de l'oprateur si s'en est un.

  anOperStackSize  : array[0..MAXNUMBER] of integer;
  // Pour les oprateurs, taille du stack aprs l'opration

  anOperDepth      : array[0..MAXNUMBER] of integer;
  // Pour les oprateurs, profondeur d'action.

  anOperCode       : array[0..MAXNUMBER] of integer;
  // Pour les oprateurs, code l'opration  faire.
  // 1 => +   2 => -   3 => *   4 => /   5 => \

  afOperHasPrevius : array[0..MAXNUMBER] of boolean;
  // indique si l'oprateur est prcd directement d'un autre oprateur.
  // Est utile pour liminer des redondance d'associativit.

//  avStack          : array[0..MAXNUMBER] of Float;
  { Contiendra les rsultats des oprations, qui se font en notation
    polonaise inverse }

  kk,         { indice de ind, pour mettre les nombres et/ou oprations sur le stack }
//  nStack,     { nombre d'lment dans le stack }
  nCount,     // combre le nombre d'expressions testes.
  nTests,     // nombres de tests effectus, y compris ceux limins.
  nn,
  jj          : int32;
  strS        : string;  // rsultat final, qui sera affich.
  fOk         : boolean;
  nOperande   : integer; // indique le numro de l'oprande utilise

nSum : int32;  // compte le nombre d'oprations

begin // Test8
// dfinition d'une police plus agrable
SetWriteWinFont(1, 'Courier New', 12, '');

// Initialisation
// initialisation
nOp:=5; // nombre d'oprateurs possible, gnralement 4 ou 5.
nNb:=4; // nombre de nombres  combiner,  de 2  7
nNbOp:=nNb+nOp;
nNb2m1:=2*nNb-1;

// Default values, nombres  combiner.
avNumber[1]:=3;
avNumber[2]:=11;
avNumber[3]:=67;
avNumber[4]:=307;
avNumber[5]:=1403;
avNumber[6]:=9401;

Randomize;
avNumber[1]:=random;
avNumber[2]:=random;
avNumber[3]:=random;
avNumber[4]:=random;
avNumber[5]:=random;
avNumber[6]:=random;
avNumber[7]:=random;
avNumber[8]:=random;


anOrder[0]     :=1;  // scurit en cas d'erreur de programmation
anOperDepth[0] :=1; // sentinelle

// Etat de la stucture de donne au dpart.
anStackSize[1]:=1;
anOrder[1]:=0;

for nn:=1 to nNb-1 do begin
  anStackSize [2*nn  ]:=2;
  anOrder     [2*nn  ]:=0;
  anStackSize [2*nn+1]:=1;
  anOrder     [2*nn+1]:=nn;
  end;

WriteWin(1, '---------------------------------------------------------------');
WriteWin(1, '4) Nombres de dpart : ');
strS:='';
for kk:= 1 to nNb do strS:=strS + FloatToStr(avNumber[kk],13,9) + '  ;';
WriteWin(1, strS);  strS:='';
WriteWin(1, '');

nCount:=0;
nTests:=0;
nSum:=0;

// Initialise les oprations  '+' et la profondeur  1.
for kk:=1 to nNb-1 do begin
  anOperDepth[kk]:=1; // on commence par la profondeur minimale
  anOperCode [kk]:=1; // on commence par une addition
  anOperStackSize[kk]:=1; // reste fixe dans la boucle secondaire
  afOperHasPrevius[kk]:=false;  // non prcd d'au autre oprateur
  end;

// ***** BOUCLE PRINCIPALE *****
// Toutes les combinaisons seront teste ici
repeat
  // pour afficher la liste des oprations  faire
  nOperande:=0;
  strS:='';
  for nn:=1 to nNb2m1 do begin
    strS:=strS + IntToStr(anStackSize[nn],1);

    if (anOrder[nn] > 0) then strS:=strS + '+  '
    else begin
      inc(nOperande);
      strS:=strS + char(96+nOperande) + '  ';
      end;
    end;

  WriteWin(1, strS);

nTests:=0;

  //============ REALISATION DE CALCULS POUR LA COMBINAISON DONNE
  repeat
    // Effectue un calcul
    strS:='';
    nOperande:=0;
    for kk:=1 to nNb2m1 do begin
      if (anOrder[kk] > 0) then begin
        case anOperCode[anOrder[kk]] of
          1 : strS:=strS+'+';
          2 : strS:=strS+'-';
          3 : strS:=strS+'*';
          4 : strS:=strS+'/';
          5 : strS:=strS+'\';
          else strS:=strS + 'erreur';
          end; // case

        strS:=strS + IntToStr(anOperDepth[anOrder[kk]],1) + ' ';
        end
      else begin
        inc(nOperande);
        strS:=strS + chr(96+nOperande) + ' ';  // oprande mise sur le stack
        end;
      end; // for kk:=...

    // Affiche les oprations  faire.

WriteWin(1, strS);

inc(nTests);
inc(nSum);
    // Passage  l'opration suivante, en listant l'ordre des oprateurs.
    nn:=nNb;
    fOK:=false;
    repeat
      repeat
        dec(nn);
        inc(anOperCode[nn]);  // oprateur suivant

        // Il reste  liiner les deux cas de redondance :
        // 1) x y / z \  =  x y \ z *
        // 2) x y \ z \  =  x y / z *
        //    x ; y  et  z  peuvent tre n'importe quelle expression donnant un nombre
        // 1_bis) x y / v * z \  =  x y \ v / z *
        // 2_bis) x y \ v * z \  =  x y / v / z *
        // ( 1_bis) x y / v / z \  =  x y / v \ z *  pas intressant )
{
        if (anOperCode[nn] = nOp) then begin
          if (anOperCode[nn-1] >= 4) and
             (anOperStackSize[nn-1] = anOperStackSize[nn])
             then begin
               // limine ce cas
               inc(anOperCode[nn]);   IL FAUT TENIR COMPTE DE anOpenDepth[...] !!!
               end;

          if (nn >= 3) then begin
            if (anOperCode[nn-2] >= 4) and
               (anOperStackSize[nn-2] = anOperStackSize[nn]) and
               ((anOperCode[nn-1]  = 3) or
                (anOperStackSize[nn-1] - anOperDepth[nn-1] >= anOperStackSize[nn]))
             then begin
               // limine ce cas
               inc(anOperCode[nn]);
               end;
            end; // if (nn >= 3) then begin

          if (nn >= 4) then begin
            if (anOperCode[nn-3] >= 4) and
               (anOperStackSize[nn-3] = anOperStackSize[nn]) and
               ((anOperCode[nn-2] = 3) or (anOperStackSize[nn-2] > anOperStackSize[nn])) and
               ((anOperCode[nn-1] = 3) or (anOperStackSize[nn-1] > anOperStackSize[nn]))
             then begin
               // limine ce cas
               inc(anOperCode[nn]);
               end;
            end; // if (nn >= 4) then begin

          end; // if (anOperCode[nn] = nOp) then begin
}
        if (anOperCode[nn] > nOp) then begin
          anOperCode[nn]:=1;

          // profondeur d'opration suivante
          inc(anOperDepth[nn]);

          if (anOperDepth[nn] > anOperStackSize[nn]) then begin
            anOperDepth[nn]:=1;
            end
          else fOK:=true;
          end
        else fOK:=true;

        until (fOK or (nn = 1));

      // Test les liminations par associativit.
      //""""""""""""""""""""""""""""""""""""""""  dur ... dur
      kk:=2;
      repeat
        if (afOperHasPrevius[kk]) then begin
          // L'oprateur en position "kk" est prcd immdiatement d'un autre oprateur.
          // par associativit,
          // limine les + et - qui se suivent, ainsi que les * ; / et \ qui se suivent.
          if (anOperCode[kk-1] <= 2) then begin
            if (anOperCode[kk] <= 2) then anOperCode[kk]:=3; // limine les + et - qui se suivent
            end
          else begin  // ici anOperCode[kk-1] >= 3
            if (anOperCode[kk] >= 3) then begin
              if (anOperDepth[kk] < anOperStackSize[kk]) then begin
                inc(anOperDepth[kk]);
                end
              else begin
                anOperDepth[kk]:=1;
                fOK:=false; // il faut passer  la suite suivante d'oprations
                nn:=kk;
                end;

              anOperCode[kk]:=1;

              // saute toutes les suites faisant intervenir deux * ; / et \ qui se suivent
              for jj:=kk+1 to nNb-1 do begin
                 anOperCode[jj]:=1;
                 anOperDepth[jj]:=1;
                 end;
              end;
            end;
          end;

        inc(kk);
        until (not fOK) or (kk = nNb);

      until (fOK or (nn = 1));

    // l'opration suivante a t trouve

    until (not fOK) or (nTests > 300000);
  // ============ FIN DE REALISATION DE CALCULS POUR LA COMBINAISON DONNE

  // Passage au codage (= la combinaison) suivant
  //=============================================

  // recherche de l'oprateur prcdent le dernier oprande
  nn:=nNb2m1;
  repeat dec(nn) until (anOrder[nn] = 0);

  if (nn > nNb) then begin
    // passage au codage suivant
    repeat dec(nn) until (anOrder[nn] > 0);  // position de l'oprateur

    // position dans anOper... de l'oprateur prcdent le dernier oprande
    kk:=anOrder[nn];

    anOrder[nn]:=0; // place une oprande
    anStackSize[nn]:=anStackSize[nn]+2;
    anOperStackSize[kk]:=anStackSize[nn];
    afOperHasPrevius[kk]:=false;  // n'a pas un oprateur qui le prcde directement

    // de gauche  droite, dfini le nouveau codage des oprations du stack
    repeat
      inc(nn);
      if (anStackSize[nn-1] = 1) then begin
        // Une oprande est place sur le stack
        anOrder[nn]:=0;
        anStackSize[nn]:=2;
        end
      else begin
        // Un oprateur est plac sur le stack
        anOrder[nn]:=kk;
        anStackSize[nn]:=anStackSize[nn-1]-1;
        anOperStackSize[kk]:=anStackSize[nn];
        afOperHasPrevius[kk]:=(anOrder[nn-1] > 0); // indique si prcd d'un oprateur
        inc(kk);
        end
      until (nn = nNb2m1);

    // Initialise les oprations  '+' et  la profondeur  1.
    // Mais vite deux additions  '+'  qui se suivent immdiatement.
    anOperDepth[1]:=1;
    anOperCode[1]:=1;
    for kk:=2 to nNb-1 do begin
      anOperDepth[kk]:=1; // on commence par la profondeur minimale

      if (afOperHasPrevius[kk]) and ((anOperCode[kk-1]) = 1) then
           anOperCode[kk]:=3 // Evite deux additions qui se suivent immdiatement.
      else anOperCode[kk]:=1; // on commence par une addition
      end;

    end; // if
  // else on a termin

inc(nCount);
WriteWin(1, IntToStr(nCount,2) + ')  nTests = ' + ITS(nTests));

  until (nn <= nNb) or (nCount >= 70);

WriteWin(1, 'nSum = ' + ITS(nSum));

end;  // TMyWindow.Test9


procedure TMyWindow.Test9;
//========================
// Lecture du fichier de donnes de rsolution du compte est bon
type
  TypeArrayByte  = array[0..100000000] of Byte;
  PTypeArrayByte = ^TypeArrayByte;
var
  { variables concernant les operations a faire }
  oper : byte; {operation a faire}
  fich : file of byte;
  pabMem1  : PTypeArrayByte;
  nn       : int32;
  nRidden1  : int32;
  nRidden2  : int32;
  nSize     : int32; // nombre de bytes lus au total
  strS     : String[200];  // lite des oprations  faire
  nCount   : int32;  // compte le nombre d'oprateur au total.

begin // Test9
// dfinition d'une police plus agrable
SetWriteWinFont(1, 'Courier New', 12, '');

GetMem(pabMem1, 600001);

for nn:=0 to 600000 do pabMem1^[nn]:=0;

{$I+}
// Lecture de la premire partie
assign(fich,'cptbop61.dat');
reset(fich);
BlockRead(fich, pabMem1^[1], 500000, nRidden1);
close(fich);
WriteWin(1, 'nRidden=' + ITS(nRidden1));

// vrification
strS:='';
for nn:=327670 to 327682 do strS:=strS + IntToStr(pabMem1^[nn] and $F,3) + IntToStr(pabMem1^[nn] shr 4,3);
WriteWin(1, 'strS=' + strS);

// Lecture de la deuxime partie
assign(fich,'cptbop62.dat');
reset(fich);
BlockRead(fich, pabMem1^[nRidden1+1], 500000, nRidden2);
close(fich);
WriteWin(1, 'nRidden=' + ITS(nRidden2));

// taille total des deux fichiers.
nSize:=nRidden1 + nRidden2;

// vrification
strS:='';
for nn:=327670 to 327682 do strS:=strS + IntToStr(pabMem1^[nn] and $F,3) + IntToStr(pabMem1^[nn] shr 4,3);
WriteWin(1, 'strS=' + strS);

strS:='';
for nn:=1 to 140 do begin
  oper:=pabMem1^[nn] and $F;
  case oper of
     0 : strS:=strS + 'a ';
     1 : strS:=strS + 'b ';
     2 : strS:=strS + 'c ';
     3 : strS:=strS + 'd ';
     4 : strS:=strS + 'e ';
     5 : strS:=strS + 'f ';
     6 : strS:=strS + '+ ';
     7 : strS:=strS + '- ';
     8 : strS:=strS + '* ';
     9 : strS:=strS + '/ ';
    10 : strS:=strS + 'P ';
    11 : strS:=strS + 'M ';
    12 : strS:=strS + 'F ';
    13 : strS:=strS + 'D ';
    14 : begin WriteWin(1, strS);  strS:=''; end;
    15 : begin WriteWin(1, strS);  strS:=''; WriteWin(1, ''); end;
    end; // case

  oper:=pabMem1^[nn] shr 4;
  case oper of
     0 : strS:=strS + 'a ';
     1 : strS:=strS + 'b ';
     2 : strS:=strS + 'c ';
     3 : strS:=strS + 'd ';
     4 : strS:=strS + 'e ';
     5 : strS:=strS + 'f ';
     6 : strS:=strS + '+ ';
     7 : strS:=strS + '- ';
     8 : strS:=strS + '* ';
     9 : strS:=strS + '/ ';
    10 : strS:=strS + 'P ';
    11 : strS:=strS + 'M ';
    12 : strS:=strS + 'F ';
    13 : strS:=strS + 'D ';
    14 : begin WriteWin(1, strS);  strS:=''; end;
    15 : begin WriteWin(1, strS);  strS:=''; WriteWin(1, ''); end;
    end; // case
  end; // for

WriteWin(1, strS);

// Compte le nombre d'oprateurs.
nCount:=0;
for nn:=1 to nSize do begin
  oper:=pabMem1^[nn] and $F;
  if (oper >=6) and (oper <=13) then inc(nCount);

  oper:=pabMem1^[nn] shr 4;
  if (oper >=6) and (oper <=13) then inc(nCount);
  end; // for

WriteWin(1, 'Nombre d''oprateurs = ' + ITS(nCount));

FreeMem(pabMem1, 600001);
end;  // TMyWindow.Test9

procedure TMyWindow.MenuCreate;
//=============================
// Create the menu, override the default method of  TWindowText
begin
new(poMenu, Init(@Self));
hMenuWin:=poMenu^.MenuMsgCreate(10000);
end;  // TMyWindow.MenuCreate

procedure TMyWindow.WinCreate(strWinClass:ShortString);
//=====================================================
Begin
inherited WinCreate(strWinClass);

poToolBar:=PToolBar(ToolBarCreateMSG(11199, @self));

// The size of the RichEditFrame must be shorten
oRichEditFrame.nYSizePix:=oRichEditFrame.nYSizePix - poToolBar^.nYSizePix;
oRichEditFrame.nYPosPix := poToolBar^.nYSizePix;

// Repaint the RichEditFrame
oRichEditFrame.NotifyParentResize(TRUE);
end;  // TMyWindow.WinCreate

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// Handles the menu messages
Var wNrMenu     : word;
begin
WMCommand := 0; // Default return value when processing a message

if (lPar <> 0) then begin
   // call the parent WMCommand method.
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;

// for the menus,  lPar = 0
//=========================
wNrMenu   := LoWord(wPar);
Case wNrMenu Of
   1010 : Test1;
   1020 : Test2;
   1030 : Test3;
   1040 : Test4;
   1080 : Test8;
   1090 : Test9;

   else WMCommand:=inherited WMCommand(wPar, lPar);
   end;  // Case NrMenu Of
end;  // TMyWindow.WMCommand

//**********************************************************************
Begin // MAIN ******
// Name under which the main window is registered. Spaces are not allowed
oApp.Init('Example080');

// Creation of the main window
new(poMyMainWin, Init('tEx080.  Compte est Bon, solveur'));

// The App.WindowClass can be modified here, if wanted. (Not usual)
oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.

