{ Gnration d'un calendrier perptuel
  --------------------------------------------}
program tEx081_Calendrier_Perpetuel;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses

  wApplication0
 ,wWindowText0 // To write text in an independent window
 ,wWindow0
 ,wDialog0
 ,wGlobals2
 ,wVariableNumLink2
 ,wDialogCreatorLOW2
 ,wDialogCreator2
// ,wUtiles0
 ,wMessages2
 ,wDebug0
 ,Windows
 ,commDlg;   { !!!  AJOUTER A LA VERSION 2.40 de Freeplascal, sinon problme !!! }

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  // To do simulations, some parameters that can be changed in a dialog box.
  nIter     : int32;  // number of iteration
  nNbFaces  : int32;  // number of faces, between 1 and 40
  nNbPieces : int32;  // number of pieces (number) taken during one experiment

  constructor Init(strWinTitlePrm:ShortString);
  destructor Done; virtual;

  procedure Test1;
  procedure Test2;
  procedure Test3;
  procedure Test4;

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

type
  TArrayInt = array[0..1000] of int32;
  TArrayFlo = array[0..1000] of Float;

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);

// This line is all what is needed to have a status line.
new(poStatusLine, Init(@Self));

// Default values
nIter:=100000;
nNbFaces:=6;
nNbPieces:=80;
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//=========================
begin

inherited Done;
end;  // TMyWindow.Done

//####################################################################################

{$R-}  // Range check error off  if  $R-

procedure MySetWriteFont;
//=======================
// dfini la police en courrier new
var
  strS        : string[80];
  astrFont    : array[1..4] of string[30];
  rLogFont    : TLogFont;
  pWinText    : PWindowText0;

begin
astrFont[1]:='Arial';
astrFont[2]:='Times New Roman';
astrFont[3]:='Courier New';
astrFont[4]:='Comic Sans MS';  // if you have it.

// define a new font.
strS:=astrFont[1]+#0;
with rLogFont do  begin
//   lfHeight         := 0;                // Default logical height of font
   lfWidth          := 0;                // Default logical average character width
   lfEscapement     := 0;                // angle of escapement
   lfOrientation    := 0;                // base-line orientation angle
   lfWeight         := FW_NORMAL;        // font weight = 400
   lfItalic         := 0;                // italic attribute flag
   lfUnderline      := 0;                // underline attribute flag
   lfStrikeOut      := 0;                // strikeout attribute flag
   lfCharSet        := DEFAULT_CHARSET;  // character set identifier
   lfOutPrecision   := OUT_DEFAULT_PRECIS;  // output precision
   lfClipPrecision  := CLIP_DEFAULT_PRECIS; // clipping precision
   lfQuality        := DEFAULT_QUALITY;     // output quality
   lfPitchAndFamily := DEFAULT_PITCH;    // pitch and family
   lfFaceName       :=PCHAR(@strS[1]);   // pointer to typeface name string
//   lfWeight:=400; // normal, could go up to 1000 for very bold
   lfHeight:=-12;
   end; // with

pWinText:=GetWriteWinNr(1);
if (pWinText <> NIL) then pWinText^.oRichEditFrame.SetActualFont(rLogFont);
//if (pWinText <> NIL) then pWinText^.oRichEditFrame.SetActualFont(pWinText^.oRichEditFrame.TheLogFont);
end; //  MySetWriteFont

//####################################################################################

function GetWeekDay(nDay, nMonth, nYear:integer):integer;
//=======================================================
// Retourne le jours de la semaine correspondante  la date.  De 1  7
var nDayYear, nDayMonth, nDayWeek : integer;
begin
// Formule du calcul du jour de la semaine d'une date donne.
//Correction du mois
nDayMonth:=0;
if ((nMonth = 1) or (nMonth = 10)) then nDayMonth:=0;
if ((nMonth = 5))                  then nDayMonth:=1;
if ((nMonth = 8))                  then nDayMonth:=2;
if ((nMonth = 2) or (nMonth =  3) or (nMonth = 11)) then nDayMonth:=3;
if ((nMonth = 6))                  then nDayMonth:=4;
if ((nMonth = 9) or (nMonth = 12)) then nDayMonth:=5;
if ((nMonth = 4) or (nMonth =  7)) then nDayMonth:=6;

// Correction des annes bissextiles
if ((nYear mod 400 = 0) or
    ((nYear mod 4 = 0) and (nYear mod 100 <> 0))) then begin
   // Correction si le mois est janvier ou fvrier
   if (nMonth <= 2) then dec(nDayMonth);
   end;

// 1 janvier 1500 = 1 janvier 1900 = lundi
// 1 janvier 1600 = 1 janvier 2000 = samedi
// 1 janvier 1700 = 1 janvier 2100 = vendredi
// 1 janvier 1800 = 1 janvier 2200 = mercredi
case ((nYear div 100 + 1) mod 4) of
  0 : nDayYear:=0;
  1 : nDayYear:=6;
  2 : nDayYear:=4;
  3 : nDayYear:=2;
  end; // case

nYear:=nYear mod 100;
nDayWeek:=nDayYear + nYear + (nYear div 4) + nDay + nDayMonth;

nDayWeek:=nDayWeek mod 7;
if (nDayWeek = 0) then GetWeekDay:=7 else GetWeekDay:=nDayWeek;
end;

procedure NextDay(var nDay, nMonth:integer; nYear:integer);
//=========================================================
// Retourne le jour et le mois suivant de l'anne en question.
begin
if (nMonth =  2) then begin
  // cas du mois de Fvrier
  if (nDay < 28) then begin
    inc(nDay);
    end
  else if ((nDay = 28) and
           ((nYear mod 400 = 0) or
            ((nYear mod 4 = 0) and (nYear mod 100 <> 0)))) then begin
          // 29me jour d'une anne bissextile
          inc(nDay);
          end
  else begin
    // passage au mois suivant
    inc(nMonth);
    nDay:=1;
    end;
  end  // fin de test du mois de Fvrier
else if ((nMonth =  4) or (nMonth =  6) or (nMonth = 9) or (nMonth = 11)) then begin
  if (nDay < 30) then inc(nDay)
  else begin
    inc(nMonth);
    nDay:=1;
    end;
  end
else begin
  if (nDay < 31) then inc(nDay)
  else begin
    inc(nMonth);
    nDay:=1;
    end;
  end;
end; // NextDay

procedure TMyWindow.Test1;
//========================
// Simulate the throw of a dice
var
//  nn       : int32;
//  wRep     : word32; // answer of the dialog box
  nDay,
  nMonth,
  nMonthLast,
  nYear,
  jj,      // pour le dcalage des jours vides de la premire semaine
  kk       : integer; // indice du jour de lundi (=1)  dimanche (=7)
  astrS    : array[1..7] of string;
  strYear  : string; // deux dernires dcimales de l'anne.

begin
// initialisation

WriteWin(1, ' ');
MySetWriteFont;  // pour dfinir le type de police de caractres.

// Premire anne du sicle trait.
nYear:=1900;

// Boucle sur un sicle
//======================
repeat
  nMonth:=1;

  if ((nYear mod 100) < 10) then strYear:='0' + intToStr((nYear mod 100),1)
  else                           strYear:=intToStr((nYear mod 100),2);

  // Cas particuliers des dbuts de sicles, non bissextiles
  if ( ((nYear mod 100) = 0) and ((nYear mod 400) <> 0) ) then strYear:='';

  WriteWin(1, 'JFMAMJ');
  astrS[1]:='xxLu';
  astrS[2]:=strYear + 'Ma';
  astrS[3]:=intToStr(((nYear + 28) mod 100),2) + 'Me';
  astrS[4]:=intToStr(((nYear + 56) mod 100),2) + 'Je';
  if ((nYear mod 100) < 16) then  astrS[5]:=intToStr(((nYear + 84) mod 100),2) + 'Ve'
  else                            astrS[5]:='Ve';
  astrS[6]:='Sa';
  astrS[7]:='Di';

  // Cas particuliers des dbuts de sicles, non bissextiles, identique aux annes ..06.
  if ( ((nYear mod 100) = 6) and ((nYear mod 400) <> 0) ) then astrS[7]:='00Di';

  // Rcupre le premier jour de l'anne  kk = 1 pour un lundi
  kk:=GetWeekDay(1, 1, nYear+28);  // + 28 pour viter les dbut de sicles

  repeat
    // dbut d'un mois
    nMonthLast:=nMonth;
    nDay:=1;

    // dcalage des jours vides de la premire semaine du mois
    for jj:=1 to kk-1 do begin
      astrS[jj]:=astrS[jj] + '  ';
      end;

    // boucle sur un mois
    while (nMonth = nMonthLast) do begin
      if (nDay <= kk) then astrS[kk]:=astrS[kk] + intToStr(nDay, 1) // cas particulier du dbut de mois
      else if (nDay <= 9) then astrS[kk]:=astrS[kk] + '    ' + intToStr(nDay, 1)
      else                     astrS[kk]:=astrS[kk] + '  '   + intToStr(nDay, 2);

      // rcuple le prochain jour
      NextDay(nDay, nMonth, nYear);
      inc(kk);
      if ( kk > 7) then kk:=1;
      end; // while
    // fin du mois

    if (nMonth = 7) then begin
      astrS[1]:=astrS[1] + 'Lu';
      astrS[2]:=astrS[2] + 'Ma';
      astrS[3]:=astrS[3] + 'Me';
      astrS[4]:=astrS[4] + 'Je';
      astrS[5]:=astrS[5] + 'Ve';
      astrS[6]:=astrS[6] + 'Sa';
      astrS[7]:=astrS[7] + 'Di';
      for jj:=1 to 7 do WriteWin(1, astrS[jj]);

      WriteWin(1, ''); // saut de ligne entre les 6 premiers et les 6 derniers mois
      WriteWin(1, 'JASOND');

      astrS[1]:='xxLu';
      astrS[2]:=strYear + 'Ma';
      astrS[3]:=intToStr(((nYear + 28) mod 100),2) + 'Me';
      astrS[4]:=intToStr(((nYear + 56) mod 100),2) + 'Je';
      if ((nYear mod 100) < 16) then  astrS[5]:=intToStr(((nYear + 84) mod 100),2) + 'Ve'
      else                  astrS[5]:='Ve';
      astrS[6]:='Sa';
      astrS[7]:='Di';

      // Cas particuliers des dbuts de sicles, non bissextiles, identique aux annes ..06.
      if ( ((nYear mod 100) = 6) and ((nYear mod 400) <> 0) ) then astrS[7]:='00Di';

      end
    else if (nMonth <= 12) then for jj:=1 to 7 do astrS[jj]:=astrS[jj] + '|';

    until (nMonth > 12); // anne termine
  // L'anne est termine

  astrS[1]:=astrS[1] + 'Lu';
  astrS[2]:=astrS[2] + 'Ma';
  astrS[3]:=astrS[3] + 'Me';
  astrS[4]:=astrS[4] + 'Je';
  astrS[5]:=astrS[5] + 'Ve';
  astrS[6]:=astrS[6] + 'Sa';
  astrS[7]:=astrS[7] + 'Di';
  for jj:=1 to 7 do WriteWin(1, astrS[jj]);
  
  WriteWin(1, '-----');
  WriteWin(1, ''); // saut de ligne eaprs les 6 derniers mois
  
  inc(nYear);
  until ((nYear mod 100) = 28);
end;  // TMyWindow.Test1

procedure TMyWindow.Test2;
//========================
begin
end;  // TMyWindow.Test2

procedure TMyWindow.Test3;
//========================
begin
end;  // TMyWindow.Test3

procedure TMyWindow.Test4;
//========================
begin
end;  // TMyWindow.Test4

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// Handles the menu messages
Var wNrMenu     : word;
begin
WMCommand := 0; // Default return value when processing a message

if (lPar <> 0) then begin
   // call the parent WMCommand method.
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;

// for the menus,  lPar = 0
//=========================
wNrMenu   := LoWord(wPar);
Case wNrMenu Of
   101 : Test1;
   102 : Test2;
   103 : Test3;
   104 : Test4;

   else WMCommand:=inherited WMCommand(wPar, lPar);
   end;  // Case NrMenu Of
end;  // TMyWindow.WMCommand

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//======================================================================================
begin
// Default treatment of a message. Does nearly nothing
WindowProc := inherited WindowProc(hWindow, wMsg, wPar, lPar);
end;  // TMyWindow.WindowProc

Begin // MAIN ******
// Name under which the main window is registered. Spaces are not allowed
oApp.Init('tEx081_Calendrier_Perpetuel');

// Creation of the main window
new(poMyMainWin, Init('tEx081_Calendrier_Perpetuel'));

oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.

