{ Developpement of a graphic windows for plotting graphics.
  --------------------------------------------}
program tEx088_Graphics;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses
  wGraphic0
 ,wAutoAxes0
 ,wApplication0
 ,wWindow0
 ,wDialog0
 ,wWindowBase0
 ,wDialogCreatorLow2
 ,wDialogCreator2
 ,wVariableNumLink2
// ,wUtiles0 // for the AccelTableMSGCreate function
 ,wGlobals2
 ,wParamApplic2
 ,wMessages2
 ,wDebug0
 ,Windows
 ,commDlg;   { !!!  AJOUTER A LA VERSION 2.40 de Freeplascal, sinon problme !!! }

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""

  constructor Init(strWinTitlePrm:ShortString);
  destructor Done; virtual;

  procedure Test01;

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages
  end; // TMyWindow = object(TWindow)

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

// var nNotUsed : integer; // only to avoid an error message while compliling in DevPascal 1.9

//**********************************************************************
//********  OBJECT TMyWindow = object(TWindow)
//**********************************************************************

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);
//dwStyle := dwStyle or WS_VScroll; // to have a vertical scroll bar

new(poStatusLine, Init(@Self));
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//========================
//var nn : integer;
begin

dispose(poStatusLine, Done);

inherited Done;
end;  // TMyWindow.Done

procedure TMyWindow.Test01;
//=========================
var
  nErr,
  nn  : integer;
  pWinGr : PGAPWindow;
  pGr : PGAPGraphic;
  pCu : PGAPCurve;

begin
CreateNewGrWindow(
  pWinGr,
  pGr,
  pCu,
  1000, //indMaxAbs    { indice maximale possible de la courbe }
  0,    //    colLineCu0   { Couleur de la courbe, si il y en a une }  : TColorRef;
  'A first Test', //    strTitle0,   { Titre du graphique }
  'X Legend', //    strXLegend0, { lgende de l'axe X }
  'Y Legend', //    strYLegend0  { lgende de l'axe Y }
  nErr);
{ Cration d'une nouvelle fentre, avec un graphique pGr et une courbe pCu,
  dimensionne [0..nIndMaxAbs].
  nErr = 0 si tout est OK.
  nErr <> 0 sinon, avec message explicatif
-------------------------------------------------------------------------}

if (nErr <> 0) then DBW(1, 'Error=' + ITS(nErr));

pGr^.fDrawGrid:=true; // to see a grid
//pGr^.pGrBase^.mmY2Height:=pGr^.pGrBase^.mmY2Height - 9; Si on veut changer la partie texte

pGr^.pAxes^.vYMinLimitIncrease:=0.10; // Pour agrandir de 10% la fentre graphique
pGr^.pAxes^.vYMaxLimitIncrease:=0.10; // Pour agrandir de 10% la fentre graphique
pGr^.pAxes^.vXMinLimitIncrease:=0.05; // Pour agrandir la fentre graphique
pGr^.pAxes^.vXMinLimitIncrease:=0.05; // Pour agrandir la fentre graphique
pGr^.lAxesFlags:=pGr^.lAxesFlags or flaAxesNotSmallY or flaAxesNotSmallX; // Pour agrandir la fentre graphique

// Fill the curves with data
pCu^.nIndMax:=500;
  for nn:=0 to pCu^.nIndMax do begin
    pCu^.pXD^[nn]:=nn*0.1;
    pCu^.pYD^[nn]:=sin(pCu^.pXD^[nn]);
    end;

pCu^.InitForDraw(pCu^.nIndMax);

// Le mme pointeur de courbe peut tre rutilis, car il ne sert plus  rien ici
pCu:=pGr^.AddNewCurve(1000, 0);

// Fill the second curves with data
pCu^.nIndMax:=200;
  for nn:=0 to pCu^.nIndMax do begin
    pCu^.pXD^[nn]:=nn*0.2;
    pCu^.pYD^[nn]:=cos(pCu^.pXD^[nn]);
    end;

pCu^.colLineCu:=RGB(255,0,0);
pCu^.InitForDraw(pCu^.nIndMax);
end; // TMyWindow.Test01

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// Handles the menu messages
Var
  wNrMenu     : word;

begin
WMCommand := 0; // Default return value when processing a message

if (lPar <> 0) then begin
   // call the parent WMCommand method.
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;

// for the menus,  lPar = 0
//=========================
wNrMenu   := LoWord(wPar);
Case wNrMenu Of

   101 : Test01;

   // Parameters
   301 : begin
         DialogExecMSG(30199, @Self);
         end;

   // A help information
   901 : DialogExecMSG(90199, @Self);

   else WMCommand:=inherited WMCommand(wPar, lPar);
   end;  // Case NrMenu Of
end;  // TMyWindow.WMCommand

Begin // MAIN ******
// to use the application parameters defined here.
//new(poMyAppPrm, Init);
//gglpoPrm:=poMyAppPrm; // it will be destroyed in the TApplication automatically

// Name under which the main window is registered. Spaces are not allowed
oApp.Init('tEx088_Graphics');

// Creation of the main window
new(poMyMainWin, Init('tEx088_Graphics'));

// The App.WindowClass can be modified here, if wanted. (Not usual)
oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.
